#include <iostream>
#include <cmath>

using namespace std;

using ll = long long;
using ld = long double;

struct Vector {
    ld x, y;
    ld operator ^ (const Vector& other) const {
        return x * other.y - y * other.x;
    }
    Vector operator - (const Vector& other) const {
        return {x - other.x, y - other.y};
    }
    static ld dist(const Vector& a, const Vector& b) {
        return sqrt((b.x - a.x) * (b.x - a.x) + (b.y - a.y) * (b.y - a.y));
    }
    ld distL(const Vector& a, const Vector& b) const {
        return abs((a - *this) ^ (b - *this)) / dist(a, b);
    }
};


istream& operator >> (istream &in, Vector &a) {
    in >> a.x >> a.y;
    return in;
}

int main()
{
    Vector a, b, c;
    cin >> a >> b >> c;
    ld x, y, z;
    x = a.distL(b, c);
    y = b.distL(a, c);
    z = c.distL(a, b);

    if (x <= y && x <= z) {
        cout << b.x << " " << b.y << " " << c.x << " " << c.y;
    } else {
        if (y <= x && y <= z) {
            cout << a.x << " " << a.y << " " << c.x << " " << c.y;
        } else {
            if (z <= y && z <= x) {
                cout << a.x << " " << a.y << " " << b.x << " " << b.y;
            }
        }
    }
    return 0;
}
