def find_best_line(points):
    def distance(x1, y1, x2, y2, x, y):
        """Рассчитать расстояние от точки (x, y) до прямой через (x1, y1) и (x2, y2)."""
        return abs((y2 - y1) * x - (x2 - x1) * y + x2 * y1 - y2 * x1) / ((y2 - y1) ** 2 + (x2 - x1) ** 2) ** 0.5

    x1, y1, x2, y2, x3, y3 = points
    candidates = [
        ((x1, y1), (x2, y2), (x3, y3)),
        ((x1, y1), (x3, y3), (x2, y2)),
        ((x2, y2), (x3, y3), (x1, y1)),
    ]
    
    min_distance = float('inf')
    best_line = None

    for (x1, y1), (x2, y2), (x, y) in candidates:
        dist = distance(x1, y1, x2, y2, x, y)
        if dist < min_distance:
            min_distance = dist
            best_line = (x1, y1, x2, y2)
    
    return best_line

# Пример ввода
input_data = list(map(int, input().split()))
result = find_best_line(input_data)

# Вывод результата
print(result[0], result[1], result[2], result[3])
