def magical_spell(t, test_cases):
    results = []
    for case in test_cases:
        n, m, k = case['n'], case['m'], case['k']
        p = case['p']
        a = case['a']
        segments = case['segments']
        
        # Маппинг рун на индексы
        rune_positions = {rune: [] for rune in range(1, n + 1)}
        for idx, rune in enumerate(a):
            rune_positions[rune].append(idx + 1)  # Индексы 1-индексация
        
        # Проверяем, есть ли все руны из p в a
        for rune in p:
            if not rune_positions[rune]:
                results.append(-1)
                break
        else:
            # Найти минимальное количество отрезков
            required_positions = set()
            for rune in p:
                required_positions.update(rune_positions[rune])
            
            required_positions = sorted(required_positions)
            
            # Двухуказательный подход для минимального покрытия
            min_segments = []
            i, j = 0, 0
            current_cover = set()
            while j < len(segments):
                li, ri = segments[j]
                if li <= required_positions[i] <= ri:
                    current_cover.add(j + 1)
                    i += 1
                    if i >= len(required_positions):
                        break
                j += 1
            
            if i < len(required_positions):
                results.append(-1)
            else:
                results.append(len(current_cover))
                results.append(sorted(current_cover))
    return results

# Пример вызова
t = 1
test_cases = [
    {
        'n': 4, 'm': 6, 'k': 3,
        'p': [1, 3, 2, 4],
        'a': [2, 1, 3, 1, 2, 4],
        'segments': [(5, 6), (2, 6), (1, 3)]
    }
]

results = magical_spell(t, test_cases)
for result in results:
    print(result)
