def swap_one_card(card):
    return card[1], card[0]
    
def merge_sort(cards):
    if len(cards) > 1:
        mid = len(cards) // 2
        L = cards[:mid]
        R = cards[mid:]
        merge_sort(L)
        merge_sort(R)
        i = j = k = 0
        while i < len(L) and j < len(R):
            if L[i][0] < R[j][0]:
                cards[k] = L[i]
                i += 1
            else:
                cards[k] = R[j]
                j += 1
            k += 1
        while i < len(L):
            cards[k] = L[i]
            i += 1
            k += 1
        while j < len(R):
            cards[k] = R[j]
            j += 1
            k += 1

def solve():
    n = int(input())
    a = [int(x) for x in input().split()]
    b = [int(x) for x in input().split()]
    cards = []
    for i in range(n):
        cards.append((a[i], b[i]))
        
        if cards[i][1] < cards[i][0]:
            cards[i] = swap_one_card(cards[i])
    
    merge_sort(cards)   
    for i in range(n-1):
        if cards[i][0] > cards[i+1][0] or cards[i][1] > cards[i+1][1]:
            print(-1)
            return
    for i in range(n):
        print(cards[i][0], end=" ")
    print()
    for i in range(n):
        print(cards[i][1], end=" ")
    
solve()