def galactic_timeline(n, a, b):
    # Последние минимальные значения для лицевой и обратной сторон
    prev_a, prev_b = -1, -1
    
    # Результат: изначально пустые списки
    res_a, res_b = [], []
    
    for i in range(n):
        # Текущие годы для лицевой и обратной сторон
        face = a[i]
        back = b[i]
        
        # Проверяем все комбинации
        if face >= prev_a and back >= prev_b:
            # Лицо остаётся лицом
            res_a.append(face)
            res_b.append(back)
            prev_a, prev_b = face, back
        elif back >= prev_a and face >= prev_b:
            # Переворачиваем карту
            res_a.append(back)
            res_b.append(face)
            prev_a, prev_b = back, face
        else:
            # Если обе комбинации недопустимы, цель недостижима
            return -1
    
    # Если все карты обработаны успешно, возвращаем результат
    return res_a, res_b

# Ввод данных
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

result = galactic_timeline(n, a, b)

# Вывод результата
if result == -1:
    print(-1)
else:
    print(*result[0])
    print(*result[1])
