n, q = map(int, input().split())
edges = {}
color_degree = {i: {} for i in range(1, 100001)}  # Tracks how many edges each vertex has for each color
color_perfect = {}  # Tracks whether the color is still "perfect"
answers = []
beauty = 0

for _ in range(q):
    operation, a, b, c = input().split()
    a, b, c = int(a), int(b), int(c)

    edge = f"{min(a, b)}-{max(a, b)}"
    perfect = True

    if edge not in edges:
        edges[edge] = []

    # Update the edge with color
    if operation == '+':
        edges[edge].append(c)
        color_degree[c][a] = color_degree[c].get(a, 0) + 1
        color_degree[c][b] = color_degree[c].get(b, 0) + 1
        
        # Check if color becomes imperfect for a vertex
        if color_degree[c][a] > 1 or color_degree[c][b] > 1:
            if c not in color_perfect or color_perfect[c]:
                color_perfect[c] = False
                beauty -= edges[edge].count(c)  # Remove previous beauty contribution
    else:  # operation == '-'
        edges[edge].remove(c)
        color_degree[c][a] -= 1
        color_degree[c][b] -= 1

        if color_degree[c][a] <= 1 and color_degree[c][b] <= 1:
            if c not in color_perfect or color_perfect[c] == False:
                color_perfect[c] = True
                beauty += edges[edge].count(c)  # Add new beauty contribution
    
    # Track the current beauty of all "perfect" colors
    answers.append(beauty)

# Print all answers for each query
print("\n".join(map(str, answers)))
