from collections import defaultdict

n, q = map(int, input().split())

vertex_color_count = [defaultdict(int) for _ in range(n)]
color_edge_count = defaultdict(int)
edges = set()

answers = []

for _ in range(q):
    operation, v, u, c = input().split()
    v, u, c = int(v) - 1, int(u) - 1, int(c)

    edge = tuple(sorted([v, u, c]))

    if operation == '+':
        vertex_color_count[v][c] += 1
        vertex_color_count[u][c] += 1
        color_edge_count[c] += 1
        edges.add(edge)

    elif operation == '-':
        vertex_color_count[v][c] -= 1
        vertex_color_count[u][c] -= 1
        color_edge_count[c] -= 1
        edges.remove(edge)

    total_beauty = 0
    for color in color_edge_count:
        excellent = True
        for vertex in range(n):
            if vertex_color_count[vertex][color] > 1:
                excellent = False
                break
        
        if excellent:
            total_beauty += color_edge_count[color]

    answers.append(str(total_beauty))

print("\n".join(answers))
