#include <iostream>
#include <vector>
#include <unordered_map>
#include <set>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    vector<unordered_map<int, int>> vertex_color_count(n);
    unordered_map<int, int> color_edge_count;
    set<tuple<int, int, int>> edges;

    vector<int> answers;

    for (int i = 0; i < q; ++i) {
        char operation;
        int v, u, c;
        cin >> operation >> v >> u >> c;
        --v; --u;
        tuple<int, int, int> edge = make_tuple(min(v, u), max(v, u), c);

        if (operation == '+') {
            vertex_color_count[v][c]++;
            vertex_color_count[u][c]++;
            color_edge_count[c]++;
            edges.insert(edge);
        } else if (operation == '-') {
            vertex_color_count[v][c]--;
            vertex_color_count[u][c]--;
            color_edge_count[c]--;
            edges.erase(edge);
        }

        int total_beauty = 0;
        for (const auto& color_pair : color_edge_count) {
            int color = color_pair.first;
            bool excellent = true;
            
            for (int vertex = 0; vertex < n; ++vertex) {
                if (vertex_color_count[vertex][color] > 1) {
                    excellent = false;
                    break;
                }
            }
            
            if (excellent) {
                total_beauty += color_edge_count[color];
            }
        }

        answers.push_back(total_beauty);
    }

    for (int ans : answers) {
        cout << ans << endl;
    }

    return 0;
}
