#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;

    unordered_map<pair<int, int>, int, hash<pair<int, int>>> edges;
    unordered_map<int, unordered_map<int, int>> color_count;
    int total_beauty = 0;

    for (int i = 0; i < q; ++i) {
        char operation;
        int v, u, c;
        cin >> operation >> v >> u >> c;

        if (v > u) swap(v, u);

        pair<int, int> edge_key = {v, u};

        if (operation == '+') {
            if (edges.find(edge_key) == edges.end()) {
                edges[edge_key] = c;

                if (color_count[c].find(v) == color_count[c].end()) {
                    color_count[c][v] = 0;
                }
                if (color_count[c].find(u) == color_count[c].end()) {
                    color_count[c][u] = 0;
                }

                color_count[c][v]++;
                color_count[c][u]++;

                if (color_count[c][v] == 1 && color_count[c][u] == 1) {
                    total_beauty++;
                }
            }
        } else if (operation == '-') {
            if (edges.find(edge_key) != edges.end() && edges[edge_key] == c) {
                edges.erase(edge_key);

                color_count[c][v]--;
                color_count[c][u]--;

                if (color_count[c][v] == 0 || color_count[c][u] == 0) {
                    total_beauty--;
                }
            }
        }

        cout << total_beauty << endl;
    }

    return 0;
}