#include <iostream>
#include <unordered_map>
#include <vector>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    
    unordered_map<int, unordered_map<int, int>> degree;
    unordered_map<int, int> edge_count;
    vector<int> answers;
    
    auto is_excellent = [&](int color) -> bool {
        for (int vertex = 0; vertex < n; ++vertex) {
            if (degree[color].count(vertex) && degree[color][vertex] > 1) {
                return false;
            }
        }
        return true;
    };
    
    for (int i = 0; i < q; ++i) {
        char operation;
        int a, b, c;
        cin >> operation >> a >> b >> c;
        a--; b--; 
        
        if (degree.find(c) == degree.end()) {
            degree[c] = unordered_map<int, int>();
            edge_count[c] = 0;
        }
        
        if (operation == '+') {
            degree[c][a] += 1;
            degree[c][b] += 1;
            edge_count[c] += 1;
        } else {
            degree[c][a] -= 1;
            degree[c][b] -= 1;
            edge_count[c] -= 1;
        }
        
        int excellent_color_count = 0;
        for (const auto& pair : edge_count) {
            int color = pair.first;
            if (is_excellent(color)) {
                excellent_color_count += pair.second;
            }
        }
        
        answers.push_back(excellent_color_count);
    }
    
    for (int ans : answers) {
        cout << ans << endl;
    }
    
    return 0;
}
