def galactic_timeline(n, a, b):
    cards = list(zip(a, b))

    cards.sort(key=lambda x: min(x[0], x[1]))

    top_sequence = []
    bottom_sequence = []

    last_top = -float('inf')
    last_bottom = -float('inf')

    for front, back in cards:
        if front >= last_top and back >= last_bottom:
            top_sequence.append(front)
            bottom_sequence.append(back)
            last_top = front
            last_bottom = back
        elif back >= last_top and front >= last_bottom:
            top_sequence.append(back)
            bottom_sequence.append(front)
            last_top = back
            last_bottom = front
        else:
            print(-1)
            return

    print(" ".join(map(str, top_sequence)))
    print(" ".join(map(str, bottom_sequence)))


n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))
galactic_timeline(n, a, b)
