from collections import Counter


def solve():
    n, m, s = map(int, input().split())

    if s == n * m:
        print(0)
        return

    ans = float('inf')

    for x in range(n):
        for y in range(m):
            cuts = x + y
            if cuts >= ans:
                continue

            possible_sums = Counter()
            for i in range(x + 1):
                for j in range(y + 1):
                    area = (n // (x + 1) + (i < n % (x + 1))) * (m // (y + 1) + (j < m % (y + 1)))
                    possible_sums[area] += 1

            dp = [False] * (s + 1)
            dp[0] = True
            for area, count in possible_sums.items():
                for _ in range(count):
                    for j in range(s, area - 1, -1):
                        dp[j] |= dp[j - area]

            if dp[s]:
                ans = min(ans, cuts)

    # Only horizontal cuts
    for y in range(1, m):
        cuts = y
        if cuts >= ans:
            continue
        possible_sums = Counter()
        for j in range(y + 1):
            area = n * (m // (y + 1) + (j < m % (y + 1)))
            possible_sums[area] += 1

        dp = [False] * (s + 1)
        dp[0] = True
        for area, count in possible_sums.items():
            for _ in range(count):
                for j in range(s, area - 1, -1):
                    dp[j] |= dp[j - area]

        if dp[s]:
            ans = min(ans, cuts)

    # Only vertical cuts
    for x in range(1, n):
        cuts = x
        if cuts >= ans:
            continue
        possible_sums = Counter()

        for i in range(x + 1):
            area = (n // (x + 1) + (i < n % (x + 1))) * m
            possible_sums[area] += 1

        dp = [False] * (s + 1)
        dp[0] = True
        for area, count in possible_sums.items():
            for _ in range(count):
                for j in range(s, area - 1, -1):
                    dp[j] |= dp[j - area]
        if dp[s]:
            ans = min(ans, cuts)

    print(ans)


solve()