#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<pair<int, int>> cards(n);
    for (int i = 0; i < n; ++i) cin >> cards[i].first;
    for (int i = 0; i < n; ++i) cin >> cards[i].second;

    sort(cards.begin(), cards.end(), [](pair<int, int> &x, pair<int, int> &y) {
        return min(x.first, x.second) < min(y.first, y.second);
    });

    vector<int> front, back;
    int lastFront = 0, lastBack = 0;

    for (const auto &card : cards) {
        int a = card.first, b = card.second;
        if (a >= lastFront && b >= lastBack) {
            front.push_back(a);
            back.push_back(b);
            lastFront = a;
            lastBack = b;
        } else if (b >= lastFront && a >= lastBack) {
            front.push_back(b);
            back.push_back(a);
            lastFront = b;
            lastBack = a;
        } else {
            cout << -1 << endl;
            return 0;
        }
    }

    for (int x : front) cout << x << " ";
    cout << endl;
    for (int x : back) cout << x << " ";
    cout << endl;

    return 0;
}