#include <bits/stdc++.h>
using namespace std;

struct Card {
    int face, back;
    int original_index;
};

bool compare_cards(const Card& a, const Card& b) {
    return min(a.face, a.back) < min(b.face, b.back);
}

int main() {
    int n;
    cin >> n;

    vector<Card> cards(n);
    for (int i = 0; i < n; i++) {
        cin >> cards[i].face;
        cards[i].original_index = i;
    }
    for (int i = 0; i < n; i++) {
        cin >> cards[i].back;
    }

    // Sort cards based on the minimum of face and back
    sort(cards.begin(), cards.end(), compare_cards);

    vector<int> face_order(n), back_order(n);
    int face_max = 0, back_max = 0;
    bool possible = true;

    for (int i = 0; i < n; i++) {
        if (cards[i].face >= face_max && cards[i].back >= back_max) {
            face_order[i] = cards[i].face;
            back_order[i] = cards[i].back;
            face_max = cards[i].face;
            back_max = cards[i].back;
        } else if (cards[i].back >= face_max && cards[i].face >= back_max) {
            face_order[i] = cards[i].back;
            back_order[i] = cards[i].face;
            face_max = cards[i].back;
            back_max = cards[i].face;
        } else {
            possible = false;
            break;
        }
    }

    if (!possible) {
        cout << -1 << endl;
    } else {
        for (int i = 0; i < n; i++) {
            cout << face_order[i] << " ";
        }
        cout << endl;
        for (int i = 0; i < n; i++) {
            cout << back_order[i] << " ";
        }
        cout << endl;
    }

    return 0;
}