#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

using namespace std;

struct Card {
    int index;
    long long ai;
    long long bi;
    long long ci;
    long long di; 
    bool flip_ai_bi;
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<Card> cards(n);
    for (int i = 0; i < n; ++i) {
        cin >> cards[i].ai;
    }
    for (int i = 0; i < n; ++i) {
        cin >> cards[i].bi;
    }
    for (int i = 0; i < n; ++i) {
        cards[i].index = i;
        if (cards[i].ai <= cards[i].bi) {
            cards[i].ci = cards[i].ai;
            cards[i].di = cards[i].bi;
            cards[i].flip_ai_bi = false;
        } else {
            cards[i].ci = cards[i].bi;
            cards[i].di = cards[i].ai;
            cards[i].flip_ai_bi = true;
        }
    }
    sort(cards.begin(), cards.end(), [](const Card& a, const Card& b) {
        return a.ci < b.ci;
    });

    long long prev_ci = -1e18, prev_di = -1e18;
    vector<bool> flip_flags(n);

    for (int i = 0; i < n; ++i) {
        bool possible = false;
        long long ci_candidate = cards[i].ai;
        long long di_candidate = cards[i].bi;
        if (ci_candidate >= prev_ci && di_candidate >= prev_di) {
            prev_ci = ci_candidate;
            prev_di = di_candidate;
            flip_flags[i] = false;
            possible = true;
        } else {
            ci_candidate = cards[i].bi;
            di_candidate = cards[i].ai;
            if (ci_candidate >= prev_ci && di_candidate >= prev_di) {
                prev_ci = ci_candidate;
                prev_di = di_candidate;
                flip_flags[i] = true;
                possible = true;
            }
        }
        if (!possible) {
            cout << "-1" << endl;
            return 0;
        }
    }

    cout << fixed << setprecision(0);
    for (int i = 0; i < n; ++i) {
        if (i > 0) cout << " ";
        if (!flip_flags[i]) {
            cout << cards[i].ai;
        } else {
            cout << cards[i].bi;
        }
    }
    cout << endl;
    for (int i = 0; i < n; ++i) {
        if (i > 0) cout << " ";
        if (!flip_flags[i]) {
            cout << cards[i].bi;
        } else {
            cout << cards[i].ai;
        }
    }
    cout << endl;

    return 0;
}
