from collections import defaultdict
n, q = map(int, input().split())
edges = defaultdict(set)
degree = defaultdict(lambda: defaultdict(int))
beauty = defaultdict(int)  
total_beauty = 0

def update_beauty(c):
    global total_beauty
    if all(degree[v][c] <= 1 for v in range(1, n+1)):
        new_beauty = len(edges[c])
        total_beauty += new_beauty - beauty[c]
        beauty[c] = new_beauty
    else:
        total_beauty -= beauty[c]
        beauty[c] = 0

answers = []

for _ in range(q):
    query = input().split()
    if query[0] == '+':
        v, u, c = map(int, query[1:])
        if (v, u) not in edges[c]:
            edges[c].add((v, u))
            edges[c].add((u, v))
            degree[v][c] += 1
            degree[u][c] += 1
            update_beauty(c)
    elif query[0] == '-':
        v, u, c = map(int, query[1:])
        if (v, u) in edges[c]:
            edges[c].remove((v, u))
            edges[c].remove((u, v))
            degree[v][c] -= 1
            degree[u][c] -= 1
            update_beauty(c) 
    answers.append(int(total_beauty/2))

print("\n".join(map(str, answers)))
