#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

int min_cuts_grid(int n, int m, int s) {
    // Iterate over all possible numbers of vertical and horizontal cuts
    for (int total_cuts = 0; total_cuts <= n + m; ++total_cuts) {
        for (int x = 0; x <= total_cuts; ++x) { // Vertical cuts
            int y = total_cuts - x; // Horizontal cuts
            if (x >= m || y >= n)
                continue; // Skip invalid cuts

            // Calculate slices in each dimension
            vector<int> widths(x + 1, m / (x + 1));
            for (int i = 0; i < m % (x + 1); ++i)
                widths[i]++;

            vector<int> heights(y + 1, n / (y + 1));
            for (int i = 0; i < n % (y + 1); ++i)
                heights[i]++;

            vector<int> areas;
            for (int width : widths) {
                for (int height : heights) {
                    areas.push_back(width * height);
                }
            }

            set<int> possible_sums = {0};
            for (int area : areas) {
                set<int> new_sums;
                for (int current_sum : possible_sums) {
                    if (current_sum + area <= s) {
                        new_sums.insert(current_sum + area);
                    }
                }
                possible_sums.insert(new_sums.begin(), new_sums.end());
            }

            if (possible_sums.find(s) != possible_sums.end()) {
                return total_cuts;
            }
        }
    }

    return -1; 
}

int main() {
    // Input
    int n, m, s;
    cin >> n >> m >> s;

    // Calculate and output result
    int result = min_cuts_grid(n, m, s);
    cout << result << endl;

    return 0;
}
 