#include <iostream>
#include <cstddef>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>

int main() {
    std::ios::sync_with_stdio(false);
    std::size_t n;
    int m, c;
    std::cin >> n >> m >> c;
    
    std::vector<double> x(n + 2);
    std::vector<int> t(n + 2);

    for (std::size_t i = 1; i < n + 1; ++i) {
        std::cin >> x[i] >> t[i];
    } x[n + 1] = m;

    std::vector<std::map<std::size_t, double>> graph(n + 2);
    for (std::size_t i = 0; i < n + 2; ++i) {
        for (std::size_t j = i + 1; j < n + 2; ++j) {
            graph[i][j] = (x[j] - x[i]) * (x[j] - x[i]) / c + t[j];
        }
    }

    std::vector<double> answer(n + 2);
    std::queue<std::size_t> q;
    q.push(0);
    while (!q.empty()) {
        std::size_t i = q.front();
        q.pop();
        for (std::map<std::size_t, double>::const_iterator j = graph[i].cbegin(); j != graph[i].cend(); ++j) {
            if (answer[j->first] > answer[i] + j->second || answer[j->first] == 0.) {
                answer[j->first] = answer[i] + j->second;
                q.push(j->first);
            }
        }
    }

    std::cout << std::fixed << std::setprecision(6) << answer[n + 1];

    return 0;
}
