
import heapq

def min_travel_time(n, m, c, stations):
    stations.append((m, 0))  
    stations.sort()  
    
    current_fuel = c
    current_pos = 0
    total_time = 0
    fuel_queue = []

    for next_pos, refill_time in stations:
        distance = next_pos - current_pos
        
   
        current_fuel -= distance
        
        
        while current_fuel < 0 and fuel_queue:
            current_fuel += c
            total_time += -heapq.heappop(fuel_queue)

       
        if current_fuel < 0:
            return -1

        
        total_time += distance / c

     
        heapq.heappush(fuel_queue, -refill_time)
        
      
        current_pos = next_pos

    return total_time



n, m, c = 4, 100, 25
stations = [(10, 50), (15, 30), (50, 100), (80, 60)]
print(f"{min_travel_time(n, m, c, stations):.6f}")
