
from collections import defaultdict

def process_queries(n, q, queries):
    edges = defaultdict(set)  # edges[c] - множество рёбер цвета c
    vertex_degree = defaultdict(lambda: defaultdict(int))  # vertex_degree[c][v] - количество рёбер цвета c в вершине v
    color_beauty = defaultdict(int)  # color_beauty[c] - красота (количество рёбер) цвета c
    total_beauty = 0  # общая красота всех превосходных цветов

    def update_beauty(c):
        nonlocal total_beauty
        beauty = 0
        for u, v in edges[c]:
            if vertex_degree[c][u] == 1 and vertex_degree[c][v] == 1:
                beauty += 1
        color_beauty[c] = beauty
        if beauty == 0:
            if c in color_beauty:
                total_beauty -= color_beauty[c]
        else:
            total_beauty += beauty
    
    result = []
    for query in queries:
        t, v, u, c = query
        if t == 1:
            if (v, u) not in edges[c]:
                edges[c].add((v, u))
                vertex_degree[c][v] += 1
                vertex_degree[c][u] += 1
                update_beauty(c)
        elif t == 2:
            if (v, u) in edges[c]:
                edges[c].remove((v, u))
                vertex_degree[c][v] -= 1
                vertex_degree[c][u] -= 1
                update_beauty(c)
        
        result.append(total_beauty)
    
    return result


n = 4
q = 5
queries = [
    (1, 1, 2, 1),
    (1, 2, 3, 1),
    (1, 3, 4, 1),
    (2, 1, 2, 1),
    (1, 1, 3, 2),
]

result = process_queries(n, q, queries)
for res in result:
    print(res)

