from itertools import combinations

def main():
    n, m, s = map(int, input().strip().split())

    if s == n * m:
        print(0)
        return

    max_cuts = n + m - 2
    def generate_pieces(length, cuts):
        positions = [0] + sorted(cuts) + [length]
        return [positions[i+1] - positions[i] for i in range(len(positions) - 1)]

    for total_cuts in range(1, max_cuts + 1):
        for x_cuts in range(max(0, total_cuts - (n - 1)), min(total_cuts, m - 1) + 1):
            y_cuts = total_cuts - x_cuts
            if y_cuts > n - 1:
                continue

            vertical_positions = [i for i in range(1, m)]
            horizontal_positions = [i for i in range(1, n)]

            vertical_cuts_list = list(combinations(vertical_positions, x_cuts)) if x_cuts > 0 else [()]
            horizontal_cuts_list = list(combinations(horizontal_positions, y_cuts)) if y_cuts > 0 else [()]

            for v_cuts in vertical_cuts_list:
                widths = generate_pieces(m, v_cuts)
                for h_cuts in horizontal_cuts_list:
                    heights = generate_pieces(n, h_cuts)

                    areas = [w * h for w in widths for h in heights]

                    dp = {0}
                    for area in areas:
                        new_dp = dp.copy()
                        for existing_sum in dp:
                            new_sum = existing_sum + area
                            if new_sum == s:
                                print(total_cuts)
                                return
                            if new_sum <= s:
                                new_dp.add(new_sum)
                        dp = new_dp

    print(max_cuts)

if __name__ == "__main__":
    main()
