import sys
import threading
from collections import defaultdict

def main():
    import sys
    sys.setrecursionlimit(1 << 25)
    input = sys.stdin.readline

    n, q = map(int, sys.stdin.readline().split())

    total_beauty = 0

    total_edges = dict()
    degrees = dict()
    degrees_over_one = dict()
    is_excellent = dict()

    for _ in range(q):
        query = sys.stdin.readline().strip()
        if not query:
            query = sys.stdin.readline().strip()
        tokens = query.split()
        op = tokens[0]
        v = int(tokens[1])
        u = int(tokens[2])
        c = int(tokens[3])

        if c not in total_edges:
            total_edges[c] = 0
            degrees[c] = defaultdict(int)
            degrees_over_one[c] = set()
            is_excellent[c] = True

        if op == '+':
            total_edges[c] += 1
            for x in [v, u]:
                degrees[c][x] += 1
                if degrees[c][x] == 2:
                    degrees_over_one[c].add(x)

            if is_excellent[c]:
                if degrees_over_one[c]:
                    total_beauty -= total_edges[c] - 1
                    is_excellent[c] = False
                else:
                    total_beauty += 1
        elif op == '-':
            total_edges[c] -= 1
            for x in [v, u]:
                degrees[c][x] -= 1
                if degrees[c][x] == 1:
                    degrees_over_one[c].discard(x)
                elif degrees[c][x] == 0:
                    del degrees[c][x]

            if not is_excellent[c]:
                if not degrees_over_one[c]:
                    is_excellent[c] = True
                    total_beauty += total_edges[c]
            else:
                total_beauty -= 1
        else:
            continue

        print(int(total_beauty))

threading.Thread(target=main).start()
