#include <iostream>
#include <cmath>
#include <climits>
using namespace std;

// Функция для вычисления минимального числа разрезов
int min_cuts(int n, int m, int s) {
    // Если площадь s равна площади исходного листа, разрезы не нужны
    if (s == n * m) {
        return 0;
    }

    int minCuts = INT_MAX;

    // Перебираем все делители s
    for (int a = 1; a <= sqrt(s); ++a) {
        if (s % a == 0) {
            int b = s / a;

            // Проверяем первый вариант: a на вертикали, b на горизонтали
            if (a <= n && b <= m) {
                minCuts = min(minCuts, (a - 1) + (b - 1));
            }
            // Проверяем второй вариант: b на вертикали, a на горизонтали
            if (b <= n && a <= m) {
                minCuts = min(minCuts, (b - 1) + (a - 1));
            }
        }
    }

    return minCuts == INT_MAX ? 3 : minCuts; // Если невозможно, вернем 3 (максимум разрезов)
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, s;
    cin >> n >> m >> s;

    cout << min_cuts(n, m, s) << endl;

    return 0;
}
