#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define vi vector<ll>
#define mii unordered_map<int,int>
#define umii unordered_map<int,int>
#define fast ios_base::sync_with_stdio(0); cin.tie(0);

#pragma GCC optimize("Ofast")

struct ColorInfo {
    int total_edges = 0;
    mii vertex_count;
    int over_limit_count = 0;
};

void update_excellence(ColorInfo &color_info, int vertex, bool increment) {
    if (increment) {
        if (++color_info.vertex_count[vertex] == 2) {
            color_info.over_limit_count++;
        }
    } else {
        if (--color_info.vertex_count[vertex] == 1) {
            color_info.over_limit_count--;
        } else if (color_info.vertex_count[vertex] == 0) {
            color_info.vertex_count.erase(vertex);
        }
    }
}

int main() {
    fast;
    int n, q;
    cin >> n >> q;

    unordered_map<int, ColorInfo> colors;
    int excellent_colors = 0;

    while (q--) {
        char type;
        int vertex_a, vertex_b, color_id;
        cin >> type >> vertex_a >> vertex_b >> color_id;

        ColorInfo &color_info = colors[color_id];
        bool was_excellent = (color_info.over_limit_count == 0);

        if (type == '+') {
            color_info.total_edges++;
            update_excellence(color_info, vertex_a, true);
            update_excellence(color_info, vertex_b, true);
        } else {
            if (color_info.total_edges > 0) {
                color_info.total_edges--;
                update_excellence(color_info, vertex_a, false);
                update_excellence(color_info, vertex_b, false);
            }
        }

        bool is_excellent = (color_info.over_limit_count == 0);
        if (was_excellent && !is_excellent) {
            excellent_colors--;
        } else if (!was_excellent && is_excellent) {
            excellent_colors++;
        }

        if (color_info.total_edges == 0) {
            colors.erase(color_id);
        }

        int total_beauty = 0;
        for (const auto& [color, info] : colors) {
            if (info.over_limit_count == 0) {
                total_beauty += info.total_edges;
            }
        }
        cout << total_beauty << endl;
    }

    return 0;
}