#include <iostream>
#include <cmath>
#include <vector>
#include <iomanip>

using namespace std;

const double EPS = 1e-6;

int main() {
    int x0, y0, x1, y1, n;
    cin >> x0 >> y0 >> x1 >> y1 >> n;

    vector<int> a(n);
    double tot = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        tot += a[i];
    }

    double dx = x1 - x0;
    double dy = y1 - y0;

    if (tot < hypot(dx, dy)) {
        cout << "Impossible" << endl;
        return 0;
    }

    vector<pair<double, double>> po;
    double cx = x0, cy = y0;

    po.push_back({cx, cy});

    for (int i = 0; i < n; ++i) {
        double angle = atan2(dy, dx);
        double jdist = a[i];

        cx += jdist * cos(angle);
        cy += jdist * sin(angle);

        po.push_back({cx, cy});

        dx = x1 - cx;
        dy = y1 - cy;
    }

    cout << "Possible" << endl;
    for (const auto& p : po) {
        cout << fixed << setprecision(8) << p.first << " " << p.second << endl;
    }

    return 0;
}
