n, q = map(int, input().split())

from collections import defaultdict

# Словари для отслеживания рёбер каждого цвета
color_edges = defaultdict(set)  # (v, u) для цвета c
vertex_count = defaultdict(lambda: defaultdict(int))  # vertex_count[color][vertex]
color_beauty = defaultdict(int)  # Счета красота по цветам
total_beauty = 0  # Суммарная красота

output = []

for _ in range(q):
    operation = input().strip().split()
    op_type = operation[0]
    v = int(operation[1])
    u = int(operation[2])
    c = int(operation[3])

    if op_type == '+':
        # Обрабатываем добавление рёбер
        if (v, u) not in color_edges[c]:
            color_edges[c].add((v, u))
            vertex_count[c][v] += 1
            vertex_count[c][u] += 1

            # Проверяем превосходный цвет
            if vertex_count[c][v] == 1 and vertex_count[c][u] == 1:
                color_beauty[c] += 1
                total_beauty += 1
            elif vertex_count[c][v] == 2 or vertex_count[c][u] == 2:
                color_beauty[c] += 0  # не рассматриваем цвет c

    elif op_type == '-':
        # Обрабатываем удаление рёбер
        if (v, u) in color_edges[c]:
            color_edges[c].remove((v, u))
            vertex_count[c][v] -= 1
            vertex_count[c][u] -= 1

            # Проверяем превосходный цвет
            if vertex_count[c][v] < 2 and vertex_count[c][u] < 2:
                if vertex_count[c][v] == 1 and vertex_count[c][u] == 1:
                    color_beauty[c] -= 0  # остался превосходным
                elif vertex_count[c][v] == 0 or vertex_count[c][u] == 0:
                    color_beauty[c] -= 1
                    total_beauty -= 1

    output.append(total_beauty)

print("\\n".join(map(str, output)))
