#include <iostream>
#include <vector>
using namespace std;

// Проверка на возможное разбиение
bool isPossible(int n) {
    // Разбиение невозможно, если n = 4 (это классическая неразрешимая задача для n=4)
    return n != 4;
}

// Основная функция для решения задачи
void solve(int n) {
    if (!isPossible(n)) {
        cout << -1 << endl;
        return;
    }

    // Инициализация пустого поля
    vector<vector<int>> grid(n, vector<int>(n, 0));

    // Нумерация фигур от 1 до n
    int currentNum = 1;

    // Заполнение поля жадным методом
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            grid[i][j] = currentNum;
            currentNum++;
            if (currentNum > n) {
                currentNum = 1; // Переход к следующей фигуре
            }
        }
    }

    // Вывод результата
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << grid[i][j] << " ";
        }
        cout << endl;
    }
}

int main() {
    int n;
    cin >> n;
    solve(n);
    return 0;
}
