#include <iostream>
#include <vector>
#include <cmath>

// Функция для вычисления расстояния между двумя точками
double distance(int x1, int y1, int x2, int y2) {
    return sqrt((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1));
}

// Функция для поиска средней точки между двумя точками
std::pair<int, int> midpoint(int x1, int y1, int x2, int y2) {
    return { (x1 + x2) / 2, (y1 + y2) / 2 };
}

int main() {
    int x1, y1, x2, y2, x3, y3;
    
    // Ввод координат трех домов
    std::cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    
    // Находим среднюю точку между двумя парами точек
    auto mid12 = midpoint(x1, y1, x2, y2);
    auto mid13 = midpoint(x1, y1, x3, y3);
    auto mid23 = midpoint(x2, y2, x3, y3);
    
    // Определяем ближайшую пару точек к средним точкам
    double dist12 = distance(mid12.first, mid12.second, x3, y3);
    double dist13 = distance(mid13.first, mid13.second, x2, y2);
    double dist23 = distance(mid23.first, mid23.second, x1, y1);
    
    if (dist12 <= dist13 && dist12 <= dist23) {
        std::cout << x1 << ' ' << y1 << ' ';
        std::cout << mid12.first << ' ' << mid12.second << '\n';
    } else if (dist13 <= dist12 && dist13 <= dist23) {
        std::cout << x1 << ' ' << y1 << ' ';
        std::cout << mid13.first << ' ' << mid13.second << '\n';
    } else {
        std::cout << x1 << ' ' << y1 << ' ';
        std::cout << mid23.first << ' ' << mid23.second << '\n';
    }
    
    return 0;
}