#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

double computeDistance(long long p1x, long long p1y, long long p2x, long long p2y, long long p3x, long long p3y) {
    double A = p2y - p1y;
    double B = p1x - p2x;
    double C = p2x * p1y - p1x * p2y;
    return abs(A * p3x + B * p3y + C) / sqrt(A * A + B * B);
}

int main() {
    long long xA, yA, xB, yB, xC, yC;
    cin >> xA >> yA >> xB >> yB >> xC >> yC;

    double distC = computeDistance(xA, yA, xB, yB, xC, yC);
    double distB = computeDistance(xA, yA, xC, yC, xB, yB);
    double distA = computeDistance(xB, yB, xC, yC, xA, yA);

    double minDist = min({distA, distB, distC});
    if (distA == minDist) {
        cout << xB << " " << yB << " " << xC << " " << yC << endl;
    } else if (distB == minDist) {
        cout << xA << " " << yA << " " << xC << " " << yC << endl;
    } else {
        cout << xA << " " << yA << " " << xB << " " << yB << endl;
    }

    return 0;
}