#include <bits/stdc++.h>
using namespace std;
#define ff first
#define ss second

const int N = 1e5;
typedef pair<int, int> pii;

string to_chess_notation(int x, int y){
    string s = "";
    s += ('a' + x -1);
    s += to_string(y);
    return s;
}

main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    
    vector<pii> possible;
    for(int x = 1; x <= 8; x++){
        for(int y = 1; y <= 8; y++){
            possible.emplace_back(make_pair(x, y));
        }
    }
    
    vector<pii> move_attempts = { {1,1}, {2,2}, {3,3}, {4,4}, {1,-1}, {2,-2}, {3,-3}, {4,-4}, {-1,1}, {-2,2}, {-3,3}, {-4,4}, {-1,-1}, {-2,-2}, {-3,-3}, {-4,-4} };
    
    int move_idx = 0;
    
    for(int attempt = 0; attempt < 7 && possible.size() > 1; attempt++){
        pii move = move_attempts[move_idx % move_attempts.size()];
        move_idx++;
        
        cout << "? " << move.first << " " << move.second << "\n";
        cout.flush();
        
        string response;
        cin >> response;
        
        vector<pii> new_possible;
        for(auto &[x, y] : possible){
            int new_x = x + move.first;
            int new_y = y + move.second;
            bool valid = (new_x >=1 && new_x <=8 && new_y >=1 && new_y <=8);
            if(response == "+" && valid){
                new_possible.emplace_back(make_pair(new_x, new_y));
            }
            else if(response == "-" && !valid){
                new_possible.emplace_back(make_pair(x, y));
            }
        }
        possible = new_possible;
    }
    
    if(possible.size() >=1){
        string pos = to_chess_notation(possible[0].first, possible[0].second);
        cout << "! " << pos << "\n";
        cout.flush();
    }
    
    return 0;
}
