/******************************************************************************

                              Online C++ Compiler.
               Code, Compile, Run and Debug C++ program online.
Write your code in this editor and press "Run" button to compile and execute it.

*******************************************************************************/

#include <iostream>
#include <algorithm>
#include <climits>

using namespace std;

// Функция для подсчета минимального числа разрезов
int min_cuts(int n, int m, int s) {
    // Если площадь листа равна требуемой
    if (n * m == s) {
        return 0;
    }

    // Если невозможно достичь нужной площади
    if (s > n * m) {
        return -1;
    }

    int min_cuts_result = INT_MAX;

    // Горизонтальные разрезы
    for (int i = 1; i < n; ++i) {
        int upper_part = i * m;
        if (upper_part >= s) {
            min_cuts_result = min(min_cuts_result, 1 + min_cuts(i, m, s));
        } else {
            min_cuts_result = min(min_cuts_result, 1 + min_cuts(n - i, m, s - upper_part));
        }
    }

    // Вертикальные разрезы
    for (int j = 1; j < m; ++j) {
        int left_part = j * n;
        if (left_part >= s) {
            min_cuts_result = min(min_cuts_result, 1 + min_cuts(n, j, s));
        } else {
            min_cuts_result = min(min_cuts_result, 1 + min_cuts(n, m - j, s - left_part));
        }
    }

    return (min_cuts_result == INT_MAX) ? -1 : min_cuts_result;
}

int main() {
    int n, m, s;
    cin >> n >> m >> s;

    int result = min_cuts(n, m, s);
    cout << result << endl;

    return 0;
}
