
#include <iostream>
#include <vector>
#include <climits>
using namespace std;

int min_cuts(int n, int m, int s) {
    if (s > n * m) {
        return -1; // Невозможно
    }

    // Создаем 3D таблицу DP
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(m + 1, vector<int>(s + 1, INT_MAX)));

    // Заполняем базовые случаи
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            for (int k = 1; k <= s; ++k) {
                if (k > i * j) {
                    dp[i][j][k] = INT_MAX; // Невозможно получить площадь k
                } else if (k == i * j) {
                    dp[i][j][k] = 0; // Разрезов не требуется
                }
            }
        }
    }

    // Итеративное заполнение DP
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            for (int k = 1; k <= s; ++k) {
                // Горизонтальные разрезы
                for (int x = 1; x < i; ++x) {
                    int upper_part = x * j;
                    if (upper_part >= k) {
                        dp[i][j][k] = min(dp[i][j][k], 1 + dp[x][j][k]);
                    } else {
                        dp[i][j][k] = min(dp[i][j][k], 1 + dp[x][j][upper_part] + dp[i - x][j][k - upper_part]);
                    }
                }

                // Вертикальные разрезы
                for (int y = 1; y < j; ++y) {
                    int left_part = y * i;
                    if (left_part >= k) {
                        dp[i][j][k] = min(dp[i][j][k], 1 + dp[i][y][k]);
                    } else {
                        dp[i][j][k] = min(dp[i][j][k], 1 + dp[i][y][left_part] + dp[i][j - y][k - left_part]);
                    }
                }
            }
        }
    }

    return dp[n][m][s] == INT_MAX ? -1 : dp[n][m][s];
}

int main() {
    int n, m, s;
    cin >> n >> m >> s;

    int result = min_cuts(n, m, s);
    cout << result << endl;

    return 0;
}
