import math

def is_possible(x0, y0, x1, y1, n, a):
    result = []
    directions = [(1, 0), (-1, 0), (0, 1), (0, -1)]  # Возможные направления: вправо, влево, вверх, вниз

    def backtrack(curr_x, curr_y, step):
        if step == n:
            if math.isclose(curr_x, x1, abs_tol=1e-4) and math.isclose(curr_y, y1, abs_tol=1e-4):
                return True
            return False

        length = a[step]
        for dx, dy in directions:
            new_x = curr_x + length * dx
            new_y = curr_y + length * dy
            result.append((new_x, new_y))
            if backtrack(new_x, new_y, step + 1):
                return True
            result.pop()

        return False

    # Начинаем с начальной точки
    if backtrack(x0, y0, 0):
        return "Possible", [(x0, y0)] + result
    else:
        return "Impossible", []

# Чтение входных данных
x0, y0 = map(int, input().split())
x1, y1 = map(int, input().split())
n = int(input())
a = list(map(int, input().split()))

# Решение задачи
result, points = is_possible(x0, y0, x1, y1, n, a)
print(result)
if result == "Possible":
    for point in points:
        print(f"{point[0]:.6f} {point[1]:.6f}")
