def galactic_timeline(n, a, b):
    # Формируем список из пар (лицевая, оборотная)
    cards = [(a[i], b[i]) for i in range(n)]
    
    # Начальное значение предыдущих годов для обеих сторон
    top_prev, bottom_prev = -1, -1
    
    # Результат для лицевой и оборотной сторон
    top_result = []
    bottom_result = []
    
    for card in sorted(cards, key=lambda x: min(x)):
        top_face, bottom_face = card  # лицевая и оборотная стороны
        
        if top_face >= top_prev and bottom_face >= bottom_prev:
            # Лицевая сторона подходит
            top_result.append(top_face)
            bottom_result.append(bottom_face)
            top_prev, bottom_prev = top_face, bottom_face
        elif bottom_face >= top_prev and top_face >= bottom_prev:
            # Переворачиваем карточку
            top_result.append(bottom_face)
            bottom_result.append(top_face)
            top_prev, bottom_prev = bottom_face, top_face
        else:
            # Невозможно упорядочить
            return -1

    return top_result, bottom_result


# Считывание данных
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

result = galactic_timeline(n, a, b)
if result == -1:
    print(-1)
else:
    print(" ".join(map(str, result[0])))
    print(" ".join(map(str, result[1])))
