def galactic_timeline(n, a, b):
    # Формируем список пар (лицевая сторона, оборотная сторона)
    cards = [(a[i], b[i]) for i in range(n)]
    
    # Сортируем карты по минимальному году (для упрощения проверки)
    cards.sort(key=lambda x: min(x))
    
    # Результаты для лицевой и оборотной стороны
    top_result = []
    bottom_result = []
    
    # Предыдущие значения для проверки возрастания
    top_prev, bottom_prev = -1, -1
    
    for card in cards:
        top_face, bottom_face = card
        
        if top_face >= top_prev and bottom_face >= bottom_prev:
            # Карточка подходит как есть
            top_result.append(top_face)
            bottom_result.append(bottom_face)
            top_prev, bottom_prev = top_face, bottom_face
        elif bottom_face >= top_prev and top_face >= bottom_prev:
            # Переворачиваем карточку
            top_result.append(bottom_face)
            bottom_result.append(top_face)
            top_prev, bottom_prev = bottom_face, top_face
        else:
            # Если ни одно из условий не выполняется
            return -1
    
    return top_result, bottom_result


# Считывание входных данных
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

# Получение результата
result = galactic_timeline(n, a, b)

# Вывод результата
if result == -1:
    print(-1)
else:
    print(" ".join(map(str, result[0])))
    print(" ".join(map(str, result[1])))
