def galactic_timeline(n, a, b):
    # Создаём массив пар (лицевая сторона, оборотная сторона)
    cards = [(a[i], b[i]) for i in range(n)]
    
    # Попробуем найти правильный порядок
    def can_sort_cards(cards):
        # Предыдущие значения для лицевой и оборотной стороны
        top_prev, bottom_prev = -1, -1
        top_result, bottom_result = [], []
        
        for card in cards:
            top_face, bottom_face = card
            
            # Проверяем обе стороны карточки
            if top_face >= top_prev and bottom_face >= bottom_prev:
                top_result.append(top_face)
                bottom_result.append(bottom_face)
                top_prev, bottom_prev = top_face, bottom_face
            elif bottom_face >= top_prev and top_face >= bottom_prev:
                top_result.append(bottom_face)
                bottom_result.append(top_face)
                top_prev, bottom_prev = bottom_face, top_face
            else:
                return -1  # Невозможно упорядочить
        return top_result, bottom_result

    # Попробуем разные варианты сортировки
    cards.sort(key=lambda x: min(x))
    result = can_sort_cards(cards)
    if result != -1:
        return result
    
    # Если не сработало, сортируем по максимальным значениям
    cards.sort(key=lambda x: max(x))
    result = can_sort_cards(cards)
    if result != -1:
        return result

    # Если ни один вариант не работает
    return -1


# Считывание входных данных
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

# Решение
result = galactic_timeline(n, a, b)

# Вывод результата
if result == -1:
    print(-1)
else:
    print(" ".join(map(str, result[0])))
    print(" ".join(map(str, result[1])))
