#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ull = unsigned long long;
const ll mod = 1e9 + 9;
const ll p = 257;

template<class T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& e : a)
        in >> e;
    return in;
}

template<class T>
ostream& operator<<(ostream& out, vector<T>& a) {
    for (T& e : a)
        out << e << ' ';
    out << '\n';
    return out;
}

struct Hash{
    ll val = 0;

    Hash operator+(const ll& b) const {
        ll res = (val + b);
        if(res >= mod)
            res -= mod;
        return {res};
    }

    Hash operator-(const Hash& b) const {
        ll res = (val - b.val);
        if (res < 0) {
            res += mod;
        }
        return {res};
    }

    Hash operator*(const Hash& b) const {
        return {val * b.val % mod};
    }

    Hash operator*(const ll& b) const {
        return {val * b % mod};
    }

    bool operator==(const Hash& b) const {
        return val == b.val;
    }
};

vector<Hash> h, pw;
vector<ull> h2, pw2;

Hash sub(ll r, ll l) {
    return h[r] - h[l] * pw[r - l];
}

ull sub2(ll r, ll l) {
    return h2[r] - h2[l] * pw2[r - l];
}

struct wind {
    vector<pair<ll, ll>> l, r;
    ll ans = -1;

    wind() {}

    void push_back(ll x) {
        if (r.empty()) {
            r.push_back({x, x});
        } else {
            r.push_back({x, (x | r.back().second)});
        }
        if (ans == -1) {
            ans = r.back().second;
        }
        ans = (ans | r.back().second);
    }

    void pop_front() {
        if (l.empty()) {
            while (!r.empty()) {
                pair<ll, ll> mn = r.back();
                ll p = mn.first;
                if (l.empty()) {
                    l.push_back({p, p});
                } else {
                    l.push_back({p, (p | l.back().second)});
                }
                r.pop_back();
            }
            l.pop_back();
            ans = l.back().second;
            if (l.empty()) {
                ans = -1;
            }
        } else {
            l.pop_back();
            if (!r.empty() && !l.empty()) {
                ans = l.back().second | r.back().second;
            } else if (!r.empty()) {
                ans = r.back().second;
            } else if (!l.empty()) {
                ans = l.back().second;
            } else {
                ans = -1;
            }
        }
    }

    ll get() {
        return ans;
    }
};

bool f(ll x, ll y) {
    cout << "? " << x << " " << y << endl;
    char c;
    cin >> c;
    if (c == '+') {
        return true;
    }
    return false;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    set<ll> good, bad;
    vector<map<ll, ll>> ls(1e5 + 1);
    vector<pair<ll, ll>> cnt(1e5 + 1, {0, 0});
    ll res = 0;
    while (m--) {
        char c;
        ll x, y, s;
        cin >> c >> x >> y >> s;
        if (c == '+') {
            ls[s][x]++;
            ls[s][y]++;
            cnt[s].first += 2;
            if (ls[s][x] == 1) {
                cnt[s].second++;
            }
            if (ls[s][y] == 1) {
                cnt[s].second++;
            }
            if (ls[s][x] > 1 || ls[s][y] > 1) {
                if (good.find(s) != good.end()) {
                    res -= (cnt[s].first - 2);
                }
                good.erase(s);
                bad.insert(s);
            } else if (cnt[s].first == 2) {
                good.insert(s);
                res += 2;
            } else {
                if (good.find(s) != good.end()) {
                    res += 2;
                }
            }
        } else {
            ls[s][x]--;
            ls[s][y]--;
            cnt[s].first -= 2;
            if (ls[s][x] == 0) {
                cnt[s].second--;
            }
            if (ls[s][y] == 0) {
                cnt[s].second--;
            }
            if (cnt[s].first == 0) {
                good.erase(s);
                res -= 2;
            } else if (cnt[s].second == cnt[s].first) {
                if (bad.find(s) != bad.end()) {
                    res += cnt[s].first;
                } else {
                    res -= 2;
                }
                good.insert(s);
                bad.erase(s);
            } else {
                if (good.find(s) != good.end()) {
                    res -= 2;
                }
            }
        }
//        ll res = 0;
//        for (auto i : good) {
//            res += cnt[i].first;
//        }
        cout << res / 2 << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}