from collections import defaultdict


def process_queries(queries):
    color_edges = defaultdict(set)  # color -> set of (min(v, u), max(v, u))
    vertex_color_degree = defaultdict(lambda: defaultdict(int))  # color -> vertex -> count
    color_beauty = defaultdict(int)  # color -> current beauty
    total_beauty = 0

    result = []

    for query in queries:
        action, v, u, c = query
        v, u = min(v, u), max(v, u)
        if action == '+':
            color_edges[c].add((v, u))
            vertex_color_degree[c][v] += 1
            vertex_color_degree[c][u] += 1
            if color_beauty[c] > 0:
                total_beauty -= color_beauty[c]
            if all(degree <= 1 for degree in vertex_color_degree[c].values()):
                color_beauty[c] = len(color_edges[c])
            else:
                color_beauty[c] = 0
            total_beauty += color_beauty[c]
        elif action == '-':
            color_edges[c].remove((v, u))
            vertex_color_degree[c][v] -= 1
            vertex_color_degree[c][u] -= 1
            if color_beauty[c] > 0:
                total_beauty -= color_beauty[c]
            if all(degree <= 1 for degree in vertex_color_degree[c].values()):
                color_beauty[c] = len(color_edges[c])
            else:
                color_beauty[c] = 0
            total_beauty += color_beauty[c]
        result.append(total_beauty)

    return result


queries = []
n, q = map(int, input().split())
for _ in range(q):
    s = input().split()
    queries.append((s[0], int(s[1]), int(s[2]), int(s[3])))
for i in process_queries(queries):
    print(i)
