import itertools

def solve_galactic_timeline(n, a, b):
    s1=('')
    s2=('')
    ha=('')
    cards = list(range(1, n + 1))  # Карты от 1 до n

    def is_sorted(arr):
        """Проверяет, отсортирован ли массив."""
        return all(arr[i] < arr[i + 1] for i in range(len(arr) - 1))

    for flip_combo in itertools.product([0, 1], repeat=n):
        # Создаём копии массивов a и b
        cur_a = list(a)
        cur_b = list(b)
        # Применяем комбинацию переворотов
        for i, flip in enumerate(flip_combo):
            if flip:
                cur_a[i], cur_b[i] = cur_b[i], cur_a[i]

        # Ищем перестановку, которая отсортирует оба массива
        for permutation in itertools.permutations(range(n)):
            ordered_a = [cur_a[i] for i in permutation]
            ordered_b = [cur_b[i] for i in permutation]
            if is_sorted(ordered_a) and is_sorted(ordered_b):
                # Перестановка номеров карт в отсортированном порядке
                sorted_indices = sorted(cards[i] for i in permutation)
                # Значения, полученные после сортировки
                sorted_values = ordered_a + ordered_b
                sorted_values = sorted(sorted_values)
                ha=(" ".join(map(str, sorted_values)))
                print(ha)
                ha=ha.split()
                print(ha)
                for i in range(0, n):
                    s1+=ha[i]
                for i in range(n, n*2):
                    s2+=ha[i]
                print(s1)
                print(s2)
                return  # Завершаем программу после нахождения первого решения

    # Если решения нет
    print("-1")


# Чтение ввода и запуск программы
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))
solve_galactic_timeline(n, a, b)
