from collections import deque

def can_form_area(areas, target):
    dp = [False] * (target + 1)
    dp[0] = True
    for area in areas:
        for t in range(target, area - 1, -1):
            dp[t] = dp[t] or dp[t - area]
    return dp[target]

def min_cuts(n, m, s):
    if s > n * m:
        return -1

    # Инициализация BFS
    queue = deque([(n, m, [n * m], 0)])
    visited = set()
    visited.add((n, m))

    while queue:
        h, w, areas, cuts = queue.popleft()

        if can_form_area(areas, s):
            return cuts

        for i in range(1, h):
            new_areas = areas[:]
            new_areas.remove(h * w)
            new_areas.append(i * w)
            new_areas.append((h - i) * w)
            new_areas.sort()
            if (h - i, w) not in visited:
                visited.add((h - i, w))
                queue.append((h - i, w, new_areas, cuts + 1))

        for j in range(1, w):
            new_areas = areas[:]
            new_areas.remove(h * w)
            new_areas.append(h * j)
            new_areas.append(h * (w - j))
            new_areas.sort()
            if (h, w - j) not in visited:
                visited.add((h, w - j))
                queue.append((h, w - j, new_areas, cuts + 1))

    return -1  
n, m, s = map(int, input().split())
print(min_cuts(n, m, s))