import heapq

def solve(n, t, c, stations):
    stations = [(0, 0)] + stations + [(t, 0)]
   
    min_time = [float('inf')] * (n + 2)
    min_time[0] = 0  

    pq = [(0, 0)]  
    
    while pq:
        time, i = heapq.heappop(pq)
       
        if time > min_time[i]:
            continue
        
        for j in range(i + 1, n + 2):
            dist = stations[j][0] - stations[i][0] 
            if dist > c:
                break  
            
            travel_time = dist / c  
            refuel_time = stations[j][1]  
            total_time = travel_time + refuel_time  

            if min_time[i] + total_time < min_time[j]:
                min_time[j] = min_time[i] + total_time
                heapq.heappush(pq, (min_time[j], j))
    
    print(f"{min_time[n + 1]:.6f}")

n, t, c = map(int, input().split())
stations = [tuple(map(int, input().split())) for _ in range(n)]

solve(n, t, c, stations)