import math

def line_eq(x1, y1, x2, y2):
    A = y2 - y1
    B = x1 - x2
    C = x2 * y1 - x1 * y2
    return A, B, C

def point_distance(x, y, A, B, C):
    return abs(A * x + B * y + C) / math.sqrt(A**2 + B**2)

def sum_of_distances(x1, y1, x2, y2, x3, y3, A, B, C):
    return point_distance(x1, y1, A, B, C) + point_distance(x2, y2, A, B, C) + point_distance(x3, y3, A, B, C)

x1, y1, x2, y2, x3, y3 = map(int, input().split())

A1, B1, C1 = line_eq(x1, y1, x2, y2)
A2, B2, C2 = line_eq(x1, y1, x3, y3)
A3, B3, C3 = line_eq(x2, y2, x3, y3)

sum1 = sum_of_distances(x1, y1, x2, y2, x3, y3, A1, B1, C1)
sum2 = sum_of_distances(x1, y1, x2, y2, x3, y3, A2, B2, C2)
sum3 = sum_of_distances(x1, y1, x2, y2, x3, y3, A3, B3, C3)

if sum1 <= sum2 and sum1 <= sum3:
    print(x1, y1, x2, y2)
elif sum2 <= sum3:
    print(x1, y1, x3, y3)
else:
    print(x2, y2, x3, y3)