def dist(x0, y0, a, b, c):
  return abs(a * x0 + b * y0 + c) / ((a * a + b * b) ** 0.5)

def calc(x1, y1, x2, y2, pts):
  if x1 == x2:
      a, b = 1, 0
      c = -x1
  else:
      a = (y2 - y1) / (x2 - x1)0 0 
      b = -1
      c = y1 - a * x1

  s = 0
  for x, y in pts:
      s += dist(x, y, a, b, c)
  return s

def solve(x1, y1, x2, y2, x3, y3):
  pts = [(x1, y1), (x2, y2), (x3, y3)]
  pairs = [
      (pts[0], pts[1]),
      (pts[1], pts[2]),
      (pts[0], pts[2])
  ]

  best = float('inf')
  rx1 = ry1 = rx2 = ry2 = 0

  for (ax, ay), (bx, by) in pairs:
      s = calc(ax, ay, bx, by, pts)
      if s < best:
          best = s
          rx1, ry1, rx2, ry2 = ax, ay, bx, by

  return rx1, ry1, rx2, ry2

x1, y1, x2, y2, x3, y3 = map(int, input().split())
ax, ay, bx, by = solve(x1, y1, x2, y2, x3, y3)
print(ax, ay, bx, by)