def minimum_cuts(n, m, s):
    if n > m:
        n, m = m, n

    min_cuts = float('inf')  

    for x in range(n):
        vertical_area = n // (x + 1) * (x + 1)  
        remaining_vertical = n % (x + 1)     
        
        low, high = 0, m - 1
        while low <= high:
            y = (low + high) // 2
            horizontal_area = m // (y + 1) * (y + 1)
            remaining_horizontal = m % (y + 1)
            
            total_area = vertical_area * (y + 1) + remaining_vertical * (y + 1)
            if total_area >= s:
                min_cuts = min(min_cuts, x + y)
                high = y - 1
            else:
                low = y + 1

    return min_cuts

n, m, s = map(int, input().split())
print(minimum_cuts(n, m, s))
