import math

def solve(x0, y0, x1, y1, n, a):
    # Вычисляем расстояние между начальной и конечной точкой
    total_distance = math.sqrt((x1 - x0)*2 + (y1 - y0)*2)
    
    # Если суммарная длина прыжков меньше расстояния, задача невозможна
    if sum(a) < total_distance:
        return "Impossible"
    
    # Начальные координаты
    points = [(x0, y0)]
    current_x, current_y = x0, y0
    
    # Угол направления к конечной точке
    angle = math.atan2(y1 - y0, x1 - x0)
    
    # Выполняем прыжки
    for i in range(n - 1):
        # Доля текущего прыжка в направлении к конечной точке
        jump_x = a[i] * math.cos(angle)
        jump_y = a[i] * math.sin(angle)
        current_x += jump_x
        current_y += jump_y
        points.append((current_x, current_y))
    
    # Последний прыжок точно приводит в конечную точку
    points.append((x1, y1))
    
    # Проверка: расстояния между точками должны быть равны a_i
    for i in range(n):
        dx = points[i + 1][0] - points[i][0]
        dy = points[i + 1][1] - points[i][1]
        if not math.isclose(math.sqrt(dx*2 + dy*2), a[i], rel_tol=1e-4, abs_tol=1e-4):
            return "Impossible"
    
    # Форматируем вывод
    result = ["Possible"]
    result.extend(f"{x:.6f} {y:.6f}" for x, y in points[1:])
    return "\n".join(result)


# Чтение данных
x0, y0 = map(int, input().split())
x1, y1 = map(int, input().split())
n = int(input())
a = list(map(int, input().split()))

# Вывод результата
print(solve(x0, y0, x1, y1, n, a))
