def solve():
    # Read input
    n = int(input())  # Number of cards
    a = list(map(int, input().split()))  # Face side years
    b = list(map(int, input().split()))  # Reverse side years
    
    # Create a list of cards where each card is represented as a tuple (ai, bi, index)
    cards = [(a[i], b[i], i) for i in range(n)]
    
    # Sort cards based on the smaller value between ai and bi for each card
    cards.sort(key=lambda x: (min(x[0], x[1]), max(x[0], x[1])))
    
    # Result arrays to store the ordered years for both sides
    res_a = []
    res_b = []
    
    # Previous value of the face and reverse side years
    prev_a = prev_b = -1
    
    for ai, bi, _ in cards:
        # We want to select ai for res_a and bi for res_b such that both sequences remain valid
        if ai >= prev_a and bi >= prev_b:
            # Choose the minimal viable assignment
            if ai >= bi:
                res_a.append(ai)
                res_b.append(bi)
            else:
                res_a.append(bi)
                res_b.append(ai)
            prev_a, prev_b = res_a[-1], res_b[-1]
        else:
            print(-1)
            return
    
    print(" ".join(map(str, res_a)))
    print(" ".join(map(str, res_b)))

