class ChessBoard:
    def __init__(self):
        # Создаем пустую доску 8x8
        self.board = [['.' for _ in range(8)] for _ in range(8)]

    def print_board(self):
        for row in self.board:
            print(' '.join(row))
        print()

class Bishop:
    def __init__(self, x, y):
        self.x = x  # Позиция по оси X (столбец)
        self.y = y  # Позиция по оси Y (строка)

    def possible_moves(self):
        moves = []
        # Вверх-вправо
        for i in range(1, 8):
            if self.x + i < 8 and self.y + i < 8:
                moves.append((self.x + i, self.y + i))
            if self.x - i >= 0 and self.y + i < 8:
                moves.append((self.x - i, self.y + i))
            if self.x + i < 8 and self.y - i >= 0:
                moves.append((self.x + i, self.y - i))
            if self.x - i >= 0 and self.y - i >= 0:
                moves.append((self.x - i, self.y - i))
        return moves

# Пример использования:
board = ChessBoard()
bishop = Bishop(3, 3)  # Поместим слона в позицию d4 (индексы 3, 3)

# Получаем все возможные ходы слона
moves = bishop.possible_moves()

# Отображаем доску и возможные ходы слона
board.print_board()
print("Possible moves for the bishop at d4:")
for move in moves:
    print(chr(move[0] + 97) + str(8 - move[1]))  # Преобразуем индексы в шахматные координаты
