#include <iostream>

using namespace std;

class ChessBoard {
private:
    int x, y;  // текущие координаты слона

public:
    // Конструктор, инициализируем слона на неизвестной позиции
    ChessBoard() : x(4), y(4) {} // Начальная позиция (4, 4) (например, e5)

    // Функция для отображения текущей позиции слона
    void printPosition() const {
        char col = 'a' + x - 1;  // Преобразуем x в букву (a-h)
        char row = '1' + (8 - y); // Преобразуем y в цифру (1-8)
        cout << col << row << endl;
    }

    // Функция для выполнения хода
    void move(int dx, int dy) {
        int newX = x + dx;
        int newY = y + dy;

        // Проверка на выход за пределы доски
        if (newX >= 1 && newX <= 8 && newY >= 1 && newY <= 8) {
            x = newX;
            y = newY;
            cout << "+" << endl;  // Успешный ход
        } else {
            cout << "-" << endl;  // Невозможный ход
        }
    }

    // Проверка, допустимо ли движение по диагонали
    bool canMove(int dx, int dy) const {
        return abs(dx) == abs(dy);  // Слон ходит только по диагонали
    }
};

int main() {
    ChessBoard bishop;  // Создаем объект для шахматного слона

    // Пример хода (смещение по горизонтали x, по вертикали y)
    bishop.printPosition();  // Отображаем начальную позицию

    // До 7 попыток хода
    for (int i = 0; i < 7; ++i) {
        int dx, dy;
        cin >> dx >> dy;  // Считываем смещения по осям

        if (bishop.canMove(dx, dy)) {
            bishop.move(dx, dy);  // Выполняем ход
            bishop.printPosition();  // Показываем новую позицию
        } else {
            cout << "Invalid move!" << endl;
        }
    }

    return 0;
}
