def min_cuts(n, m, s):
    # Если s = n * m, резать не нужно
    if s == n * m:
        return 0

    # Перебираем возможные разрезы
    for cuts in range(1, n + m):
        for x in range(min(cuts + 1, n)):
            y = cuts - x
            if y > m - 1:
                continue
            
            # Составляем список всех возможных площадей
            widths = [n // (x + 1) + (1 if i < n % (x + 1) else 0) for i in range(x + 1)]
            heights = [m // (y + 1) + (1 if i < m % (y + 1) else 0) for i in range(y + 1)]
            areas = [w * h for w in widths for h in heights]

            # Проверяем, можно ли набрать сумму s
            dp = [False] * (s + 1)
            dp[0] = True
            for area in areas:
                for k in range(s, area - 1, -1):
                    dp[k] = dp[k] or dp[k - area]

            if dp[s]:
                return cuts

    return -1  # Если не получилось найти решение (в теории недостижимо)

# Чтение ввода и вызов функции
n, m, s = map(int, input().split())
print(min_cuts(n, m, s))
