def solve():
    # Чтение входных данных
    n = int(input())
    
    # Маршрут змейкой
    path = []
    for i in range(n):
        if i % 2 == 0:
            # Четная строка: слева направо
            for j in range(n):
                path.append((j, i))
        else:
            # Нечетная строка: справа налево
            for j in range(n - 1, -1, -1):
                path.append((j, i))
    
    # Оптимизация маршрута: оставляем повороты и конечную точку
    result = [path[0]]  # Начальная точка
    for i in range(1, len(path) - 1):
        prev, curr, nxt = path[i - 1], path[i], path[i + 1]
        # Проверяем, является ли текущая точка поворотом
        if not (curr[0] - prev[0] == nxt[0] - curr[0] and curr[1] - prev[1] == nxt[1] - curr[1]):
            result.append(curr)
    result.append(path[-1])  # Конечная точка
    
    # Проверка количества точек
    assert len(result) == 2 * n - 1, "Маршрут должен содержать ровно 2n-1 точек"
    
    # Вывод результата
    for x, y in result:
        print(x, y)
