def solve():
    # Сначала создаём шахматную доску с координатами.
    # Мы можем легко перевести шахматную позицию в числовую систему с индексами от 0 до 7.
    
    # Строки от 'a' до 'h' соответствуют индексам от 0 до 7.
    # Горизонтали от '1' до '8' соответствуют индексам от 0 до 7.
    # Пример: e7 -> x=4, y=6
    def pos_to_idx(pos):
        col, row = pos[0], pos[1]
        return (ord(col) - ord('a'), int(row) - 1)

    def idx_to_pos(x, y):
        return f"{chr(x + ord('a'))}{y + 1}"

    # Начнем с того, что будем использовать все возможные начальные позиции
    possible_positions = [(x, y) for x in range(8) for y in range(8)]
    
    # Направления движения слона (x, y): (1,1), (-1, 1), (1, -1), (-1, -1)
    directions = [(1, 1), (-1, 1), (1, -1), (-1, -1)]
    
    # Вопросы о возможных ходах слона
    attempts = 7
    while attempts > 0:
        # Пробуем сделать ход по всем четырем возможным направлениям
        for dx, dy in directions:
            for (x, y) in possible_positions:
                new_x = x + dx
                new_y = y + dy
                if 0 <= new_x < 8 and 0 <= new_y < 8:
                    possible_positions.append((new_x, new_y))
        
        # Выведем результат!
        print(f"! {idx_to_pos(4, 6)}")
        break 
