def solve():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    idx = 0
    t = int(data[idx])  # количество тестов
    idx += 1
    
    results = []
    
    for _ in range(t):
        # Читаем данные для одного теста
        n, m, k = map(int, data[idx].split())  # n - длина перестановки, m - страницы книги, k - ученики
        idx += 1
        
        p = list(map(int, data[idx].split()))  # перестановка
        idx += 1
        
        a = list(map(int, data[idx].split()))  # руны на страницах книги
        idx += 1
        
        students = []
        for i in range(k):
            l, r = map(int, data[idx].split())
            students.append((l-1, r-1, i+1))  # превращаем индексы в 0-based и сохраняем индекс ученика
            idx += 1
        
        # Сначала находим индексы всех элементов перестановки в книге
        pos_in_book = {}
        for i in range(m):
            if a[i] not in pos_in_book:
                pos_in_book[a[i]] = []
            pos_in_book[a[i]].append(i)
        
        # Для каждого элемента из перестановки нужно найти интервалы учеников, которые могут его покрыть
        student_intervals = []
        for value in p:
            if value not in pos_in_book:
                student_intervals = None
                break
            positions = pos_in_book[value]
            intervals_for_value = []
            for l, r, student_id in students:
                for pos in positions:
                    if l <= pos <= r:
                        intervals_for_value.append((l, r, student_id))
            if not intervals_for_value:
                student_intervals = None
                break
            student_intervals.append(intervals_for_value)
        
        if student_intervals is None:
            results.append("-1")
            continue
        
        # Жадный алгоритм, для каждого элемента перестановки выбираем интервал, который расширяет наш диапазон
        covered_positions = -1
        selected_students = []
        
        for intervals_for_value in student_intervals:
            # Сортируем интервалы по левой границе
            intervals_for_value.sort()
            selected = False
            for l, r, student_id in intervals_for_value:
                if l > covered_positions:
                    selected_students.append(student_id)
                    covered_positions = r
                    selected = True
                    break
            if not selected:
                selected_students = None
                break
        
        if selected_students is None:
            results.append("-1")
        else:
            results.append(f"{len(selected_students)}")
            results.append(" ".join(map(str, selected_students)))
    
    sys.stdout.write("\n".join(results) + "\n")

