def solve():
    import sys
    input = sys.stdin.read
    x1, y1, x2, y2, x3, y3 = map(int, input().split())
    
    # Средние координаты между точками
    mx1, my1 = (x1 + x2) / 2, (y1 + y2) / 2
    mx2, my2 = (x2 + x3) / 2, (y2 + y3) / 2
    mx3, my3 = (x1 + x3) / 2, (y1 + y3) / 2
    
    # Перпендикулярная прямая к линиям соединяющим точек
    # Линии: (x1, y1) -> (x2, y2) и (x2, y2) -> (x3, y3)
    # Найдем векторы направлений
    vx1, vy1 = x2 - x1, y2 - y1
    vx2, vy2 = x3 - x2, y3 - y2
    
    # Перпендикулярные вектора
    pv1x, pv1y = vy1, -vx1
    pv2x, pv2y = vy2, -vx2
    
    # Уравнения прямых, проходящих через середины линий и перпендикулярные им
    a1, b1 = pv1x, pv1y
    c1 = - (a1 * mx1 + b1 * my1)
    
    a2, b2 = pv2x, pv2y
    c2 = - (a2 * mx2 + b2 * my2)
    
    # Найдем точку пересечения двух прямых
    # (a1*x + b1*y + c1 = 0) and (a2*x + b2*y + c2 = 0)
    determinant = a1 * b2 - a2 * b1
    if determinant == 0:
        return
    
    x = (c1 * b2 - c2 * b1) / determinant
    y = (a1 * c2 - a2 * c1) / determinant
    
    print(int(x), int(y))

