from math import gcd

def is_reachable(x, y, a, b):
    # Проверка достижимости точки (x, y)
    g = gcd(a, b)
    return x % g == 0 and y % g == 0

def count_paths(x, y, a, b):
    if not is_reachable(x, y, a, b):
        return 0
    
    dp = {}
    dp[(0, 0)] = 1
    
    for i in range(0, x + 1):
        for j in range(0, y + 1):
            dp[(i, j)] = dp.get((i - a, j - b), 0) + dp.get((i + a, j + b), 0)
    
    return dp.get((x, y), 0)

# Пример
x, y = 6, 8
a, b = 2, 3
print(count_paths(x, y, a, b))
