def calculate_distance(point1, point2):
    """Вычисляет расстояние между двумя точками."""
    return abs(point1[0] - point2[0]) + abs(point1[1] - point2[1])

def find_shortest_path(points):
    """Находит кратчайший маршрут, посещающий все точки."""
    start = (0, 0)  # Стартовая точка (можно изменить, если требуется)
    all_points = [start] + points
    min_distance = float('inf')
    best_route = []

    # Полный перебор всех возможных маршрутов
    for perm in permutations(points):
        route = [start] + list(perm)
        distance = sum(calculate_distance(route[i], route[i+1]) for i in range(len(route) - 1))
        if distance < min_distance:
            min_distance = distance
            best_route = route

    return best_route, min_distance

# Пример входных данных
n = int(input("Введите количество точек: "))
points = []
for _ in range(n):
    x, y = map(int, input("Введите координаты точки (x, y): ").split())
    points.append((x, y))

# Поиск оптимального маршрута
route, distance = find_shortest_path(points)
print("Кратчайший маршрут:", route)
print("Общее расстояние:", distance)
