def find_min_students(n, m, k, permutation, runes, intervals):
    
    positions = {rune: [] for rune in range(1, n+1)}
    for idx, rune in enumerate(runes):
        positions[rune].append(idx + 1)
    
   
    possible_segments = []
    
    
    for i in range(k):
        l, r = intervals[i]
        segment = set(runes[l-1:r])
        if all(permutation[j] in segment for j in range(n)):
            possible_segments.append((l, r))
    
   
    if not possible_segments:
        return -1
    
    possible_segments.sort(key=lambda x: (x[1] - x[0], x[0]))
    
    return possible_segments


n = 4  
m = 6  
k = 3  
permutation = [1, 3, 2, 4]  
runes = [2, 1, 3, 2, 1, 4]  
intervals = [(1, 6), (2, 6), (1, 3)] 

result = find_min_students(n, m, k, permutation, runes, intervals)
if result == -1:
    print("Impossible")
else:
    print(len(result))
    for l, r in result:
        print(l, r)
