#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    map<int, set<pair<int, int>>> dct;

    for (int i = 0; i < q; i++) {
        string s;
        int v, u, c;
        cin >> s >> v >> u >> c;

        if (v < u) {
            swap(u, v);
        }
        if (s == "+") {
            dct[c].insert({u, v});
        } else {
            if (dct.count(c) && dct[c].count({u, v})) {
                dct[c].erase({u, v});
            }
        }
        int ans = 0;

        for (auto it = dct.rbegin(); it != dct.rend(); ++it) {
            const auto& edges = it->second;
            set<int> unique_nodes;
            bool valid = true;

            for (const auto& edge : edges) {
                if (unique_nodes.count(edge.first) || unique_nodes.count(edge.second)) {
                    valid = false;
                    break;
                }
                unique_nodes.insert(edge.first);
                unique_nodes.insert(edge.second);
            }
            if (valid) {
                ans += edges.size();
            }
        }

        cout << ans << endl;
    }

    return 0;
}

