#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool can_sort(int n, vector<int>& a, vector<int>& b) {
    vector<int> sorted_a = a, sorted_b = b;
    sort(sorted_a.begin(), sorted_a.end());
    sort(sorted_b.begin(), sorted_b.end());

    bool possible_with_a = true, possible_with_b = true;

    // Проверяем, можно ли отсортировать как есть
    if (sorted_a != a && sorted_b != b) {
        possible_with_a = false;
        possible_with_b = false;
    }

    if (possible_with_a) {
        vector<int> flipped_a(n), flipped_b(n);
        for (int i = 0; i < n; ++i) {
            flipped_a[i] = b[i];
            flipped_b[i] = a[i];
        }
        sort(flipped_a.begin(), flipped_a.end());
        sort(flipped_b.begin(), flipped_b.end());
        if (flipped_a == sorted_a && flipped_b == sorted_b) {
            return true;
        }
    }
    
    if (possible_with_b) {
        vector<int> flipped_a(n), flipped_b(n);
        for (int i = 0; i < n; ++i) {
            flipped_a[i] = b[i];
            flipped_b[i] = a[i];
        }
        sort(flipped_a.begin(), flipped_a.end());
        sort(flipped_b.begin(), flipped_b.end());
        if (flipped_a == sorted_a && flipped_b == sorted_b) {
            return true;
        }
    }

    return false;
}

int main() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    if (can_sort(n, a, b)) {
        sort(a.begin(), a.end());
        sort(b.begin(), b.end());
        for (int i = 0; i < n; ++i) {
            cout << a[i] << ' ';
        }
        cout << endl;
        for (int i = 0; i < n; ++i) {
            cout << b[i] << ' ';
        }
        cout << endl;
    } else {
        cout << -1 << endl;
    }

    return 0;
}
