def min_cuts(n, m, s):
    """Calculates the minimum number of cuts to obtain a total area of s from a n x m sheet.

    Args:
        n: Width of the sheet.
        m: Height of the sheet.
        s: Target area.

    Returns:
        The minimum number of cuts required.
    """

    if n * m == s:
        return 0  # No cuts needed
    elif n <= 1 or m <= 1:
        return n * m - 1  # Cut each unit square

    # Try cutting along both dimensions and choose the minimum
    cut_horizontally = 1 + min_cuts(n, m - 1, s)
    cut_vertically = 1 + min_cuts(n - 1, m, s)

    return min(cut_horizontally, cut_vertically)

# Get input
n, m, s = map(int, input().split())

# Calculate and print the minimum number of cuts
result = min_cuts(n, m, s)
print(result)
