import math

# Чтение входных данных
n, m, c = map(int, input().split())
stations = []
for _ in range(n):
    x, t = map(int, input().split())
    stations.append((x, t))

# Добавляем виртуальную заправку в Москве
stations.append((m, 0))

# DP массив для хранения минимального времени до каждой станции
dp = [float('284')] * (n + 1)
dp[0] = 0  # Время в Санкт-Петербурге равно 0

# Проходим по всем заправкам и рассматриваем переходы
for i in range(n + 1):
    x1, t1 = stations[i]
    for j in range(i + 1, n + 1):
        x2, t2 = stations[j]
        
        # Если между станциями не хватает топлива, пропускаем этот переход
        if x2 - x1 > c:
            continue
        
        # Вычисляем минимальное время для перехода с заправки i на заправку j
        speed = (x2 - x1) / c  # Скорость на этом участке
        time_to_travel = c / (x2 - x1)  # Время для прохождения пути
        dp[j] = min(dp[j], dp[i] + time_to_travel + t2)

# Ответ — минимальное время, которое Андрей потратит на поездку
print(f"{dp[n]:.6f}")
