from collections import defaultdict

def solve():
    # Ввод данных
    n, q = map(int, input().split())
    
    # Структуры для хранения графа
    edge_count = defaultdict(int)  # Количество рёбер для каждого цвета
    vertex_edge_count = defaultdict(lambda: defaultdict(int))  # Сколько рёбер этого цвета у каждой вершины

    total_beauty = 0  # Общая красота графа
    
    # Обрабатываем каждый запрос
    for _ in range(q):
        query = input().split()
        
        # Обрабатываем запрос типа "+ v u c"
        if query[0] == "+":
            v, u, c = int(query[1]), int(query[2]), int(query[3])
            
            # Обновляем количество рёбер для цвета c
            edge_count[c] += 1
            
            # Увеличиваем количество рёбер этого цвета для вершин v и u
            vertex_edge_count[c][v] += 1
            vertex_edge_count[c][u] += 1
            
            # Проверяем, был ли цвет c теперь превосходным
            if vertex_edge_count[c][v] == 2:
                # Если количество рёбер для вершины v стало 2 для цвета c, то этот цвет больше не превосходный
                edge_count[c] -= 1
            if vertex_edge_count[c][u] == 2:
                # Если количество рёбер для вершины u стало 2 для цвета c, то этот цвет больше не превосходный
                edge_count[c] -= 1
        
        # Обрабатываем запрос типа "- v u c"
        elif query[0] == "-":
            v, u, c = int(query[1]), int(query[2]), int(query[3])
            
            # Уменьшаем количество рёбер для цвета c
            edge_count[c] -= 1
            
            # Уменьшаем количество рёбер этого цвета для вершин v и u
            vertex_edge_count[c][v] -= 1
            vertex_edge_count[c][u] -= 1
            
            # Проверяем, стал ли цвет c превосходным снова
            if vertex_edge_count[c][v] == 1:
                edge_count[c] += 1
            if vertex_edge_count[c][u] == 1:
                edge_count[c] += 1
        
        # После каждого запроса выводим суммарную красоту всех превосходных цветов
        total_beauty = sum(count for count in edge_count.values() if count <= n)
        print(total_beauty)

# Запускаем решение
solve()
