def bresenham(x1_, y1_, x2_, y2_):
    coordinates = []
    dx = abs(x2_ - x1_)
    dy = abs(y2_ - y1_)
    sx = 1 if x1_ < x2_ else -1
    sy = 1 if y1_ < y2_ else -1
    err = dx - dy
    while True:
        coordinates.append((x1_, y1_))
        if x1_ == x2_ and y1_ == y2_:
            break
        e2 = 2 * err
        if e2 > -dy:
            err -= dy
            x1_ += sx
        if e2 < dx:
            err += dx
            y1_ += sy
    return coordinates


x1, y1, x2, y2, x3, y3 = map(int, input().split())
coords = set(bresenham(x1, y1, x2, y2))
coords.discard((x1, y1))
coords.discard((x2, y2))
coords.discard((x3, y3))
coords = sorted(coords)
res = coords[:2]
print("{} {} {} {}".format(res[0][0], res[0][1], res[1][0], res[1][1]))
