#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

bool isSorted(const vector<int>& arr) {
    for (size_t i = 1; i < arr.size(); i++) {
        if (arr[i] < arr[i - 1]) return false;
    }
    return true;
}

void solve(int n, vector<int>& front, vector<int>& back) {
    vector<int> indices(n);
    for (int i = 0; i < n; i++) indices[i] = i;
    do {
        for (int mask = 0; mask < (1 << n); mask++) {
            vector<int> new_front, new_back;
            for (int i = 0; i < n; i++) {
                int idx = indices[i];
                if (mask & (1 << i)) { 
                    new_front.push_back(back[idx]);
                    new_back.push_back(front[idx]);
                } else {
                    new_front.push_back(front[idx]);
                    new_back.push_back(back[idx]);
                }
            }
            if (isSorted(new_front) && isSorted(new_back)) {
                for (int x : new_front) cout << x << " ";
                cout << endl;
                for (int x : new_back) cout << x << " ";
                cout << endl;
                return;
            }
        }
    } while (next_permutation(indices.begin(), indices.end()));
    cout << -1 << endl;
}

int main() {
    int n;
    cin >> n;
    vector<int> front(n), back(n);
    for (int i = 0; i < n; i++) cin >> front[i];
    for (int i = 0; i < n; i++) cin >> back[i];

    solve(n, front, back);
    return 0;
}