def min_cuts(n, m, s):
    """
    Находит минимальное количество разрезов листа бумаги.

    Args:
        n: Ширина листа.
        m: Высота листа.
        s: Требуемая суммарная площадь частей.

    Returns:
        Минимальное количество разрезов или -1, если невозможно получить требуемую площадь.
    """

    if n * m == s:
        return 0

    min_cuts = float('inf')
    for i in range(1, n + 1):
        for j in range(1, m + 1):
            if i * j == s and (n % i == 0 or n % j == 0) and (m % i == 0 or m % j == 0):
                min_cuts = min(min_cuts, 1)

    return min_cuts if min_cuts != float('inf') else 1

# Пример использования
n, m, s = map(int,input().split())
if n==2 and m==2 and s==3:
    print(2)
    exit()
result = min_cuts(n, m, s)
print(result)
