#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;

bool check(double c, double h) {
    double D = c * c - 4 * h * h;
    double x1 = 0, x2 = 0;

    if (D >= 0) {
        x1 = (c - sqrt(D)) / 2;
        x2 = (c + sqrt(D)) / 2;
    }

    double a1 = 0, b1 = 0, a2 = 0, b2 = 0;
    if (x1 > 0) {
        a1 = sqrt(h * h + x1 * x1);
        b1 = sqrt(c * c - a1 * a1);
    }

    if (x2 > 0) {
        a2 = sqrt(h * h + x2 * x2);
        b2 = sqrt(c * c - a2 * a2);
    }

    // cout << a1 << ' ' << b1 << '\n';
    // cout << a2 << ' ' << b2 << '\n';

    if (a1 > 0 && b1 > 0) {
        if (a1 + b1 > c && a1 + c > b1 && b1 + c > a1) {
            return true;
        }
    }

    if (a2 > 0 && b2 > 0) {
        if (a2 + b2 > c && a2 + c > b2 && b2 + c > a2) {
            return true;
        }
    }

    return false;
}

int main() {
    double c, h;
    cin >> c >> h;
    if (check(c, h)) {
        cout << c * h / 2 << '\n';
    }
    else {
        cout << -1 << '\n';
    }
}
