
# Решение задачи "Натуральное деление" на Python

def find_numbers(n, digits):
    """
    Функция для поиска чисел a и b, соответствующих условиям задачи.
    
    :param n: Количество цифр после запятой.
    :param digits: Строка из n цифр, заданных в дробной части.
    :return: Строка с результатом ("NO" или "YES\na b").
    """
    fractional_part = int(digits)  # Преобразуем дробную часть в число
    denominator = 10 ** n          # Знаменатель
    
    for numerator in range(1, denominator):
        # Проверяем соответствие дроби, включая весь формат (0.XXX...)
        if round(numerator / denominator, n) == fractional_part / denominator:
            # Убедимся, что 0 < a < b < 10^6
            if numerator < denominator and denominator < 10**6:
                return f"YES\n{numerator} {denominator}"
    
    return "NO"

# Считывание входных данных
if __name__ == "__main__":
    n = int(input().strip())
    digits = input().strip()
    result = find_numbers(n, digits)
    print(result)

