def min_cuts(n, m, s):
    # Если s равен размеру всего листа, резать не нужно
    if s == n * m:
        return 0

    min_cuts_needed = float('inf')

    # Перебираем все возможные количества вертикальных и горизонтальных разрезов
    for x in range(n):
        for y in range(m):
            # Если текущие разрезы дают нужное количество клеток
            if (x + 1) * (y + 1) == s:
                min_cuts_needed = min(min_cuts_needed, x + y)
                
    # Проверяем, нашли ли мы решение
    return min_cuts_needed if min_cuts_needed != float('inf') else -1

# Чтение данных
n, m, s = map(int, input().split())

# Получение минимального количества разрезов
result = min_cuts(n, m, s)

# Вывод результата
if result == -1:
    print("NO")
else:
    print(result)

