from collections import defaultdict

# Ввод данных
n, q = map(int, input().split())

# Словари для хранения данных о рёбрах
color_connections = defaultdict(lambda: defaultdict(int))  # {color: {vertex: count}}
color_beauty = defaultdict(int)  # {color: total_edges}
is_superior = defaultdict(bool)  # {color: is_superior}
total_beauty = 0  # Суммарная красота графа

for _ in range(q):
    query = input().split()
    operation = query[0]
    v, u, c = map(int, query[1:])

    if v > u:
        v, u = u, v  # Упорядочиваем вершины для однозначности

    if operation == '+':
        # Если цвет c был превосходным, вычитаем его красоту
        if is_superior[c]:
            total_beauty -= color_beauty[c]

        # Добавляем ребро
        color_connections[c][v] += 1
        color_connections[c][u] += 1
        color_beauty[c] += 1

        # Пересчитываем превосходство цвета
        is_superior[c] = all(count <= 1 for count in color_connections[c].values())

        # Если цвет c превосходен, добавляем его красоту
        if is_superior[c]:
            total_beauty += color_beauty[c]

    elif operation == '-':
        # Если цвет c был превосходным, вычитаем его красоту
        if is_superior[c]:
            total_beauty -= color_beauty[c]

        # Удаляем ребро
        color_connections[c][v] -= 1
        color_connections[c][u] -= 1
        if color_connections[c][v] == 0:
            del color_connections[c][v]
        if color_connections[c][u] == 0:
            del color_connections[c][u]
        color_beauty[c] -= 1

        # Пересчитываем превосходство цвета
        is_superior[c] = all(count <= 1 for count in color_connections[c].values())

        # Если цвет c превосходен, добавляем его красоту
        if is_superior[c]:
            total_beauty += color_beauty[c]

    # Выводим текущую суммарную красоту
    print(total_beauty)
