#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <map>
using namespace std;

// Типы данных
using Connections = unordered_map<int, int>; // {vertex: count}
using ColorConnections = unordered_map<int, Connections>; // {color: {vertex: count}}

int main() {
    int n, q;
    cin >> n >> q;

    // Словари для хранения данных
    ColorConnections color_connections; // {color: {vertex: count}}
    unordered_map<int, int> color_beauty; // {color: total_edges}
    unordered_map<int, bool> is_superior; // {color: is_superior}
    long long total_beauty = 0; // Суммарная красота графа

    for (int i = 0; i < q; ++i) {
        char operation;
        int v, u, c;
        cin >> operation >> v >> u >> c;

        if (v > u) swap(v, u); // Упорядочиваем вершины для однозначности

        if (operation == '+') {
            // Если цвет c был превосходным, вычитаем его красоту
            if (is_superior[c]) {
                total_beauty -= color_beauty[c];
            }

            // Добавляем ребро
            color_connections[c][v]++;
            color_connections[c][u]++;
            color_beauty[c]++;

            // Пересчитываем превосходство цвета
            bool superior = true;
            for (auto &[vertex, count] : color_connections[c]) {
                if (count > 1) {
                    superior = false;
                    break;
                }
            }
            is_superior[c] = superior;

            // Если цвет c превосходен, добавляем его красоту
            if (is_superior[c]) {
                total_beauty += color_beauty[c];
            }

        } else if (operation == '-') {
            // Если цвет c был превосходным, вычитаем его красоту
            if (is_superior[c]) {
                total_beauty -= color_beauty[c];
            }

            // Удаляем ребро
            color_connections[c][v]--;
            color_connections[c][u]--;
            if (color_connections[c][v] == 0) {
                color_connections[c].erase(v);
            }
            if (color_connections[c][u] == 0) {
                color_connections[c].erase(u);
            }
            color_beauty[c]--;

            // Пересчитываем превосходство цвета
            bool superior = true;
            for (auto &[vertex, count] : color_connections[c]) {
                if (count > 1) {
                    superior = false;
                    break;
                }
            }
            is_superior[c] = superior;

            // Если цвет c превосходен, добавляем его красоту
            if (is_superior[c]) {
                total_beauty += color_beauty[c];
            }
        }

        // Выводим текущую суммарную красоту
        cout << total_beauty << "\n";
    }

    return 0;
}
