#include <iostream>
#include <unordered_map>
#include <unordered_set>
using namespace std;

// Типы данных
using Connections = unordered_map<int, int>; // {vertex: count}
using ColorConnections = unordered_map<int, Connections>; // {color: {vertex: count}}
using ProblematicVertices = unordered_map<int, unordered_set<int>>; // {color: {problematic_vertices}}

int main() {
    int n, q;
    cin >> n >> q;

    // Хранилища данных
    ColorConnections color_connections; // {color: {vertex: count}}
    unordered_map<int, int> color_beauty; // {color: total_edges}
    ProblematicVertices problematic_vertices; // {color: problematic_vertices}
    long long total_beauty = 0; // Суммарная красота графа

    for (int i = 0; i < q; ++i) {
        char operation;
        int v, u, c;
        cin >> operation >> v >> u >> c;

        if (v > u) swap(v, u); // Упорядочиваем вершины

        if (operation == '+') {
            // Увеличиваем количество связей для вершин
            if (++color_connections[c][v] == 2) {
                problematic_vertices[c].insert(v);
            } else if (color_connections[c][v] == 1) {
                problematic_vertices[c].erase(v);
            }

            if (++color_connections[c][u] == 2) {
                problematic_vertices[c].insert(u);
            } else if (color_connections[c][u] == 1) {
                problematic_vertices[c].erase(u);
            }

            // Увеличиваем количество рёбер цвета
            color_beauty[c]++;

            // Если цвет стал превосходным, добавляем его красоту
            if (problematic_vertices[c].empty()) {
                total_beauty += color_beauty[c];
            }

        } else if (operation == '-') {
            // Если цвет был превосходным, вычитаем его красоту
            if (problematic_vertices[c].empty()) {
                total_beauty -= color_beauty[c];
            }

            // Уменьшаем количество связей для вершин
            if (--color_connections[c][v] == 1) {
                problematic_vertices[c].erase(v);
            } else if (color_connections[c][v] == 0) {
                problematic_vertices[c].erase(v);
                color_connections[c].erase(v);
            }

            if (--color_connections[c][u] == 1) {
                problematic_vertices[c].erase(u);
            } else if (color_connections[c][u] == 0) {
                problematic_vertices[c].erase(u);
                color_connections[c].erase(u);
            }

            // Уменьшаем количество рёбер цвета
            color_beauty[c]--;

            // Если цвет стал превосходным, добавляем его красоту
            if (problematic_vertices[c].empty()) {
                total_beauty += color_beauty[c];
            }
        }

        // Выводим текущую суммарную красоту
        cout << total_beauty << "\n";
    }

    return 0;
}
