#include <iostream>
#include <map>
#include <set>
#include <vector>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;

    // Словарь для хранения рёбер по цветам
    map<int, set<pair<int, int>>> edges_by_color;

    // Множество вершин, соединённых рёбрами каждого цвета
    map<int, map<int, int>> color_connections;

    // Количество рёбер каждого цвета
    map<int, int> color_beauty;

    // Суммарная красота
    int total_beauty = 0;

    for (int i = 0; i < q; ++i) {
        char operation;
        int v, u, c;
        cin >> operation >> v >> u >> c;

        if (v > u) swap(v, u); // Упорядочиваем вершины для однозначности

        if (operation == '+') {
            // Добавляем ребро цвета c между вершинами v и u
            edges_by_color[c].insert({v, u});

            // Проверка, был ли цвет c превосходным до изменения
            bool is_superior_before = true;
            for (const auto& p : color_connections[c]) {
                if (p.second > 1) {
                    is_superior_before = false;
                    break;
                }
            }

            if (is_superior_before) {
                total_beauty -= color_beauty[c];
            }

            // Обновляем связи для вершин
            color_connections[c][v]++;
            color_connections[c][u]++;
            color_beauty[c]++;

            // Проверка, остался ли цвет c превосходным после изменения
            bool is_superior_after = true;
            for (const auto& p : color_connections[c]) {
                if (p.second > 1) {
                    is_superior_after = false;
                    break;
                }
            }

            if (is_superior_after) {
                total_beauty += color_beauty[c];
            }
        }
        else if (operation == '-') {
            // Удаляем ребро цвета c между вершинами v и u
            edges_by_color[c].erase({v, u});

            // Проверка, был ли цвет c превосходным до изменения
            bool is_superior_before = true;
            for (const auto& p : color_connections[c]) {
                if (p.second > 1) {
                    is_superior_before = false;
                    break;
                }
            }

            if (is_superior_before) {
                total_beauty -= color_beauty[c];
            }

            // Обновляем связи для вершин
            color_connections[c][v]--;
            color_connections[c][u]--;
            color_beauty[c]--;

            // Проверка, остался ли цвет c превосходным после изменения
            bool is_superior_after = true;
            for (const auto& p : color_connections[c]) {
                if (p.second > 1) {
                    is_superior_after = false;
                    break;
                }
            }

            if (is_superior_after) {
                total_beauty += color_beauty[c];
            }
        }

        // Печатаем текущую суммарную красоту после каждого запроса
        cout << total_beauty << endl;
    }

    return 0;
}