from collections import defaultdict

# Ввод данных
n, q = map(int, input().split())

# Структуры данных для хранения информации о вершинах и рёбрах
vertex_color_count = [defaultdict(int) for _ in range(n + 1)]
color_edge_count = defaultdict(int)
superior_color_beauty = defaultdict(int)

# Суммарная красота
total_beauty = 0

for _ in range(q):
    query = input().split()
    operation = query[0]
    v, u, c = map(int, query[1:])
    
    if operation == '+':
        # Добавляем ребро
        vertex_color_count[v][c] += 1
        vertex_color_count[u][c] += 1
        color_edge_count[c] += 1

        # Проверяем состояние цвета c до изменения
        if vertex_color_count[v][c] == 2 or vertex_color_count[u][c] == 2:
            if color_edge_count[c] > 1:
                total_beauty -= superior_color_beauty[c]
            superior_color_beauty[c] = 0
        else:
            if vertex_color_count[v][c] == 1 and vertex_color_count[u][c] == 1:
                superior_color_beauty[c] = color_edge_count[c]
                total_beauty += superior_color_beauty[c]

    elif operation == '-':
        # Удаляем ребро
        if vertex_color_count[v][c] == 1 and vertex_color_count[u][c] == 1:
            total_beauty -= superior_color_beauty[c]
            superior_color_beauty[c] = 0

        vertex_color_count[v][c] -= 1
        vertex_color_count[u][c] -= 1
        color_edge_count[c] -= 1

        # Проверяем состояние цвета c после изменения
        if vertex_color_count[v][c] == 1 and vertex_color_count[u][c] == 1:
            superior_color_beauty[c] = color_edge_count[c]
            total_beauty += superior_color_beauty[c]

    # Печатаем текущую суммарную красоту после каждого запроса
    print(total_beauty)
