from collections import defaultdict

# Ввод данных
n, q = map(int, input().split())

# Словарь для хранения рёбер по цветам (сортировка вершин для однозначности)
edges_by_color = defaultdict(set)

# Множество вершин, соединённых рёбрами каждого цвета
vertex_connections = [defaultdict(int) for _ in range(n + 1)]

# Количество рёбер каждого цвета
color_edges_count = defaultdict(int)

# Количество вершин с более чем одним соединением цвета
non_superior_colors = defaultdict(int)

# Суммарная красота
total_beauty = 0

for _ in range(q):
    query = input().split()
    operation = query[0]
    v, u, c = map(int, query[1:])
    if v > u:
        v, u = u, v  # Упорядочиваем вершины для однозначности

    if operation == '+':
        # Добавляем ребро цвета c между вершинами v и u
        edges_by_color[c].add((v, u))
        
        # Обновляем связи для вершин
        if vertex_connections[v][c] == 1:
            non_superior_colors[c] += 1
        if vertex_connections[u][c] == 1:
            non_superior_colors[c] += 1
        
        vertex_connections[v][c] += 1
        vertex_connections[u][c] += 1
        color_edges_count[c] += 1

        # Обновляем суммарную красоту
        if non_superior_colors[c] == 0:
            total_beauty += 1
        elif non_superior_colors[c] == 1:
            total_beauty -= 1

    elif operation == '-':
        # Удаляем ребро цвета c между вершинами v и u
        edges_by_color[c].remove((v, u))
        
        # Обновляем связи для вершин
        if vertex_connections[v][c] == 2:
            non_superior_colors[c] -= 1
        if vertex_connections[u][c] == 2:
            non_superior_colors[c] -= 1
        
        vertex_connections[v][c] -= 1
        vertex_connections[u][c] -= 1
        color_edges_count[c] -= 1

        # Обновляем суммарную красоту
        if non_superior_colors[c] == 0:
            total_beauty += 1
        elif non_superior_colors[c] == -1:
            total_beauty -= 1
            non_superior_colors[c] = 0

    # Печатаем текущую суммарную красоту после каждого запроса
    print(total_beauty)
