def find_pipeline_points(x1, y1, x2, y2, x3, y3):
    # Уравнение прямой через две точки: ax + by + c = 0
    def line_through_two_points(x1, y1, x2, y2):
        a = y2 - y1
        b = x1 - x2
        c = -(a * x1 + b * y1)
        return a, b, c

    # Вычисление расстояния от точки (x, y) до прямой ax + by + c = 0
    def distance_to_line(a, b, c, x, y):
        return abs(a * x + b * y + c) / (a ** 2 + b ** 2) ** 0.5

    # Перебираем все пары точек
    points = [(x1, y1), (x2, y2), (x3, y3)]
    min_distance = float("inf")
    best_line = None

    for i in range(3):
        for j in range(i + 1, 3):
            # Прямая через точки i и j
            a, b, c = line_through_two_points(points[i][0], points[i][1], points[j][0], points[j][1])

            # Суммарное расстояние от всех точек до прямой
            distance = 0
            for k in range(3):
                if k != i and k != j:
                    distance += distance_to_line(a, b, c, points[k][0], points[k][1])

            # Обновляем минимум
            if distance < min_distance:
                min_distance = distance
                best_line = (a, b, c, points[i], points[j])

    # Генерация двух точек с целыми координатами на прямой
    a, b, c, p1, p2 = best_line
    if a == 0:  # Горизонтальная прямая
        x1, x2 = -c // b, (-c + b) // b
        return x1, 0, x2, 1
    elif b == 0:  # Вертикальная прямая
        y1, y2 = -c // a, (-c + a) // a
        return 0, y1, 1, y2
    else:  # Общий случай
        return p1[0], p1[1], p2[0], p2[1]


# Чтение данных
x1, y1, x2, y2, x3, y3 = map(int, input().split())

# Вычисление
result = find_pipeline_points(x1, y1, x2, y2, x3, y3)

# Вывод результата
print(*result)

