#include <iostream>
#include <map>
#include <bitset>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;

    map<int, map<pair<int, int>, bool>> graph;
    map<int, bitset<100005>> degree; //  bitset  

    auto is_excellent = [&](int color) {
        return degree.count(color) == 0 || degree[color].count() <= 1; // 
    };

    auto calculate_total_beauty = [&]() {
        long long total_beauty = 0;
        for (auto const& [color, edges] : graph) {
            if (is_excellent(color)) {
                total_beauty += edges.size();
            }
        }
        return total_beauty;
    };

    for (int i = 0; i < q; ++i) {
        char op;
        int u, v, c;
        cin >> op >> u >> v >> c;
        pair<int, int> edge = {min(u, v), max(u, v)};

        if (op == '+') {
            graph[c][edge] = true;
            degree[c][u -1] = degree[c][u-1] + 1; //   0
            degree[c][v -1] = degree[c][v-1] + 1;
        } else {
            graph[c].erase(edge);
            degree[c][u -1] = degree[c][u-1] - 1;
            degree[c][v -1] = degree[c][v-1] - 1;

            if (degree[c][u -1] == 0) {
                degree[c].reset(u-1);
            }
            if (degree[c][v -1] == 0) {
                degree[c].reset(v-1);
            }
            if (graph[c].empty()) {
                graph.erase(c);
                degree.erase(c);
            }
        }
        cout << calculate_total_beauty() << endl;
    }

    return 0;
}

