#include <iostream>
#include <map>
#include <set>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, q;
    cin >> n >> q;

    map<int, map<pair<int, int>, bool>> graph;
    map<int, map<int, int>> degree;

    auto is_excellent = [&](int color) {
        if (degree.find(color) == degree.end()) {
            return true;
        }
        for (auto const& [node, deg] : degree[color]) {
            if (deg > 1) {
                return false;
            }
        }
        return true;
    };

    auto calculate_total_beauty = [&]() {
        long long total_beauty = 0;
        for (auto const& [color, edges] : graph) {
            if (is_excellent(color)) {
                total_beauty += edges.size();
            }
        }
        return total_beauty;
    };

    for (int i = 0; i < q; ++i) {
        char op;
        int u, v, c;
        cin >> op >> u >> v >> c;
        pair<int, int> edge = make_pair(min(u, v), max(u, v));

        if (op == '+') {
            graph[c][edge] = true;
            degree[c][u] = degree[c].count(u) ? degree[c][u] + 1 : 1;
            degree[c][v] = degree[c].count(v) ? degree[c][v] + 1 : 1;
        } else {
            graph[c].erase(edge);
            degree[c][u]--;
            degree[c][v]--;
            if (degree[c][u] == 0) {
                degree[c].erase(u);
            }
            if (degree[c][v] == 0) {
                degree[c].erase(v);
            }
            if (graph[c].empty()) {
                graph.erase(c);
                degree.erase(c);
            }
        }
        cout << calculate_total_beauty() << endl;
    }

    return 0;
}
