#include <iostream>
#include <map>
#include <vector>
#include <string>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;

    map<int, map<pair<int, int>, bool>> graph;
    map<int, map<int, int>> degree;

    auto is_excellent = [&](int color) {
        if (degree.find(color) == degree.end()) {
            return true;
        }
        for (const auto& count : degree[color]) {
            if (count.second > 1) {
                return false;
            }
        }
        return true;
    };

    auto calculate_total_beauty = [&]() {
        int total_beauty = 0;
        for (const auto& color : graph) {
            if (is_excellent(color.first)) {
                total_beauty += graph[color.first].size();
            }
        }
        return total_beauty;
    };

    for (int i = 0; i < q; ++i) {
        string op;
        int u, v, c;
        cin >> op >> u >> v >> c;
        u = min(u, v);
        v = max(u, v);

        if (op == "+") {
            if (graph.find(c) == graph.end()) {
                graph[c] = {};
                degree[c] = {};
            }
            graph[c][make_pair(u, v)] = true;
            degree[c][u] += 1;
            degree[c][v] += 1;
        } else {
            graph[c].erase(make_pair(u, v));
            degree[c][u] -= 1;
            degree[c][v] -= 1;
            if (degree[c][u] == 0) {
                degree[c].erase(u);
            }
            if (degree[c][v] == 0) {
                degree[c].erase(v);
            }
            if (graph[c].empty()) {
                graph.erase(c);
                degree.erase(c);
            }
        }

        cout << calculate_total_beauty() << endl;
    }

    return 0;
}
