#include <iostream> 
#include <map> 
#include <vector> 
#include <set> 
 
 
 
struct MapWithStates 
{ 
    int counter = 0; 
    std::map<int, int> dict; 
    std::set<int> imperfectNodes; 
 
 
    void add(int u, int v) 
    { 
        if (dict.find(u) != dict.end()) 
            dict[u]++; 
        else 
            dict[u] = 1; 
 
        if (dict.find(v) != dict.end()) 
            dict[v]++; 
        else 
            dict[v] = 1; 
 
        if (dict[u] > 1) 
            imperfectNodes.insert(u); 
        if (dict[v] > 1) 
            imperfectNodes.insert(v); 
        counter++; 
    } 
 
    void del(int u, int v) 
    { 
        dict[u]--; 
        dict[v]--; 
        if (dict[u] <= 1 && imperfectNodes.find(u) != imperfectNodes.end()) 
            imperfectNodes.erase(u); 
        if (dict[v] <= 1 && imperfectNodes.find(v) != imperfectNodes.end()) 
            imperfectNodes.erase(v); 
        counter--; 
    } 
 
    bool isPerfect() 
    { 
        return (imperfectNodes.empty()) ? true : false; 
    } 
 
    int getNumberOfNodes() 
    { 
        return counter; 
    } 
 
}; 
 
 
int main() 
{ 
    int n, q; 
    int ans = 0; 
    std::cin >> n >> q; 
 
 
    std::vector<MapWithStates> colors(1e5); 
    std::vector<bool> isPreviouslyPerfect(1e5, true); 
 
    while (q--) 
    { 
        char oper; 
        int u, v, c; 
        std::cin >> oper >> u >> v >> c; 
        if (oper == '+') 
        { 
            colors[c].add(u, v); 
            if (colors[c].isPerfect()) 
                ans++; 
            else if (!colors[c].isPerfect() && isPreviouslyPerfect[c]) 
            { 
                ans++; 
                ans -= colors[c].getNumberOfNodes(); 
                isPreviouslyPerfect[c] = false; 
            } 
        } 
        else 
        { 
            colors[c].del(u, v); 
 
            if (colors[c].isPerfect() && !isPreviouslyPerfect[c]) 
            { 
                ans += colors[c].getNumberOfNodes(); 
                isPreviouslyPerfect[c] = true; 
            } 
        } 
 
        std::cout << ans << '\n'; 
    } 
 
 
    return 0; 
}