#include <stdio.h>
#include <stdlib.h>

#define MAXN 100005

int n;
int ai[MAXN], bi[MAXN];
int indices[MAXN], min_ab[MAXN];
int flipped[MAXN];
int result_first[MAXN], result_second[MAXN];

int compare(const void *a, const void *b) {
    int idxA = *(int *)a;
    int idxB = *(int *)b;
    if (min_ab[idxA] != min_ab[idxB])
        return min_ab[idxA] - min_ab[idxB];
    else return idxA - idxB;
}

int main() {
    scanf("%d", &n);

    for (int i = 0; i < n; i++) {
        scanf("%d", &ai[i]);
    }
    for (int i = 0; i < n; i++) {
        scanf("%d", &bi[i]);
    }

    for (int i = 0; i < n; i++) {
        indices[i] = i;
        min_ab[i] = (ai[i] < bi[i]) ? ai[i] : bi[i];
    }

    qsort(indices, n, sizeof(int), compare);

    long long prev_first = -1e18, prev_second = -1e18;

    for (int i = 0; i < n; i++) {
        int idx = indices[i];
        int a = ai[idx];
        int b = bi[idx];
        int option1_first = a, option1_second = b;
        int option2_first = b, option2_second = a;
        int can_option1 = 0, can_option2 = 0;

        if (option1_first >= prev_first && option1_second >= prev_second) {
            can_option1 = 1;
        }
        if (option2_first >= prev_first && option2_second >= prev_second) {
            can_option2 = 1;
        }

        if (can_option1 && can_option2) {
            if (option1_first <= option2_first) {
                flipped[idx] = 0;
                prev_first = option1_first;
                prev_second = option1_second;
                result_first[i] = option1_first;
                result_second[i] = option1_second;
            } else {
                flipped[idx] = 1;
                prev_first = option2_first;
                prev_second = option2_second;
                result_first[i] = option2_first;
                result_second[i] = option2_second;
            }
        } else if (can_option1) {
            flipped[idx] = 0;
            prev_first = option1_first;
            prev_second = option1_second;
            result_first[i] = option1_first;
            result_second[i] = option1_second;
        } else if (can_option2) {
            flipped[idx] = 1;
            prev_first = option2_first;
            prev_second = option2_second;
            result_first[i] = option2_first;
            result_second[i] = option2_second;
        } else {
            printf("-1\n");
            return 0;
        }
    }

    for (int i = 0; i < n; i++) {
        printf("%d", result_first[i]);
        if (i < n - 1) printf(" ");
    }
    printf("\n");
    for (int i = 0; i < n; i++) {
        printf("%d", result_second[i]);
        if (i < n - 1) printf(" ");
    }
    printf("\n");

    return 0;
}