#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
#define int long long
//@formatter:on
//region queue
using ld = long double;

struct Point {
      ld x, y;

      Point() : x(0), y(0) {};

      Point(ld x, ld y) : x(x), y(y) {};

      Point(double x1, double y1, double x2, double y2) : x(x2 - x1), y(y2 - y1) {};

      Point(Point start, Point end) : x(end.x - start.x), y(end.y - start.y) {};

      void read() {
            Point a, b;
            cin >> a >> b;
            *this = Point(a, b);
      }

      long long len() { return 1ll * x * x + 1ll * y * y; }

      long double lenf() { return sqrtl(1ll * x * x + 1ll * y * y); }

      friend istream &operator>>(istream &is, Point &a) {
            is >> a.x >> a.y;
            return is;
      }

      friend ostream &operator<<(ostream &os, Point a) {
            os << a.x << " " << a.y;
            return os;
      }

      friend bool operator==(Point a, Point b) {
            return a.x == b.x && a.y == b.y;
      }

      friend Point operator+(Point a, Point b) { return Point(a.x + b.x, a.y + b.y); }

      friend Point operator-(Point a, Point b) { return Point(a.x - b.x, a.y - b.y); }

      friend Point operator/(Point a, double b) { return Point(a.x / b, a.y / b); }

      friend long long operator*(Point a, Point b) { return 1ll * a.x * b.x + 1ll * a.y * b.y; }

      friend Point operator*(Point a, double b) { return Point(a.x * b, a.y * b); }

      friend long long operator%(Point a, Point b) { return 1ll * a.x * b.y - 1ll * a.y * b.x; }
};


int sign(ld x) {
      if (x == 0) return 0;
      if (x > 0) return 1;
      if (x < 0) return -1;
      return 0;
}

struct Circle {
      Point start;
      int r;
};
using ld = long double;

vector<Point> intersect(Circle a, Circle b) {
      int xa = a.start.x, ya = a.start.y;
      int xb = b.start.x, yb = b.start.y;
      int ra = a.r, rb = b.r;

      if (a.start == b.start) {
            if (a.r == b.r) {
                  return {{0, 0},
                          {0, 0},
                          {0, 0}};
            }
            return {};
      }
      int A = 2 * xa - 2 * xb;
      int B = 2 * ya - 2 * yb;
      int C = xb * xb + yb * yb - rb * rb - xa * xa - ya * ya + ra * ra;
      ld h = abs(A * xa + B * ya + C) / sqrtl(A * A + B * B);
      if (sign(h - ra) > 0) {
            return {};
      } else if (sign(h - ra) == 0) {
            int nx = A, ny = B;
            ld len = sqrtl(A * A + B * B);
            ld _nx = (ld) nx / len * h;
            ld _ny = (ld) ny / len * h;
            ld sx, sy;
            if (sign(A * (xa - _nx) + B * (ya - _ny) + C) == 0) {
                  sx = xa - _nx;
                  sy = ya - _ny;
            } else {
                  sx = xa + _nx;
                  sy = ya + _ny;
            }
            return {{sx, sy}};
      } else {
            int nx = A, ny = B;
            ld len = sqrtl(A * A + B * B);
            ld _nx = (ld) nx / len * h;
            ld _ny = (ld) ny / len * h;
            ld sx, sy;
            if (sign(A * (xa - _nx) + B * (ya - _ny) + C) == 0) {
                  sx = xa - _nx;
                  sy = ya - _ny;
            } else {
                  sx = xa + _nx;
                  sy = ya + _ny;
            }
            int ux = -B, uy = A;
            ld len3 = hypotl(ux, uy);
            ld len2 = sqrtl(ra * ra - h * h);
            ld _ux = ux / len3 * len2, _uy = uy / len3 * len2;

            return {
                    {sx + _ux, sy + _uy},
                    {sx - _ux, sy - _uy}
            };
      }
}

random_device rd;
mt19937 rnd(rd());

ll rand(int l, int r) { return uniform_int_distribution<int>(l, r)(rnd); }

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(0);
#endif

      Point s, e;
      cin >> s >> e;

      int n;
      cin >> n;

      vector<pair<ll, int>> aold(n);
      for (int i = 0; i < n; ++i) {
            cin >> aold[i].first;
            aold[i].second = i;
      }


      auto solve = [&](vector<pair<ll, ll>> a) {
            Circle start(s, 0);
            ll sum = 0;
            for (int i = 0; i < n; ++i) {
                  sum += a[i].first;
            }
            Circle end(e, sum);
            for (int i = -1; i < n; ++i) {
                  if (i >= 0) {
                        start.r += a[i].first;
                        end.r -= a[i].first;
                  }

                  if (intersect(start, end).size()) {
                        cout << "Possible" << "\n";
                        vector<double> tn(n);
                        Point p = intersect(start, end)[0];
                        ld tn1 = atan2(p.y - s.y, p.x - s.x);
                        ld tn2 = atan2(e.y - p.y, e.x - p.x);
                        for (int j = 0; j <= i; ++j) {
                              tn[a[j].second] = tn1;
                        }
                        for (int j = i + 1; j < n; ++j) {
                              tn[a[j].second] = tn2;
                        }

                        ld x = s.x, y = s.y;
                        cout << fixed << setprecision(18);
                        for (int j = 0; j < n; ++j) {
                              x += aold[j].first * cos(tn[j]);
                              y += aold[j].first * sin(tn[j]);
                              cout << x << " " << y << "\n";
                        }

                        exit(0);
                  }
            };
      };

      auto anew = aold;
      std::sort(anew.begin(), anew.end());
      solve(anew);
      for (int i = 0; i < 100; ++i) {
            std::shuffle(anew.begin(), anew.end(), rnd);
            solve(anew);
      }

      cout << "Impossible" << "\n";
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
      for (int i = 0; i < a.size(); i++)
            os << a[i] << " \n"[i == a.size() - 1];
      return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
      for (auto &i: a)
            is >> i;
      return is;
}
// endregion