#include <iostream>
#include <vector>
#include <iomanip>
const long long inf = 1e18;
using pair = std::pair<long long, long long>;
struct line {
    long long k, b;
    line() {}
    line(long long _k, long long _b) {
        k = _k;
        b = _b; 
    }
    long long  get(long long x) {
        return k*x + b;
    }
};
std::vector<line> lines;
std::vector<long long> dots;
long long cross(line a, line b) { 
    long long x = (b.b - a.b) / (a.k - b.k);
    if (b.b < a.b) x--;
    return x;
}
void add(line cur) {
    while (lines.size() && lines.back().get(dots.back()) > cur.get(dots.back())) {
        lines.pop_back();
        dots.pop_back();
    }
    if (lines.empty()) {
        dots.push_back(-inf);
    } else {
        dots.push_back(cross(lines.back(), cur));
    }
    lines.push_back(cur);
}
long long get(long long x) {
    long long pos = std::lower_bound(dots.begin(), dots.end(), x) - dots.begin() - 1;
    return lines[pos].get(x);
}
int main() {
    std::cin.tie(0);
    std::cout.tie(0);
    std::ios_base::sync_with_stdio(false);
    long long n, m, c, i;
    std::cin >> n >> m >> c;
    std::vector<pair> a(n + 2);
    a.front() = pair{0, 0};
    a.back() = pair{m, 0};
    for(i = 1; i <= n; ++i) {
        std::cin >> a[i].first >> a[i].second;
    }
    std::vector<long long> dp(n + 2, 0);
    line l(0, 0);
    add(l);
    for(i = 1; i < n+2; ++i) {
        dp[i] = get(a[i].first) + a[i].first*a[i].first + a[i].second*c;
        l.k = -2.0*a[i].first;
        l.b = dp[i] + a[i].first*a[i].first;
        add(l);
    }
    double ans = dp.back()*1.0/c;
    std::cout << std::fixed << std::setprecision(6) << ans << '\n';
}