def calculate_distance(A, B, C, x, y):
    return abs(A * x + B * y + C) / (A**2 + B**2)**0.5

def find_best_line(x1, y1, x2, y2, x3, y3):
    points = [(x1, y1), (x2, y2), (x3, y3)]
    min_distance = float('inf')
    best_line_points = None
    for i in range(3):
        for j in range(i + 1, 3):
            x_a, y_a = points[i]
            x_b, y_b = points[j]
            A = y_b - y_a
            B = x_a - x_b
            C = x_b * y_a - x_a * y_b
            total_distance = 0
            for k in range(3):
                if k != i and k != j:
                    x_k, y_k = points[k]
                    total_distance += calculate_distance(A, B, C, x_k, y_k)
            if total_distance < min_distance:
                min_distance = total_distance
                best_line_points = (x_a, y_a, x_b, y_b)

    return best_line_points



x1, y1, x2, y2, x3, y3 = map(int, input().split())
x_a, y_a, x_b, y_b = find_best_line(x1, y1, x2, y2, x3, y3)
print(x_a, y_a, x_b, y_b)
