#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Card {
    int front, back;
};

bool solve(int n, const vector<int>& a, const vector<int>& b) {
    vector<Card> cards(n);
    for (int i = 0; i < n; ++i) {
        cards[i] = {a[i], b[i]};
    }

    sort(cards.begin(), cards.end(), [](const Card& c1, const Card& c2) {
        return min(c1.front, c1.back) < min(c2.front, c2.back);
    });

    vector<int> top, bottom;
    int topLast = 0, bottomLast = 0;

    for (const auto& card : cards) {
        if (card.front >= topLast && card.back >= bottomLast) {
            top.push_back(card.front);
            bottom.push_back(card.back);
            topLast = card.front;
            bottomLast = card.back;
        } else if (card.back >= topLast && card.front >= bottomLast) {
            top.push_back(card.back);
            bottom.push_back(card.front);
            topLast = card.back;
            bottomLast = card.front;
        } else {
            return false;
        }
    }

    for (int year : top) {
        cout << year << " ";
    }
    cout << endl;
    for (int year : bottom) {
        cout << year << " ";
    }
    cout << endl;

    return true;
}

int main() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    if (!solve(n, a, b)) {
        cout << -1 << endl;
    }

    return 0;
}