#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Card {
    int front, back;
};

bool solve(int n, const vector<int>& a, const vector<int>& b) {
    vector<Card> cards(n);
    for (int i = 0; i < n; ++i) {
        cards[i] = {a[i], b[i]};
    }

    vector<int> t, bot;
    int topLast = 0, botLast = 0;

    for (const auto& card : cards) {
        if (card.front >= topLast && card.back >= botLast) {
            t.push_back(card.front);
            bot.push_back(card.back);
            topLast = card.front;
            botLast = card.back;
        } else if (card.back >= topLast && card.front >= botLast) {
            t.push_back(card.back);
            bot.push_back(card.front);
            topLast = card.back;
            botLast = card.front;
        } else {
            return false;
        }
    }

    for (int y : t) {
        cout << y << " ";
    }
    cout << endl;
    for (int y : bot) {
        cout << y << " ";
    }
    cout << endl;

    return true;
}

int main() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n;i++) {
        cin >> b[i];
    }

    if (!solve(n, a, b)) {
        cout << -1 << endl;
    }

    return 0;
}