use std::io::{self, BufRead};

#[derive(Debug)]
struct O {
    f: i64,
    b: i64,
    i: usize,
    fl: bool,
}

fn main() {
    let stdin = io::stdin();
    let mut lines = stdin.lock().lines();
    
    let n: usize = lines.next().unwrap().unwrap().trim().parse().unwrap();
    let a: Vec<i64> = lines.next().unwrap().unwrap().split_whitespace().map(|s| s.parse().unwrap()).collect();
    let b: Vec<i64> = lines.next().unwrap().unwrap().split_whitespace().map(|s| s.parse().unwrap()).collect();

    let mut opts = Vec::new();
    for j in 0..n {
        opts.push(O { f: a[j], b: b[j], i: j, fl: false });
        if a[j] != b[j] {
            opts.push(O { f: b[j], b: a[j], i: j, fl: true });
        }
    }

    opts.sort_by(|x, y| {
        if x.f != y.f {
            x.f.cmp(&y.f)
        } else {
            x.b.cmp(&y.b)
        }
    });

    let mut u = vec![false; n];
    let mut fs = Vec::new();
    let mut bs = Vec::new();
    let mut fl = vec![false; n];

    let mut pb = -1;
    let mut c = 0;

    for o in &opts {
        if !u[o.i] && o.b >= pb {
            u[o.i] = true;
            fs.push(o.f);
            bs.push(o.b);
            fl[o.i] = o.fl;
            pb = o.b;
            c += 1;
            if c == n {
                break;
            }
        }
    }

    if c < n {
        println!("-1");
        return;
    }

    let mut rf = vec![0; n];
    let mut rb = vec![0; n];
    for j in 0..n {
        let idx = opts[j].i;
        if fl[idx] {
            rf[j] = b[idx];
            rb[j] = a[idx];
        } else {
            rf[j] = a[idx];
            rb[j] = b[idx];
        }
    }

    for j in 0..n {
        print!("{}{}", rf[j], if j == n - 1 { "\n" } else { " " });
    }
    for j in 0..n {
        print!("{}{}", rb[j], if j == n - 1 { "\n" } else { " " });
    }
}