#include <iostream> 
#include <vector> 
#include <algorithm> 
#include <limits> 
 
bool canFormTarget(const std::vector<int>& areas, int s) { 
    std::vector<bool> dp(s + 1, false); 
    dp[0] = true; 
 
    for (int area : areas) { 
        for (int i = s; i >= area; --i) { 
            dp[i] = dp[i] || dp[i - area]; 
        } 
    } 
 
    return dp[s]; 
} 
 
int minCuts(int n, int m, int s) { 
    if (s == n * m) { 
        return 0; 
    } 
 
    int minCuts = std::numeric_limits<int>::max(); 
 
    for (int x = 0; x < n; ++x) { 
        int rows = x + 1; 
        std::vector<int> rowHeights(rows); 
        for (int i = 0; i < rows; ++i) { 
            rowHeights[i] = n / rows + (i < n % rows ? 1 : 0); 
        } 
 
        for (int y = 0; y < m; ++y) { 
            int cols = y + 1; 
            std::vector<int> colWidths(cols); 
            for (int j = 0; j < cols; ++j) { 
                colWidths[j] = m / cols + (j < m % cols ? 1 : 0); 
            } 
 
            std::vector<int> areas; 
            for (int row : rowHeights) { 
                for (int col : colWidths) { 
                    areas.push_back(row * col); 
                } 
            } 
 
            if (canFormTarget(areas, s)) { 
                minCuts = std::min(minCuts, rows - 1 + cols - 1); 
            } 
        } 
    } 
 
    return minCuts == std::numeric_limits<int>::max() ? -1 : minCuts; 
} 
 
int main() { 
    int n, m, s; 
    std::cin >> n >> m >> s; 
    std::cout << minCuts(n, m, s) << std::endl; 
    return 0; 
}