#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

void solve_galactic_timeline(int n, vector<int>& a, vector<int>& b) {
    vector<pair<int, int>> cards;
    for (int i = 0; i < n; ++i) {
        cards.emplace_back(a[i], b[i]);
    }

    sort(cards.begin(), cards.end(), [](pair<int, int>& x, pair<int, int>& y) {
        return make_pair(min(x.first, x.second), max(x.first, x.second)) < 
               make_pair(min(y.first, y.second), max(y.first, y.second));
    });

    vector<int> top_sequence;
    vector<int> bottom_sequence;

    for (auto& card : cards) {
        int min_val = min(card.first, card.second);
        int max_val = max(card.first, card.second);

        if (top_sequence.empty() || top_sequence.back() <= min_val) {
            top_sequence.push_back(min_val);
            bottom_sequence.push_back(max_val);
        } else if (top_sequence.empty() || top_sequence.back() <= max_val) {
            top_sequence.push_back(max_val);
            bottom_sequence.push_back(min_val);
        } else {
            cout << -1 << endl;
            return;
        }
    }

    for (int i = 1; i < bottom_sequence.size(); ++i) {
        if (bottom_sequence[i] < bottom_sequence[i - 1]) {
            cout << -1 << endl;
            return;
        }
    }

    for (int x : top_sequence) cout << x << " ";
    cout << endl;
    for (int x : bottom_sequence) cout << x << " ";
    cout << endl;
}

int main() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    solve_galactic_timeline(n, a, b);
    return 0;
}