#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

// Функция для вычисления расстояния от точки до прямой
double distance_to_line(int x, int y, int A, int B, int C) {
    return abs(A * x + B * y + C) / sqrt(A * A + B * B);
}

// Функция для нахождения уравнения прямой через две точки
void line_from_points(int x1, int y1, int x2, int y2, int &A, int &B, int &C) {
    A = y2 - y1;
    B = x1 - x2;
    C = x2 * y1 - x1 * y2;
}

// Функция для нахождения минимальной суммы расстояний до прямой
void total_distance(int x1, int y1, int x2, int y2, int x3, int y3, int &A, int &B, int &C) {
    double best_distance = 1e9;
    
    // Прямая через точки (x1, y1) и (x2, y2)
    int A1, B1, C1;
    line_from_points(x1, y1, x2, y2, A1, B1, C1);
    double dist = distance_to_line(x1, y1, A1, B1, C1) +
                  distance_to_line(x2, y2, A1, B1, C1) +
                  distance_to_line(x3, y3, A1, B1, C1);
    if (dist < best_distance) {
        best_distance = dist;
        A = A1;
        B = B1;
        C = C1;
    }
    
    // Прямая через точки (x1, y1) и (x3, y3)
    line_from_points(x1, y1, x3, y3, A1, B1, C1);
    dist = distance_to_line(x1, y1, A1, B1, C1) +
           distance_to_line(x2, y2, A1, B1, C1) +
           distance_to_line(x3, y3, A1, B1, C1);
    if (dist < best_distance) {
        best_distance = dist;
        A = A1;
        B = B1;
        C = C1;
    }
    
    // Прямая через точки (x2, y2) и (x3, y3)
    line_from_points(x2, y2, x3, y3, A1, B1, C1);
    dist = distance_to_line(x1, y1, A1, B1, C1) +
           distance_to_line(x2, y2, A1, B1, C1) +
           distance_to_line(x3, y3, A1, B1, C1);
    if (dist < best_distance) {
        best_distance = dist;
        A = A1;
        B = B1;
        C = C1;
    }
}

// Функция для нахождения двух точек на прямой
void find_two_points_on_line(int A, int B, int C, int &x1, int &y1, int &x2, int &y2) {
    // Находим первую точку, подставив x=0, получим y
    if (B != 0) {
        y1 = -C / B;
        x1 = 0;
    } else {
        // Если B = 0, то можно подставить y=0, чтобы найти x
        x1 = -C / A;
        y1 = 0;
    }
    
    // Находим вторую точку, подставив x = 1 (или любое другое значение)
    if (B != 0) {
        y2 = (-A * 1 - C) / B;
        x2 = 1;
    } else {
        x2 = 0;
        y2 = -C / A;
    }
}

int main() {
    // Ввод данных
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    // Вычисление лучшей прямой
    int A, B, C;
    total_distance(x1, y1, x2, y2, x3, y3, A, B, C);

    // Нахождение двух точек на найденной прямой
    int x1_point, y1_point, x2_point, y2_point;
    find_two_points_on_line(A, B, C, x1_point, y1_point, x2_point, y2_point);

    // Вывод результатов
    cout << x1_point << " " << y1_point << endl;
    cout << x2_point << " " << y2_point << endl;

    return 0;
}