#include <iostream>
#include <string>

using namespace std;

// Function to find GCD of two numbers
long long gcd(long long a, long long b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int main() {
    int n;
    string digits;
    
    cin >> n;
    cin >> digits;
    
    // Convert decimal string to numerator
    long long num = 0;
    for(char d : digits) {
        num = num * 10 + (d - '0');
    }
    
    // Calculate denominator (10^n)
    long long denom = 1;
    for(int i = 0; i < n; i++) {
        denom *= 10;
    }
    
    // Find GCD to reduce the fraction
    long long g = gcd(num, denom);
    num /= g;
    denom /= g;
    
    // Check if this creates a valid fraction
    if(num < denom && num > 0) {
        cout << "YES\n" << num << " " << denom << endl;
        return 0;
    }
    
    cout << "NO\n";
    return 0;
}