#include <iostream>
#include <cmath>

using namespace std;

int main() {
    int c, h;
    cin >> c >> h;
    
    if (c < 1 || c > 10000 || h < 1 || h > 10000) {
        cout << -1;
        return 0;
    }
    
    if (h > c) {
        cout << -1;
        return 0;
    }
	double baseSquared = c*c - h*h;  // using Pythagorean theorem
    
    if (baseSquared <= 0) {
        cout << -1;
        return 0;
    }
    
    double base = sqrt(baseSquared);
    

    double discriminant = c*c - 4*h*h;
    if (discriminant < 0) {
        cout << -1;
        return 0;
    }
    
    double x1 = (c + sqrt(discriminant)) / 2;
    double x2 = (c - sqrt(discriminant)) / 2;
    
    if (x1 <= 0 || x2 <= 0 || fabs(x1 + x2 - c) > 1e-10) {
        cout << -1;
        return 0;
    }
    
    double area = (c * h) / 2.0;
    cout << area;
    
    return 0;
}