#include <iostream>
#include <cmath>
#include <iomanip>

using namespace std;

int main() {
    int c, h;
    cin >> c >> h;
    
    // Check input constraints (1 ≤ c,h ≤ 10^4)
    if (c < 1 || c > 10000 || h < 1 || h > 10000) {
        cout << -1 << endl;
        return 0;
    }
    
    // Calculate discriminant: D = c^2 - 4h^2
    long long discriminant = (long long)c*c - 4LL*(long long)h*h;
    
    // If discriminant < 0, no real roots exist
    // If discriminant ≥ 0, triangle can exist
    if (discriminant < 0) {
        cout << -1 << endl;
    } else {
        double area = (c * h) / 2.0;
        cout << fixed << setprecision(1) << area << endl;
    }
    
    return 0;
}