#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    
    int n;
    cin >> n;
    
    // Считываем входные данные
    vector<pair<long long, long long>> cards(n);
    for(int i = 0; i < n; i++) {
        cin >> cards[i].first;
    }
    for(int i = 0; i < n; i++) {
        cin >> cards[i].second;
    }
    
    // Для каждой карты оставляем минимальное значение спереди
    for(int i = 0; i < n; i++) {
        if(cards[i].first > cards[i].second) {
            swap(cards[i].first, cards[i].second);
        }
    }
    
    // Сортируем карты по значению на лицевой стороне
    sort(cards.begin(), cards.end());
    
    // Проверяем, можно ли построить возрастающую последовательность
    bool possible = true;
    long long prev_front = 0, prev_back = 0;
    
    for(int i = 0; i < n; i++) {
        if(cards[i].first <= prev_front || cards[i].second <= prev_back) {
            possible = false;
            break;
        }
        prev_front = cards[i].first;
        prev_back = cards[i].second;
    }
    
    if(!possible) {
        cout << "-1\n";
        return 0;
    }
    
    // Выводим результат
    for(int i = 0; i < n; i++) {
        cout << cards[i].first << (i == n-1 ? '\n' : ' ');
    }
    for(int i = 0; i < n; i++) {
        cout << cards[i].second << (i == n-1 ? '\n' : ' ');
    }
    
    return 0;
}