#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
    int n;
    cin >> n;

    vector<int> front(n), back(n);

    // Input the front and back years
    for (int i = 0; i < n; i++) {
        cin >> back[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> front[i];
    }

    vector<pair<int, int>> cards(n);

    // Store cards as pairs
    for (int i = 0; i < n; i++) {
        cards[i] = {front[i], back[i]};
    }

    // Sort cards by the minimum of their two sides
    sort(cards.begin(), cards.end(), [](const pair<int, int>& a, const pair<int, int>& b) {
        return min(a.first, a.second) < min(b.first, b.second);
    });

    vector<int> top, bottom;

    // Try to construct both sides
    int prevTop = -1, prevBottom = -1;
    for (int i = 0; i < n; i++) {
        int frontSide = cards[i].first;
        int backSide = cards[i].second;

        if (frontSide >= prevTop && backSide >= prevBottom) {
            // No flipping needed
            top.push_back(frontSide);
            bottom.push_back(backSide);
            prevTop = frontSide;
            prevBottom = backSide;
        } else if (backSide >= prevTop && frontSide >= prevBottom) {
            // Flip the card
            top.push_back(backSide);
            bottom.push_back(frontSide);
            prevTop = backSide;
            prevBottom = frontSide;
        } else {
            // Not possible to construct the timeline
            cout << -1 << endl;
            return 0;
        }
    }

    // Output the solution
    for (int i = 0; i < n; i++) {
        cout << top[i] << " ";
    }
    cout << endl;

    for (int i = 0; i < n; i++) {
        cout << bottom[i] << " ";
    }
    cout << endl;

    return 0;
}
