#include <iostream>
#include <string>
#include <algorithm>
using namespace std;

// Функция для вычисления НОД для больших чисел
int computeGCD(long long a, long long b) {
    while (b != 0) {
        long long temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

string bigIntMod(const string& num, long long m) {
    long long result = 0;
    for (char digit : num) {
        result = (result * 10 + (digit - '0')) % m;
    }
    return to_string(result);
}

int main() {
    int n;
    string digits;
    cin >> n >> digits;

    // Число a - это число, представленных в строке digits
    string a = digits;
    
    // Число b - это 10^n
    string b = "1" + string(n, '0');
    
    // Вычисление НОД через строковое представление для 10^n
    long long gcd = computeGCD(stoll(a), stoll(b));
    
    // Преобразуем числа a и b к минимальному виду через НОД
    a = to_string(stoll(a) / gcd);
    b = to_string(stoll(b) / gcd);

    if (stoll(a) < stoll(b) && stoll(b) < 1000000) {
        cout << "YES" << endl;
        cout << a << " " << b << endl;
    } else {
        cout << "NO" << endl;
    }

    return 0;
}
