#include <iostream>
#include <string>
using namespace std;

// Функция для вычисления НОД через остатки
int computeGCD(long long a, long long b) {
    while (b != 0) {
        long long temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

// Функция для нахождения остатка от деления большого числа на m
long long bigIntMod(const string& num, long long m) {
    long long result = 0;
    for (char digit : num) {
        result = (result * 10 + (digit - '0')) % m;
    }
    return result;
}

int main() {
    int n;
    string digits;
    cin >> n >> digits;
    
    // Число a как строка
    string a = digits;
    
    // Число b = 10^n
    long long b = 1;
    for (int i = 0; i < n; i++) {
        b *= 10;
    }
    
    // Находим остатки от деления a на 10^n
    long long a_mod_b = bigIntMod(a, b);
    
    // Вычисляем НОД
    long long gcd = computeGCD(a_mod_b, b);
    
    // Уменьшаем a и b на НОД
    long long a_final = a_mod_b / gcd;
    long long b_final = b / gcd;
    
    if (a_final < b_final && b_final < 1000000) {
        cout << "YES" << endl;
        cout << a_final << " " << b_final << endl;
    } else {
        cout << "NO" << endl;
    }

    return 0;
}
