﻿#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

struct Point {
    double x, y;
};


bool findLineThroughTwoPoints(Point p1, Point p2, double& m, double& b) {
    if (p1.x == p2.x) {
        cerr << "Error: Vertical line detected. Slope is undefined." << endl;
        return false; 
    }
    m = (p2.y - p1.y) / (p2.x - p1.x);
    b = p1.y - m * p1.x;
    return true;
}


void findTwoPointsOnLine(double m, double b, double& x1, double& y1, double& x2, double& y2) {
    x1 = 1.0; 
    y1 = m * x1 + b;

    x2 = 3.0; 
    y2 = m * x2 + b;
}

int main() {
    vector<Point> points(3);

 
    
    for (int i = 0; i < 3; ++i) {
        cin >> points[i].x >> points[i].y;
    }

    double m, b;

 
    if (!findLineThroughTwoPoints(points[0], points[1], m, b)) {
        return 1; 
    }

    double x1, y1, x2, y2;
    findTwoPointsOnLine(m, b, x1, y1, x2, y2);

    
    cout << round(x1) << " " << round(y1) << " "
        << round(x2) << " " << round(y2) << endl;

    return 0;
}
