from math import gcd

def find_a_b(n, digits):
    # Максимальное значение для чисел a и b
    MAX_B = 10**6

    # Преобразуем строку цифр в число
    decimal_part = int(digits)

    # Проверяем все возможные значения b
    for b in range(2, MAX_B):
        # Проверяем, что b содержит простые множители, отличные от 2 и 5
        temp = b
        while temp % 2 == 0:
            temp //= 2
        while temp % 5 == 0:
            temp //= 5
        
        # Если остались другие простые множители, дробь может быть непериодической
        if temp == 1:
            continue

        # Проверяем все возможные значения a
        a = decimal_part * b // (10**n)

        # Проверяем, корректен ли найденный результат
        if 0 < a < b and len(str(decimal_part)) == n:
            # Сокращаем дробь и проверяем, что она равна исходной
            if gcd(a, b) == 1:
                if (a * 10**n) % b == decimal_part:
                    return "YES", a, b
    
    # Если ничего не найдено
    return "NO"

# Чтение входных данных
n = int(input())
digits = input()

# Вызов функции и вывод результата
result = find_a_b(n, digits)
if result == "NO":
    print("NO")
else:
    print("YES")
    print(result[1], result[2])
