from collections import deque
import sys

input = sys.stdin.read


def min_time_to_moscow(n, m, c, stations):
    stations = [(0, 0)] + stations + [(m, 0)]  # Добавляем начальную и конечную точки
    n += 2
    dp = [float('inf')] * n  # Минимальное время для достижения каждой станции
    dp[0] = 0  # Начальная точка

    # Дек для оптимизации
    deq = deque([0])  # Хранит индексы станций

    for i in range(1, n):
        # Удаляем станции из очереди, которые не достижимы
        while deq and stations[i][0] - stations[deq[0]][0] > c:
            deq.popleft()

        # Если очередь пуста, то станция недостижима
        if not deq:
            return -1

        # Обновляем минимальное время
        j = deq[0]
        dist = stations[i][0] - stations[j][0]
        dp[i] = dp[j] + stations[j][1] + dist / c

        # Убираем менее оптимальные элементы из дек
        while deq and dp[deq[-1]] + stations[deq[-1]][1] >= dp[i] + stations[i][1]:
            deq.pop()

        deq.append(i)

    return dp[-1]


data = input().split()
n, m, c = map(int, data[:3])
stations = [tuple(map(int, data[i:i + 2])) for i in range(3, len(data), 2)]

result = min_time_to_moscow(n, m, c, stations)
print(f"{result:.6f}")
