def galactic_timeline(n, a, b):
    # DP массив
    dp = [[False, False] for _ in range(n)]
    dp[0][0] = True  # Первый элемент лицевой стороной вверх
    dp[0][1] = True  # Первый элемент перевёрнут

    # Обработка всех карточек
    for i in range(1, n):
        if dp[i - 1][0]:
            if a[i] >= a[i - 1]:
                dp[i][0] = True
            if b[i] >= a[i - 1]:
                dp[i][1] = True
        if dp[i - 1][1]:
            if a[i] >= b[i - 1]:
                dp[i][0] = True
            if b[i] >= b[i - 1]:
                dp[i][1] = True

    # Проверяем возможность решения
    if not dp[n - 1][0] and not dp[n - 1][1]:
        return -1

    # Восстановление результата
    result_a = [0] * n
    result_b = [0] * n
    current = 0 if dp[n - 1][0] else 1

    for i in range(n - 1, -1, -1):
        if current == 0:
            result_a[i] = a[i]
            result_b[i] = b[i]
            if i > 0:
                current = 0 if dp[i - 1][0] and a[i] >= a[i - 1] else 1
        else:
            result_a[i] = b[i]
            result_b[i] = a[i]
            if i > 0:
                current = 0 if dp[i - 1][0] and b[i] >= a[i - 1] else 1

    return result_a, result_b


# Чтение данных
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

# Решение задачи
result = galactic_timeline(n, a, b)

# Вывод результата
if result == -1:
    print(-1)
else:
    print(" ".join(map(str, result[0])))
    print(" ".join(map(str, result[1])))
