from collections import defaultdict

def solve(n, q, queries):
    # Храним рёбра для каждого цвета (сеты, чтобы не было дубликатов)
    edges = defaultdict(set)
    # Храним количество рёбер, инцидентных каждой вершине для каждого цвета
    degree = defaultdict(lambda: defaultdict(int))
    # Храним количество рёбер для каждого цвета, если цвет превосходный
    beauty = defaultdict(int)
    
    # Считаем суммарную красоту
    total_beauty = 0
    
    # Функция для подсчёта красоты после изменения
    def calculate_beauty():
        nonlocal total_beauty
        total_beauty = 0
        for c in edges:
            # Для каждого цвета считаем количество рёбер этого цвета
            current_beauty = 0
            for v, u in edges[c]:
                if degree[c][v] == 1 and degree[c][u] == 1:
                    current_beauty += 1
            beauty[c] = current_beauty
            total_beauty += current_beauty
    
    results = []
    
    for query in queries:
        operation, v, u, c = query
        v, u, c = int(v), int(u), int(c)
        
        if operation == '+':
            # Добавляем ребро
            edges[c].add((v, u))
            degree[c][v] += 1
            degree[c][u] += 1
        elif operation == '-':
            # Удаляем ребро
            edges[c].remove((v, u))
            degree[c][v] -= 1
            degree[c][u] -= 1
        
        # После запроса пересчитываем красоту
        calculate_beauty()
        results.append(total_beauty)
    
    return results

# Чтение входных данных
n, q = map(int, input().split())
queries = [input().split() for _ in range(q)]

# Получаем результат
results = solve(n, q, queries)

# Выводим результат
for res in results:
    print(res)
