from math import gcd

def solve_task(n, digits):
    # Преобразуем цифры в числитель (как целое число) и знаменатель
    numerator = int(digits)
    denominator = 10 ** n
    
    # Упрощаем дробь
    common_gcd = gcd(numerator, denominator)
    numerator //= common_gcd
    denominator //= common_gcd
    
    # Проверяем, что знаменатель состоит только из множителей 2 и 5
    while denominator % 2 == 0:
        denominator //= 2
    while denominator % 5 == 0:
        denominator //= 5
    
    # Если после деления на 2 и 5 остался ненулевой делитель, дробь не конечная
    if denominator != 1:
        print("NO")
    else:
        # Проверяем, что 0 < numerator < denominator < 10^6
        if numerator < denominator and denominator < 10**6:
            print("YES")
            print(numerator, denominator)
        else:
            print("NO")

# Чтение входных данных
n = int(input())  # Количество знаков после запятой
digits = input()  # Строка с цифрами после запятой

# Вызов функции решения
solve_task(n, digits)
