def solve(x1, y1, x2, y2, x3, y3):
    # Проверка на коллинеарность
    if (x2 - x1) * (y3 - y1) == (y2 - y1) * (x3 - x1):
        # Точки коллинеарны
        print(x1, y1)
        print(x2, y2)
    else:
        # Точки не коллинеарны, находим прямую методом регрессии
        from fractions import Fraction

        # Уравнение прямой: y = mx + b
        x_coords = [x1, x2, x3]
        y_coords = [y1, y2, y3]

        # Средние значения
        x_mean = sum(x_coords) / 3
        y_mean = sum(y_coords) / 3

        # Коэффициент наклона m
        numerator = sum((x - x_mean) * (y - y_mean) for x, y in zip(x_coords, y_coords))
        denominator = sum((x - x_mean) ** 2 for x in x_coords)
        numerator = int(round(numerator))  # Приводим к целому
        denominator = int(round(denominator))  # Приводим к целому

        if denominator == 0:  # Защита от деления на 0
            m = Fraction(0)
        else:
            m = Fraction(numerator, denominator)

        # Свободный член b
        b = Fraction(y_mean) - m * Fraction(x_mean)

        # Прямая: y = mx + b
        x_a, x_b = 0, 1
        y_a = m * x_a + b
        y_b = m * x_b + b

        # Приводим координаты к целым значениям
        x_a, y_a = int(x_a), int(round(y_a))
        x_b, y_b = int(x_b), int(round(y_b))

        print(x_a, y_a)
        print(x_b, y_b)


# Чтение данных
try:
    coords = list(map(int, input("Введите координаты x1 y1 x2 y2 x3 y3: ").split()))
    if len(coords) != 6:
        raise ValueError("Ввод должен содержать ровно 6 чисел!")
    x1, y1, x2, y2, x3, y3 = coords
    solve(x1, y1, x2, y2, x3, y3)
except ValueError as e:
    print(f"Ошибка ввода: {e}")
