#include <bits/stdc++.h>
using namespace std;

typedef pair<long long, long long> Point;

long double sum_of_distances(long long A, long long B, long long C, Point p1, Point p2, Point p3){
    long double denom = sqrt((long double)(A*A + B*B));
    if (denom == 0) return 1e18;
    auto distance = [&](Point p) -> long double {
        return abs((long double)(A*p.first + B*p.second + C)) / denom;
    };
    return distance(p1) + distance(p2) + distance(p3);
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    long long x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    Point P1 = {x1, y1};
    Point P2 = {x2, y2};
    Point P3 = {x3, y3};
    auto get_line = [&](Point p, Point q) -> tuple<long long, long long, long long> {
        long long A = p.second - q.second;
        long long B = q.first - p.first;
        long long C = p.first * q.second - q.first * p.second;
        long long g = gcd(gcd(abs(A), abs(B)), abs(C));
        if (g != 0){
            A /= g;
            B /= g;
            C /= g;
        }
        if (A < 0 || (A == 0 && B < 0)){
            A = -A;
            B = -B;
            C = -C;
        }
        return make_tuple(A, B, C);
    };
    vector<tuple<long long, long long, long long>> candidate_lines;
    candidate_lines.emplace_back(get_line(P1, P2));
    candidate_lines.emplace_back(get_line(P1, P3));
    candidate_lines.emplace_back(get_line(P2, P3));
    sort(candidate_lines.begin(), candidate_lines.end());
    candidate_lines.erase(unique(candidate_lines.begin(), candidate_lines.end()), candidate_lines.end());
    long double min_sum = 1e18;
    tuple<long long, long long, long long> optimal_line = {1, 0, 0};
    for(auto &[A, B, C] : candidate_lines){
        long double current_sum = sum_of_distances(A, B, C, P1, P2, P3);
        if(current_sum < min_sum){
            min_sum = current_sum;
            optimal_line = {A, B, C};
        }
    }
    auto &[A_opt, B_opt, C_opt] = optimal_line;
    auto find_point = [&](bool fix_x, long long fixed_value) -> Point {
        if(fix_x){
            if(B_opt == 0){
                return {LLONG_MAX, LLONG_MAX};
            }
            if((-A_opt * fixed_value - C_opt) % B_opt != 0){
                return {LLONG_MAX, LLONG_MAX};
            }
            long long y = (-A_opt * fixed_value - C_opt) / B_opt;
            return {fixed_value, y};
        }
        else{
            if(A_opt == 0){
                return {LLONG_MAX, LLONG_MAX};
            }
            if((-B_opt * fixed_value - C_opt) % A_opt != 0){
                return {LLONG_MAX, LLONG_MAX};
            }
            long long x = (-B_opt * fixed_value - C_opt) / A_opt;
            return {x, fixed_value};
        }
    };
    vector<Point> points_on_line;
    for(long long fx = -1000; fx <= 1000 && points_on_line.size() < 2; fx++){
        Point p = find_point(true, fx);
        if(p.first != LLONG_MAX){
            points_on_line.emplace_back(p);
        }
    }
    if(points_on_line.size() < 2){
        for(long long fy = -1000; fy <= 1000 && points_on_line.size() < 2; fy++){
            Point p = find_point(false, fy);
            if(p.first != LLONG_MAX){
                points_on_line.emplace_back(p);
            }
        }
    }
    if(points_on_line.size() < 2){
        Point p1 = find_point(true, 0);
        if(p1.first != LLONG_MAX){
            points_on_line.emplace_back(p1);
        }
        Point p2 = find_point(true, 1);
        if(p2.first != LLONG_MAX && p1 != p2){
            points_on_line.emplace_back(p2);
        }
        if(points_on_line.size() < 2){
            Point p3 = find_point(false, 0);
            if(p3.first != LLONG_MAX && p3 != p1 && p3 != p2){
                points_on_line.emplace_back(p3);
            }
        }
    }
    while(points_on_line.size() < 2){
        points_on_line.emplace_back(0,0);
    }
    sort(points_on_line.begin(), points_on_line.end());
    points_on_line.erase(unique(points_on_line.begin(), points_on_line.end()), points_on_line.end());
    if(points_on_line.size() < 2){
points_on_line.emplace_back(points_on_line[0].first +1, points_on_line[0].second);
    }
    cout << points_on_line[0].first << " " << points_on_line[0].second << " "
         << points_on_line[1].first << " " << points_on_line[1].second;
}
