#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define F first
#define S second
ll exgcd(ll a, ll b, ll &x, ll &y){
    if(b == 0){
        x =1;
        y =0;
        return a;
    }
    ll x1, y1;
    ll g = exgcd(b, a % b, x1, y1);
    x = y1;
    y = x1 - (a / b) * y1;
    return g;
}
double dist(ll A, ll B, ll C, vector<pair<ll, ll>> points){
    double sum_dist =0.0;
    double denom = sqrt((double)A*A + (double)B*B);
    for(auto &[x, y] : points){
        double dist = abs((double)A*x + (double)B*y + (double)C) / denom;
        sum_dist += dist;
    }
    return sum_dist;
}
pair<pair<ll, ll>, pair<ll, ll>> find_two_points(ll A, ll B, ll C){
    if(A ==0 && B ==0){
        return { {0,0}, {1,0} };
    }
    ll g = gcd(abs(A), abs(B));
    if(g ==0){
        return { {0,0}, {1,0} };
    }
    ll x0, y0;
    exgcd(A/g, B/g, x0, y0);
    x0 *= (-C)/g;
    y0 *= (-C)/g;
    pair<ll, ll> p1 = {x0, y0};
    pair<ll, ll> p2 = {x0 + (B/g), y0 - (A/g)};
    if(abs(p2.F) > 1e9 || abs(p2.S) >1e9){
        p2 = {x0 - (B/g), y0 + (A/g)};
    }
    return { p1, p2 };
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    ll x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    vector<pair<ll, ll>> points = { {x1, y1}, {x2, y2}, {x3, y3} };
    vector<pair<pair<ll, ll>, pair<ll, ll>>> lines = {
        { points[0], points[1] },
        { points[0], points[2] },
        { points[1], points[2] }
    };
    double min_sum = 1e18;
    tuple<ll, ll, ll> best_line = {0,0,0};
    for(auto &[Pa, Pb] : lines){
        ll xa = Pa.F, ya = Pa.S;
        ll xb = Pb.F, yb = Pb.S;
        ll A = yb - ya;
        ll B = xa - xb;
        ll C = xb * ya - xa * yb;
        double sum_dist = dist(A, B, C, points);
        if(sum_dist < min_sum){
            min_sum = sum_dist;
            best_line = {A, B, C};
        }
    }
    ll A = get<0>(best_line);
    ll B = get<1>(best_line);
    ll C = get<2>(best_line);
    pair<pair<ll, ll>, pair<ll, ll>> two_points = find_two_points(A, B, C);
    cout << two_points.F.F << " " << two_points.F.S << " " 
         << two_points.S.F << " " << two_points.S.S;
}
