#include <bits/stdc++.h>
using namespace std;
using ll = long long;
struct Point {
    ll x;
    ll y;
};

tuple<ll, ll, ll> glc(const Point& p1, const Point& p2) {
    ll a = p2.y - p1.y;
    ll b = -(p2.x - p1.x);
    ll c = (p2.x - p1.x) * p1.y - (p2.y - p1.y) * p1.x;
    return make_tuple(a, b, c);
}

double dptl(ll a, ll b, ll c, const Point& p) {
    return abs((double)(a * p.x + b * p.y + c)) / sqrt((double)(a * a + b * b));
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    
    ll x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    
    Point A = {x1, y1};
    Point B = {x2, y2};
    Point C = {x3, y3};
    
    vector<Point> houses = {A, B, C};
    
    vector<pair<int, int>> candidate_pairs = {
        {0,1},
        {0,2},
        {1,2}
    };
    
    double mn = 1e18;
    pair<Point, Point> optimal_line;
    
    for(auto &pair_idx : candidate_pairs){
        Point p1 = houses[pair_idx.first];
        Point p2 = houses[pair_idx.second];
        
        auto [a, b, c] = glc(p1, p2);
        
        double total_distance = 0.0;
        for(auto &p : houses){
            total_distance += dptl(a, b, c, p);
        }
        
        if(total_distance < mn){
            mn = total_distance;
            optimal_line = {p1, p2};
        }
    }
    
    cout << optimal_line.first.x << " " << optimal_line.first.y << " " 
         << optimal_line.second.x << " " << optimal_line.second.y;
         
    return 0;
}
