def min_cuts_final_version(n, m, s):
    if s > n * m:
        return -1

    min_cuts = float('inf')

    for horizontal in range(1, n + 1):
        if s % horizontal == 0:
            part_width = s // horizontal
            if part_width <= m:
                min_cuts = min(min_cuts, horizontal - 1)

    for vertical in range(1, m + 1):
        if s % vertical == 0:
            part_height = s // vertical
            if part_height <= n:
                min_cuts = min(min_cuts, vertical - 1)

    for horizontal in range(n + 1):
        for vertical in range(m + 1):
            area1 = horizontal * m
            area2 = vertical * n
            area3 = (n - horizontal) * (m - vertical)

            if area1 + area2 == s or area1 + area3 == s or area2 + area3 == s:
                min_cuts = min(min_cuts, horizontal + vertical)

    return min_cuts if min_cuts != float('inf') else -1

n, m, s = map(int, input().split())
print(min_cuts_final_version(n, m, s))
