def solve_jump_problem():
    import math

    x0, y0 = map(int, input().split())
    x1, y1 = map(int, input().split())
    n = int(input())
    a = list(map(int, input().split()))

    total_distance = math.sqrt((x1 - x0) ** 2 + (y1 - y0) ** 2)

    if sum(a) < total_distance:
        print("Impossible")
        return

    dx = (x1 - x0) / total_distance
    dy = (y1 - y0) / total_distance

    current_x, current_y = x0, y0
    points = []

    for i in range(n):
        next_x = current_x + a[i] * dx
        next_y = current_y + a[i] * dy
        points.append((next_x, next_y))
        current_x, current_y = next_x, next_y

    if abs(current_x - x1) > 1e-4 or abs(current_y - y1) > 1e-4:
        print("Impossible")
        return

    print("Possible")
    for x, y in points:
        print(f"{x:.6f} {y:.6f}")

solve_jump_problem()
