def coordinates_to_chess(x, y):
    return f"{chr(x + ord('a') - 1)}{y}"

def find_bishop_position():
    possible_positions = [(x, y) for x in range(1, 9) for y in range(1, 9)]
    moves = [(2, 2), (2, -2), (-2, 2), (-2, -2), (1, 1), (-1, -1), (1, -1), (-1, 1)]

    for move_index in range(7):
        if len(possible_positions) == 1:
            break

        move_x, move_y = moves[move_index % len(moves)]
        print(f"? {move_x} {move_y}", flush=True)

        response = input().strip()

        filtered_positions = []
        if response == '+':
            filtered_positions = [
                (x, y) for x, y in possible_positions
                if 1 <= x + move_x <= 8 and 1 <= y + move_y <= 8
            ]
        elif response == '-':
            filtered_positions = [
                (x, y) for x, y in possible_positions
                if not (1 <= x + move_x <= 8 and 1 <= y + move_y <= 8)
            ]

        if filtered_positions:
            possible_positions = filtered_positions

        if not possible_positions:
            print("Error: no positions remain after filtering.", flush=True)
            return

    if len(possible_positions) == 1:
        x, y = possible_positions[0]
        print(f"! {coordinates_to_chess(x, y)}", flush=True)
    else:
        print("Error: ambiguous positions remain.", flush=True)

find_bishop_position()
