from collections import defaultdict

def solve(n, q, queries):
    # Состояния графа
    edges = defaultdict(set)  # Список рёбер по цветам
    count = defaultdict(lambda: defaultdict(int))  # Счётчики рёбер по вершинам для каждого цвета
    beauty = defaultdict(int)  # Суммарная красота для каждого цвета
    
    # Функция для подсчёта красоты графа
    def calculate_beauty():
        total_beauty = 0
        for color, edges_set in edges.items():
            count_edges = 0
            # Пройдем по всем рёбрам цвета и проверим, все ли вершины имеют не более одного инцидентного ребра
            for u, v in edges_set:
                if count[color][u] <= 1 and count[color][v] <= 1:
                    count_edges += 1
            beauty[color] = count_edges
            total_beauty += count_edges
        return total_beauty
    
    results = []
    for query in queries:
        operation, v, u, c = query
        v, u, c = int(v), int(u), int(c)
        
        if operation == '+':
            # Добавляем ребро
            edges[c].add((v, u))
            count[c][v] += 1
            count[c][u] += 1
        elif operation == '-':
            # Удаляем ребро
            edges[c].remove((v, u))
            count[c][v] -= 1
            count[c][u] -= 1
        
        # Подсчитываем красоту графа после запроса
        results.append(calculate_beauty())
    
    # Выводим результаты для каждого запроса
    return results

# Чтение входных данных
n, q = map(int, input().split())
queries = [input().split() for _ in range(q)]

# Получаем результат
results = solve(n, q, queries)

# Выводим результат
for res in results:
    print(res)
