import heapq

def solve(n, m, c, stations):
    # Добавим начальную точку (Санкт-Петербург)
    stations = [(0, 0)] + stations  # (расстояние, время заправки)
    
    # Инициализируем dp массив, где dp[i] - минимальное время до станции i
    dp = [float('inf')] * (n + 1)
    dp[0] = 0  # Начинаем в Санкт-Петербурге, времени не потрачено
    
    # Используем очередь с приоритетом (min-heap)
    pq = [(0, 0)]  # (время, индекс станции)
    
    while pq:
        time, i = heapq.heappop(pq)
        
        # Если мы уже нашли лучшее время для станции i, пропускаем
        if time > dp[i]:
            continue
        
        # Теперь проверим, куда можем поехать из станции i
        for j in range(i + 1, n + 1):
            # Расстояние между станциями i и j
            distance = stations[j][0] - stations[i][0]
            
            # Если можем доехать до станции j
            if distance <= c:
                # Время для преодоления этого расстояния с максимальной скоростью
                new_time = time + distance / c + stations[j][1]
                if new_time < dp[j]:
                    dp[j] = new_time
                    heapq.heappush(pq, (new_time, j))
                    
    # Ответ: минимальное время для достижения Москвы (последней станции)
    print(f"{dp[n]:.6f}")

# Чтение входных данных
n, m, c = map(int, input().split())
stations = [tuple(map(int, input().split())) for _ in range(n)]

# Вызов функции для решения задачи
solve(n, m, c, stations)
