def solve(n, a, b):
    # Сначала создаем список из пар (ai, bi)
    cards = list(zip(a, b))
    
    # Сортируем карточки, чтобы попробовать собрать возрастающие последовательности
    cards.sort()
    
    # Массивы для конечных значений на лицевых и оборотных сторонах
    front = []
    back = []
    
    # Начальные значения для лицевой и оборотной сторон
    last_front = -1
    last_back = -1
    
    # Проходим по отсортированным карточкам
    for ai, bi in cards:
        # Для каждой карточки пытаемся выбрать подходящие значения
        # Для лицевой стороны можно взять ai, если оно больше, чем предыдущее значение лицевой стороны
        # Или же берем bi, если оно больше, чем предыдущее значение оборотной стороны
        if ai >= last_front and bi >= last_back:
            # Если оба варианта возможны, берем тот, что легче подходит
            if ai >= last_back:
                front.append(ai)
                back.append(bi)
                last_front = ai
                last_back = bi
            else:
                front.append(bi)
                back.append(ai)
                last_front = bi
                last_back = ai
        elif ai >= last_front:
            front.append(ai)
            back.append(bi)
            last_front = ai
            last_back = bi
        elif bi >= last_back:
            front.append(bi)
            back.append(ai)
            last_front = bi
            last_back = ai
        else:
            # Если ни один вариант не подходит, возвращаем -1
            return -1
    
    return front, back

# Чтение входных данных
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

# Решение
result = solve(n, a, b)

if result == -1:
    print(-1)
else:
    front, back = result
    print(" ".join(map(str, front)))
    print(" ".join(map(str, back)))
