def find_min_time(n, m, c, stations):
    stations = [(0, 0)] + stations + [(m, 0)]
    n += 2
    
    def can_reach(v):
        curr_fuel = c
        curr_time = 0.0
        curr_pos = 0
        
        for i in range(1, n):
            dist = stations[i][0] - stations[i-1][0]
            fuel_needed = dist * v
            
            if fuel_needed > c:
                return False
                
            if fuel_needed > curr_fuel:
                curr_time += stations[i-1][1]
                curr_fuel = c
            
            curr_fuel -= fuel_needed
            curr_time += dist / v
            
        return True
        
    left = 0.0
    right = 1e18
    
    for _ in range(100):
        mid = (left + right) / 2
        if can_reach(mid):
            right = mid
        else:
            left = mid
            
    v = right
    curr_fuel = c
    total_time = 0.0
    
    for i in range(1, n):
        dist = stations[i][0] - stations[i-1][0]
        fuel_needed = dist * v
        
        if fuel_needed > curr_fuel:
            total_time += stations[i-1][1]
            curr_fuel = c
            
        curr_fuel -= fuel_needed
        total_time += dist / v
        
    return total_time

n, m, c = map(int, input().split())
stations = []
for _ in range(n):
    x, t = map(int, input().split())
    stations.append((x, t))

print(f"{find_min_time(n, m, c, stations):.10f}")
