from heapq import heappush, heappop

def min_travel_time(n, m, c, stations):
    
    stations = [(0, 0)] + sorted(stations) + [(m, 0)]
    n += 2 

    
    dp = [float('inf')] * n
    dp[0] = 0 

    
    queue = []
    heappush(queue, (0, 0)) 

    for i in range(1, n):
        
        while queue and stations[i][0] - stations[queue[0][1]][0] > c:
            heappop(queue)

      
        if not queue:
            return -1

        
        dp[i] = queue[0][0] + (stations[i][0] - stations[queue[0][1]][0]) + stations[i][1]

        
        heappush(queue, (dp[i], i))

    return dp[-1]


n, m, c = map(int, input().split())
stations = [tuple(map(int, input().split())) for _ in range(n)]


result = min_travel_time(n, m, c, stations)
print(f"{result:.6f}")
