#include <iostream>
#include <vector>
#include <cmath>
#include <iomanip>

using namespace std;

const double EPSILON = 1e-9;

// ??????? ??? ?????????? ?????????? ????? ????? ???????
double distance(double x0, double y0, double x1, double y1) {
    return sqrt((x1 - x0) * (x1 - x0) + (y1 - y0) * (y1 - y0));
}

int main() {
    // ???? ??????
    double x0, y0, x1, y1;
    cin >> x0 >> y0 >> x1 >> y1;
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    
    // ????? ???? ???? ???????
    double total_distance = 0;
    for (int i = 0; i < n; ++i) {
        total_distance += a[i];
    }
    
    // ????????, ????? ?? ????????? ?? ????
    double target_distance = distance(x0, y0, x1, y1);
    if (abs(total_distance - target_distance) > EPSILON) {
        cout << "Impossible" << endl;
        return 0;
    }
    
    // ??????? ? ??????? ?????????????: ????? ?????? ??????????? ??? ??????? ??????
    vector<pair<double, double>> points;
    points.push_back({x0, y0});
    
    // ????????????? ????????? ?????????
    double cx = x0, cy = y0;
    double angle = 0.0;  // ????????? ???? (0 ??????)

    // ??? ??????? ??????
    for (int i = 0; i < n; ++i) {
        double len = a[i];
        // ????????? ????? ?????????? ????? ??????
        cx += len * cos(angle);
        cy += len * sin(angle);
        
        // ????????? ????? ? ??????
        points.push_back({cx, cy});
        
        // ????????? ???? ??? ?????????? ??????
        // ? ?????? ?????? ????? ??????? ????? ????, ?? ??? ???????? ????? ????????? ? ??????? ????
        double dx = x1 - cx, dy = y1 - cy;
        angle = atan2(dy, dx);
    }
    
    // ??????? ?????
    cout << "Possible" << endl;
    for (const auto& point : points) {
        cout << fixed << setprecision(6) << point.first << " " << point.second << endl;
    }
    
    return 0;
}

