#include <iostream>
#include <cmath>
#include <vector>
#include <iomanip>
using namespace std;
struct Point {
    double x, y;
};
bool isPossible(int total_distance, int sum_of_jumps) {
    return (sum_of_jumps >= total_distance && (sum_of_jumps - total_distance) % 2 == 0);
}
void solve(int x0, int y0, int x1, int y1, int n, vector<int>& a) {
    double dx = x1 - x0;
    double dy = y1 - y0;
    double distance = hypot(dx, dy);
    int sum_of_jumps = 0;
    for (int length : a) sum_of_jumps += length;
    if (!isPossible(distance, sum_of_jumps)) {
        cout << "Impossible" << endl;
        return;
    }
    dx /= distance;
    dy /= distance;
    vector<Point> points;
    points.push_back({(double)x0, (double)y0});
    double current_x = x0, current_y = y0;
    for (int i = 0; i < n; i++) {
        double move_x = dx * a[i];
        double move_y = dy * a[i];
        current_x += move_x;
        current_y += move_y;
        points.push_back({current_x, current_y});
    }
    if (fabs(points.back().x - x1) > 1e-4 || fabs(points.back().y - y1) > 1e-4) {
        cout << "Impossible" << endl;
        return;
    }
    cout << "Possible" << endl;
    for (int i = 1; i < points.size(); i++) {
        cout << fixed << setprecision(8) << points[i].x << " " << points[i].y << endl;
    }
}
int main() {
    int x0, y0, x1, y1, n;
    cin >> x0 >> y0 >> x1 >> y1 >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    solve(x0, y0, x1, y1, n, a);
    return 0;
}
