#include <iostream>
#include <unordered_map>
#include <vector>
using namespace std;

const int MAX_C = 100000; 

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    
    unordered_map<int, vector<int>> edges_count; 
    unordered_map<int, int> total_edges; 
    unordered_map<int, bool> is_excellent; 
    unordered_map<int, int> beauty; 

    int total_beauty = 0; 

    while (q--) {
        char type;
        int v, u, c;
        cin >> type >> v >> u >> c;

        v--; u--; 

        if (type == '+') {
            
            if (edges_count.find(c) == edges_count.end()) {
                edges_count[c] = vector<int>(n, 0);
            }

            
            edges_count[c][v]++;
            edges_count[c][u]++;
            total_edges[c]++;

            
            bool excellent = true;
            for (int i = 0; i < n; i++) {
                if (edges_count[c][i] > 1) {
                    excellent = false;
                    break;
                }
            }

            
            if (excellent && !is_excellent[c]) {
                is_excellent[c] = true;
                beauty[c] = total_edges[c]; 
                total_beauty += beauty[c];   
            }
            
            else if (!excellent && is_excellent[c]) {
                is_excellent[c] = false;
                total_beauty -= beauty[c]; 
            }

        } else if (type == '-') {
            
            edges_count[c][v]--;
            edges_count[c][u]--;
            total_edges[c]--;

            
            bool excellent = true;
            for (int i = 0; i < n; i++) {
                if (edges_count[c][i] > 1) {
                    excellent = false;
                    break;
                }
            }

            
            if (!excellent && is_excellent[c]) {
                is_excellent[c] = false;
                total_beauty -= beauty[c]; 
            }
            
            else if (excellent && !is_excellent[c]) {
                is_excellent[c] = true;
                beauty[c] = total_edges[c]; 
                total_beauty += beauty[c];  
            }
        }

        cout << total_beauty << endl;
    }

    return 0;
}
