from collections import defaultdict

def solve():
    n, q = map(int, input().split())
    
    color_edges = defaultdict(set)
    vertex_colors = defaultdict(lambda: defaultdict(int))
    
    def is_excellent_color(color):
        if not color_edges[color]:
            return True
        return all(count <= 1 for v_dict in vertex_colors.values() for c, count in v_dict.items() if c == color)
    
    def get_beauty():
        total_beauty = 0
        for color in color_edges:
            if is_excellent_color(color):
                total_beauty += len(color_edges[color])
        return total_beauty
    
    def add_edge(v, u, c):
        color_edges[c].add((min(v, u), max(v, u)))
        vertex_colors[v][c] += 1
        vertex_colors[u][c] += 1
    
    def remove_edge(v, u, c):
        color_edges[c].remove((min(v, u), max(v, u)))
        vertex_colors[v][c] -= 1
        vertex_colors[u][c] -= 1
        if vertex_colors[v][c] == 0:
            del vertex_colors[v][c]
        if vertex_colors[u][c] == 0:
            del vertex_colors[u][c]
        if not color_edges[c]:
            del color_edges[c]
    
    queries = []
    results = []
    
    for _ in range(q):
        queries.append(input().replace('+', '1').replace('-', '0').split())
        
    for query in queries:
        op, v, u, c = query
        v, u, c = int(v), int(u), int(c)
        
        if op == '1':
            add_edge(v, u, c)
        else:
            remove_edge(v, u, c)
            
        results.append(str(get_beauty()))
    
    print('\n'.join(results))

solve()
