def find_min_students(n, m, k, p, a, ranges):
    from collections import defaultdict
    import sys
    
    p_index = {value: idx for idx, value in enumerate(p)}
    required = [p_index[a[i]] for i in range(len(a)) if a[i] in p_index]
    
    indices = defaultdict(list)
    for i, (l, r) in enumerate(ranges):
        indices[(l - 1, r - 1)].append(i + 1)
    
    segments = []
    
    for l, r in indices.keys():
        segments.append((l, r, indices[(l, r)]))
    
    segments.sort(key=lambda x: x[0])
    
    pos = 0
    selected = []
    
    while pos < len(required):
        used = -1
        farthest = pos
        for l, r, ids in segments:
            if l > required[pos]: 
                break
            
           
            if r >= required[pos]:
                if farthest < r + 1:
                    farthest = r + 1
                    used = ids[0] 
                
                continue
        
        if used == -1: 
            return -1
        
        selected.append(used)
        while pos < len(required) and required[pos] <= farthest:
            pos += 1
    
    return selected


def main():
    input = sys.stdin.read
    data = input().strip().splitlines()
    
    t = int(data[0])
    output = []
    
    index = 1
    for _ in range(t):
        n, m, k = map(int, data[index].split())
        index += 1
        
        p = list(map(int, data[index].split()))
        index += 1
        
        a = list(map(int, data[index].split()))
        index += 1
        
        ranges = []
        for _ in range(k):
            l, r = map(int, data[index].split())
            ranges.append((l, r))
            index += 1
        
        result = find_min_students(n, m, k, p, a, ranges)
        
        if isinstance(result, list):
            output.append(f"{len(result)}")
            output.append(" ".join(map(str, result)))
        else:
            output.append("-1")
    
    print("\n".join(output))

main()
