#include <iostream>
#include <vector>
#include <queue>

using namespace std;

struct Station {
    int x, t;
};

double min_time(int n, int m, int c, const vector<Station>& stations) {
    vector<double> dp(n + 1, numeric_limits<double>::infinity());
    dp[0] = 0;

    deque<pair<int, double>> q;
    q.push_back({0, 0});

    for (int i = 1; i <= n; ++i) {
        int x = stations[i - 1].x, t = stations[i - 1].t;
        while (!q.empty() && x - q.front().first > c) {
            q.pop_front();
        }

        if (!q.empty()) {
            auto [j, time] = q.front();
            dp[i] = time + (x - stations[j - 1].x) * (x - stations[j - 1].x) / (4.0 * c) + t;
        }
        q.push_back({i, dp[i]});
    }

    return dp[n];
}

int main() {
    int n, m, c;
    cin >> n >> m >> c;

    vector<Station> stations(n);
    for (int i = 0; i < n; ++i) {
        cin >> stations[i].x >> stations[i].t;
    }

    cout << fixed << setprecision(6) << min_time(n, m, c, stations) << endl;
    return 0;
}