from collections import defaultdict
import sys


n, q = map(int, sys.stdin.readline().split())


edge_count = defaultdict(int) 
vertex_degree = defaultdict(lambda: defaultdict(int))  
total_beauty = 0  


def update_total_beauty():
    global total_beauty
    total_beauty = 0
    for color in edge_count:
        if all(degree <= 1 for degree in vertex_degree[color].values()):  
            total_beauty += edge_count[color] 


for _ in range(q):
    query = input().split()
    operation = query[0]
    v, u, c = map(int, query[1:])
    if operation == "+":
       
        edge_count[c] += 1
        vertex_degree[c][v] += 1
        vertex_degree[c][u] += 1
        
    elif operation == "-":
        
        edge_count[c] -= 1
        vertex_degree[c][v] -= 1
        vertex_degree[c][u] -= 1
    

    update_total_beauty()
    

    print(total_beauty)
