def is_power_of_2_and_5(x):
    # Проверим, можно ли представить x как произведение степеней 2 и 5
    while x % 2 == 0:
        x //= 2
    while x % 5 == 0:
        x //= 5
    return x == 1

def solve(n, decimal_digits):
    # Строим числитель и знаменатель из строки
    numerator = int(decimal_digits)
    denominator = 10 ** n
    
    # Проверяем, является ли знаменатель произведением только 2 и 5
    if is_power_of_2_and_5(denominator):
        # Упростим дробь
        from math import gcd
        common_divisor = gcd(numerator, denominator)
        numerator //= common_divisor
        denominator //= common_divisor
        # Убедимся, что 0 < a < b < 10^6
        if numerator < denominator and denominator < 10**6:
            print("YES")
            print(numerator, denominator)
        else:
            print("NO")
    else:
        print("NO")

# Ввод
n = int(input())  # Количество знаков после запятой
decimal_digits = input().strip()  # Строка с цифрами после запятой

# Решение
solve(n, decimal_digits)
