def min_cuts(n, m, s):
    # Если s больше, чем площадь листа, решение невозможно
    if s > n * m:
        return -1

    # Если требуется вся площадь, разрезы не нужны
    if s == n * m:
        return 0

    # Минимальное количество разрезов
    min_cuts = float('inf')

    # Перебор вертикальных разрезов
    for x in range(n + 1):
        width = x + 1  # Число вертикальных полос

        # Проверка всех горизонтальных разрезов
        for y in range(m + 1):
            height = y + 1  # Число горизонтальных полос

            # Максимальная возможная площадь одного прямоугольника
            if s % width == 0 and (s // width) <= m:
                min_cuts = min(min_cuts, x + y)
            elif s % height == 0 and (s // height) <= n:
                min_cuts = min(min_cuts, x + y)

    return min_cuts if min_cuts != float('inf') else -1

# Ввод данных
n, m, s = map(int, input().split())
result = min_cuts(n, m, s)
print(result)
