def arrange_cards(n, front, back):
    cards = list(zip(front, back))
    cards.sort()  # Сортируем карточки по лицевой стороне

    result_front = []
    result_back = []

    prev_front = prev_back = -1

    for f, b in cards:
        # Проверяем, можем ли взять лицевую сторону
        if f >= prev_front:
            result_front.append(f)
            prev_front = f
        # Проверяем, можем ли взять оборотную сторону
        elif b >= prev_front:
            result_back.append(b)
            prev_front = b
        else:
            return -1  # Невозможно упорядочить

    # Проверяем, что обе стороны упорядочены
    if len(result_front) != n or len(result_back) != n:
        return -1

    return result_front, result_back

# Чтение входных данных
n = int(input().strip())
front = list(map(int, input().strip().split()))
back = list(map(int, input().strip().split()))

result = arrange_cards(n, front, back)

if result == -1:
    print(-1)
else:
    front_sorted, back_sorted = result
    print(" ".join(map(str, front_sorted)))
    print(" ".join(map(str, back_sorted)))
