def solve_game(n, a, b):
    # Список карточек (лицевая, оборотная)
    cards = [(a[i], b[i]) for i in range(n)]
    
    # Сортируем карточки по лицевой стороне
    cards.sort()
    
    # Массивы для лицевых и оборотных сторон
    result_a = [0] * n
    result_b = [0] * n
    
    # Начинаем с первой карточки
    result_a[0] = cards[0][0]
    result_b[0] = cards[0][1]
    
    # Пробуем заполнить массивы для лицевых и оборотных сторон
    for i in range(1, n):
        # Лицевая сторона текущей карточки
        if cards[i][0] > result_a[i - 1]:
            result_a[i] = cards[i][0]
        else:
            result_b[i] = cards[i][0]
        
        # Оборотная сторона текущей карточки
        if cards[i][1] > result_b[i - 1]:
            result_b[i] = cards[i][1]
        else:
            result_a[i] = cards[i][1]
    
    return result_a, result_b

# Ввод
n = int(input())  # Количество карточек
a = list(map(int, input().split()))  # Годы на лицевых сторонах
b = list(map(int, input().split()))  # Годы на оборотных сторонах

# Решение
result = solve_game(n, a, b)

# Вывод
if result == -1:
    print(-1)
else:
    result_a, result_b = result
    print(" ".join(map(str, result_a)))
    print(" ".join(map(str, result_b)))
