def is_valid_position(board, n, row, col):
    return 0 <= row < n and 0 <= col < n and board[row][col] == 0

def fill_shape(board, n, row, col, shape_num, shape_size):
    if shape_size == 0:
        return True
    
    if not is_valid_position(board, n, row, col):
        return False
    
    board[row][col] = shape_num
    
    directions = [(0, 1), (0, -1), (1, 0), (-1, 0)]
    for dr, dc in directions:
        if fill_shape(board, n, row + dr, col + dc, shape_num, shape_size - 1):
            return True
    
    board[row][col] = 0
    return False

def cut_board(n):
    if n % 2 != 0:
        return -1
    
    board = [[0 for _ in range(n)] for _ in range(n)]
    shape_num = 1
    for i in range(n):
        for j in range(n):
            if board[i][j] == 0:
                if not fill_shape(board, n, i, j, shape_num, n // 2):
                    return -1
                shape_num += 1
    
    return board

# Ввод данных
n = int(input())

# Разрезание поля на n-миношки
result = cut_board(n)

# Вывод результата
if result == -1:
    print(-1)
else:
    for row in result:
        print(*row)
