def find_optimal_trench_coordinates(x1, y1, x2, y2, x3, y3):
    # Находим уравнение прямой, проходящей через две точки
    def line_equation(x1, y1, x2, y2):
        a = y1 - y2
        b = x2 - x1
        c = x1 * y2 - x2 * y1
        return a, b, c

    # Находим уравнения прямых, проходящих через каждую пару точек
    a1, b1, c1 = line_equation(x1, y1, x2, y2)
    a2, b2, c2 = line_equation(x1, y1, x3, y3)
    a3, b3, c3 = line_equation(x2, y2, x3, y3)

    # Находим точку пересечения прямых
    x = (c1 * b3 - c3 * b1) / (a1 * b3 - a3 * b1)
    y = (c3 * a1 - c1 * a3) / (a1 * b3 - a3 * b1)

    return x, y

# Ввод данных
x1, y1, x2, y2, x3, y3 = map(int, input().split())

# Нахождение оптимальных координат для траншеи
trench_x, trench_y = find_optimal_trench_coordinates(x1, y1, x2, y2, x3, y3)

# Вывод результатов
print(trench_x, trench_y)
