﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <numeric>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

struct DSU {
    vector<ll> p, sz;
    DSU() {};
    DSU(ll n) {
        init(n);
    }

    void init(ll n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0ll);
        sz.assign(n, 1);
    }

    ll leader(ll v) {
        return (v == p[v] ? v : p[v] = leader(p[v]));
    }

    bool unite(ll a, ll b) {
        a = leader(a);
        b = leader(b);
        if (a == b) return 0;
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        sz[a] += sz[b];
        p[b] = a;
        return 1;
    }
    ll size(ll n) {
        return sz[leader(n)];
    }
};

ll num(string s) {
    ll sum = 0;
    reverse(s.begin(), s.end());
    for (ll i = 0; i < s.size(); ++i) {
        sum += pow(10, i) * (s[i] - '0');
    }
    return sum;
}
ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

void solve() {
    ll n; cin >> n;
    string s; cin >> s;
    ll a = num(s), b = pow(10, n);
    ll d = gcd(a, b);
    cout << "YES\n" << a / d << " " << b / d << '\n';
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    ll tt = 1;
    while (tt--) solve();
}