﻿//#include <iostream>
//#include <string>
//#include <vector>
//#include <algorithm>
//#include <iomanip>
//#include <set>
//#include <map>
//#include <numeric>
//#include <iomanip>
//#include <unordered_set>
//#include <unordered_map>
//#include <bitset>
//#include <queue>
//#include <deque>
//#include <stack>
//#include <cmath>
//using namespace std;
//using ll = long long;
//using ull = unsigned long long;
//using ld = long double;
//
//struct DSU {
//    vector<ll> p, sz;
//    DSU() {};
//    DSU(ll n) {
//        init(n);
//    }
//
//    void init(ll n) {
//        p.resize(n);
//        iota(p.begin(), p.end(), 0ll);
//        sz.assign(n, 1);
//    }
//
//    ll leader(ll v) {
//        return (v == p[v] ? v : p[v] = leader(p[v]));
//    }
//
//    bool unite(ll a, ll b) {
//        a = leader(a);
//        b = leader(b);
//        if (a == b) return 0;
//        if (sz[a] < sz[b]) {
//            swap(a, b);
//        }
//        sz[a] += sz[b];
//        p[b] = a;
//        return 1;
//    }
//    ll size(ll n) {
//        return sz[leader(n)];
//    }
//};
//
//ll num(string s) {
//    ll sum = 0;
//    reverse(s.begin(), s.end());
//    ll j = 1;
//    for (ll i = 0; i < s.size(); ++i) {
//        sum += j * (s[i] - '0');
//        j *= 10;
//    }
//    return sum;
//}
//ll gcd(ll a, ll b) {
//    if (b == 0) return a;
//    return gcd(b, a % b);
//}
//
//void solve() {
//    ll n; cin >> n;
//    string s; cin >> s;
//    ll a = num(s), b = pow(10, n);
//    ll d = gcd(a, b);
//    cout << "YES\n" << a / d << " " << b / d << '\n';
//}
//
//int main() {
//    ios_base::sync_with_stdio(0); cin.tie(0);
//    ll tt = 1;
//    while (tt--) solve();
//}
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <numeric>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

struct DSU {
    vector<ll> p, sz;
    DSU() {};
    DSU(ll n) {
        init(n);
    }

    void init(ll n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0ll);
        sz.assign(n, 1);
    }

    ll leader(ll v) {
        return (v == p[v] ? v : p[v] = leader(p[v]));
    }

    bool unite(ll a, ll b) {
        a = leader(a);
        b = leader(b);
        if (a == b) return 0;
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        sz[a] += sz[b];
        p[b] = a;
        return 1;
    }
    ll size(ll n) {
        return sz[leader(n)];
    }
};

ll num(string s) {
    ll sum = 0;
    reverse(s.begin(), s.end());
    ll j = 1;
    for (ll i = 0; i < s.size(); ++i) {
        sum += j * (s[i] - '0');
        j *= 10;
    }
    return sum;
}
ll ok(vector<pair<ld, ld>> div, ll h, ll c) {
    bool f = 0;
    for (auto e : div) {
        ll AD = e.first + 1, CD = e.second + 1;
        ll BD = h, AC = c;
        ll BC = hypot(CD, BD);
        ll AB = hypot(BD, AD);
        f |= ((AB + BC - AC > 1e18) && (AB + AC - BC > 1e18) && (BC + AC - AB > 1e18));
    }
    return f;
}

void solve() {
    ll n, m, c; cin >> n >> m >> c;
    if (n < m) swap(n, m);
    if (c == n * m) {
        cout << 0 << '\n';
        return;
    }
    else if (c % n == 0 || c % m == 0) {
        cout << 1 << '\n';
        return;
    }
    else if (n == 2 || m == 2 || n * m - c < n) {
        cout << 2 << '\n';
        return;
    }
    vector<ll> div1, div2;
    for (ll i = 1; i * i <= c; ++i) {
        if(c % i == 0) div1.push_back(i);
    }
    ll c1 = n * m - c;
    for (ll i = 1; i * i <= c1; ++i) {
        if (c1 % i == 0) div2.push_back(i);
    }
    for (auto e : div1) {
        ll a = e, b = c / e;
        if (a < b) swap(a, b);
        if (a <= n && b <= m) {
            cout << 2 << '\n';
            return;
        }
    }
    for (auto e : div2) {
        ll a = e, b = c1 / e;
        if (a < b) swap(a, b);
        if (a <= n && b <= m) {
            cout << 2 << '\n';
            return;
        }
    }
    for (ll x = 1; x <= n; ++x) {
        bool f1 = (c - m * x) % (n - 2 * x) == 0;
        bool f2 = ((c - m * (n - x)) % (2 * x - n) == 0);
        if (f1 || f2) {
            cout << 2 << '\n';
            return;
        }
    }
    cout << 3 << '\n';
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    ll tt = 1;
    while (tt--) solve();
}