#include <iostream>
#include <cmath>
using namespace std;

bool areCollinear(int x1, int y1, int x2, int y2, int x3, int y3) {
    return (x2 - x1) * (y3 - y1) == (y2 - y1) * (x3 - x1);
}

pair<pair<int, int>, pair<int, int>> fPoints(int A, int B, int C) {
    if (B != 0) {
        int y1 = -C / B;
        int y2 = -(A + C) / B;
        return {{0, y1}, {1, y2}};
    } else {
        int x1 = -C / A;
        int x2 = -(B + C) / A;
        return {{x1, 0}, {x2, 1}};
    }
}

int main() {
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    if (areCollinear(x1, y1, x2, y2, x3, y3)) {
        cout << x1 << " " << y1 << " " << x2 << " " << y2 << endl;
    } else {
        int A = y2 - y1;
        int B = x1 - x2;
        int C = -(A * x1 + B * y1);

        auto points = fPoints(A, B, C);
        cout << points.first.first << " " << points.first.second << " ";
        cout << points.second.first << " " << points.second.second << endl;
    }

}
