def lazy_cuts(n, m, s):
    # Если количество клеток уже совпадает с суммой, резать не нужно
    if s == n * m:
        return 0

    # Минимальное количество разрезов
    min_cuts = float('inf')

    # Перебираем количество вертикальных разрезов
    for x in range(n + 1):  # x вертикальных разрезов
        for y in range(m + 1):  # y горизонтальных разрезов
            # Вычисляем размеры получившихся частей
            part1 = (x + 1)  # количество вертикальных частей
            part2 = (y + 1)  # количество горизонтальных частей
            
            # Проверяем, подходит ли сумма площадей
            if part1 * part2 == s:
                # Минимизируем количество разрезов
                min_cuts = min(min_cuts, x + y)

    return min_cuts

# Считываем ввод
n, m, s = map(int, input().split())
# Выводим результат
print(lazy_cuts(n, m, s))
