def solve_pipeline(input_line):
    x1, y1, x2, y2, x3, y3 = map(int, input_line.split())
    
    def line_through_points(x1, y1, x2, y2):
        A = y2 - y1
        B = x1 - x2
        C = -(A * x1 + B * y1)
        return A, B, C

    def distance_to_line(A, B, C, x, y):
        return abs(A * x + B * y + C) / ((A**2 + B**2) ** 0.5)

    points = [(x1, y1), (x2, y2), (x3, y3)]
    min_total_distance = float('inf')
    best_line = None

    for i in range(3):
        for j in range(i + 1, 3):
            A, B, C = line_through_points(points[i][0], points[i][1], points[j][0], points[j][1])
            total_distance = sum(
                distance_to_line(A, B, C, points[k][0], points[k][1]) for k in range(3)
            )
            if total_distance < min_total_distance:
                min_total_distance = total_distance
                best_line = (A, B, C)

    A, B, C = best_line

    def find_two_points_on_line(A, B, C):
        if B != 0:
            x1, y1 = 1, -(A * 1 + C) // B
            x2, y2 = 3, -(A * 3 + C) // B
        else:
            x1, y1 = -C // A, 1
            x2, y2 = -C // A, 3
        return (x1, y1), (x2, y2)

    point1, point2 = find_two_points_on_line(A, B, C)

    def clamp(value, limit=10**9):
        return max(-limit, min(limit, value))

    point1 = tuple(clamp(coord) for coord in point1)
    point2 = tuple(clamp(coord) for coord in point2)

    if point1 == point2:
        point2 = (point2[0] + 1, point2[1] + 1)

    return f"{point1[0]} {point1[1]} {point2[0]} {point2[1]}"


# Для ввода данных
input_data = input()
print(solve_pipeline(input_data))
