from collections import defaultdict

def process_queries(n, q, queries):
    degree = defaultdict(lambda: defaultdict(int)) 
    edge_count = defaultdict(int) 
    total_beauty = 0  

    result = []

    is_excellent = defaultdict(lambda: True)
    color_beauty = defaultdict(int)

    for query in queries:
        t, v, u, c = query
        
        if t == "+":
            degree[v][c] += 1
            degree[u][c] += 1
            edge_count[c] += 1

            if degree[v][c] > 1 or degree[u][c] > 1:
                is_excellent[c] = False
            else:
                if is_excellent[c]:
                    color_beauty[c] += 1

        elif t == "-":
            degree[v][c] -= 1
            degree[u][c] -= 1
            edge_count[c] -= 1

            if degree[v][c] > 1 or degree[u][c] > 1:
                is_excellent[c] = False
            else:
                if is_excellent[c]:
                    color_beauty[c] -= 1

        total_beauty = sum(color_beauty[c] for c in color_beauty if is_excellent[c])
        result.append(str(total_beauty))

    print("\n".join(result))

n, q = map(int, input().split())  
queries = []
for _ in range(q):
    t, v, u, c = input().split()
    queries.append((t, int(v), int(u), int(c)))

process_queries(n, q, queries)
