#include <bits/stdc++.h>

#define int long long
#define yes cout << "YES"
#define no cout << "NO"
#define fi first
#define se second

using namespace std;

typedef pair<int, int> Position;

const int BOARD_SIZE = 8;

bool isValid(int x, int y) {
    return x >= 1 && x <= BOARD_SIZE && y >= 1 && y <= BOARD_SIZE;
}

string toChessNotation(Position pos) {
    char file = 'a' + pos.first - 1;
    char rank = '0' + pos.second;
    return string(1, file) + rank;
}

void solve()
{
    vector<Position> ip;

    for (int x = 1; x <= BOARD_SIZE; x++)
    {
        for (int y = 1; y <= BOARD_SIZE; y++)
        {
            ip.push_back({x, y});
        }
    }

    int max_moves = 7;

    map<Position, Position> pm;

    for (auto pos : ip)
    {
        pm[pos] = pos;
    }

    for (int move_num = 0; move_num < max_moves; ++move_num)
    {
        if (pm.size() == 1)
        {
            break;
        }

        vector<pair<int, int>> moves;
        for (int len = 1; len <= 7; len++)
        {
            for (int dx : {-len, len})
            {
                int dy = dx;
                moves.push_back({dx, dy});
                moves.push_back({dx, -dy});
            }
        }

        int best_max_size = BOARD_SIZE * BOARD_SIZE;
        pair<int, int> best_move = {0, 0};

        for (auto move : moves)
        {
            int dx = move.first;
            int dy = move.second;

            int plus_count = 0;
            int minus_count = 0;

            for (auto& entry : pm)
            {
                Position current_pos = entry.second;
                int x = current_pos.first;
                int y = current_pos.second;
                int nx = x + dx;
                int ny = y + dy;

                if (isValid(nx, ny))
                {
                    plus_count++;
                }
                else
                {
                    minus_count++;
                }
            }

            int max_size = max(plus_count, minus_count);

            if (max_size < best_max_size)
            {
                best_max_size = max_size;
                best_move = move;
            }
        }

        int dx = best_move.first;
        int dy = best_move.second;

        cout << "? " << dx << " " << dy << endl;
        cout.flush();

        string response;
        cin >> response;

        map<Position, Position> new_pm;

        for (auto& entry : pm) {
            Position initial_pos = entry.first;
            Position current_pos = entry.second;
            int x = current_pos.first;
            int y = current_pos.second;
            int nx = x + dx;
            int ny = y + dy;

            if (response == "+") {
                if (isValid(nx, ny)) {
                    new_pm[initial_pos] = {nx, ny};
                }
            } else {
                if (!isValid(nx, ny)) {
                    new_pm[initial_pos] = current_pos;
                }
            }
        }

        pm = new_pm;
    }

    if (pm.size() == 1) {
        Position final_initial_pos = pm.begin()->first;
        cout << "! " << toChessNotation(final_initial_pos) << endl;
        cout.flush();
    } else {
        cout << "! a1" << endl;
        cout.flush();
    }
}

main()
{
    int t = 1;
    //cin >> t;
    while(t--)
    {
        solve();
        cout << '\n';
    }
}
