﻿#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

ld dist(ld x0, ld y0, ld x1, ld y1) {
	return sqrtl((x0 - x1) * (x0 - x1) + (y0 - y1) * (y0 - y1));
}

ld eps = 1e-12;

ld sq(ld x) { return x * x; }

ld dist(ld x, ld y, ld a, ld b, ld c) {
	return abs(a * x + b * y + c) / sqrtl(sq(a) + sq(b));
}

bool on(ld x, ld y, ld a, ld b, ld c) {
	return (a * x + b * y + c) <= 1e-5;
}

pair<ld, ld> get_scaled(ld a, ld b, ld c, ld x) {
	ld d = dist(0, 0, a, b);
	return { a * x / d, b * x / d };
}

pair<ld, ld> intersect(ld x0, ld y0, ld r0, ld x1, ld y1, ld r1) {
	if (r0 == 0) return { x0, y0 };
	if (r1 == 0) return { x1, y1 };
	ld a = (2 * x1 - 2 * x0), b = 2 * (y1 - y0), c = sq(x0) - sq(x1) + sq(y0) - sq(y1) - sq(r0) + sq(r1);
	ld d = dist(x0, y0, a, b, c);
	auto [nx, ny] = get_scaled(a, b, c, d);
	auto [dx, dy] = get_scaled(-b, a, c, sqrtl(sq(r0) - sq(d)));
	if (on(x0 + nx, y0 + ny, a, b, c)) return { x0 + nx + dx, y0 + ny + dy };
	else return { x0 - nx + dx, y0 - ny + dy };
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout.precision(64);
	ld x0, y0, x1, y1; cin >> x0 >> y0 >> x1 >> y1;
	int n; cin >> n;
	ld d = dist(x0, y0, x1, y1);
	vector<ld> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	ld sum = accumulate(a.begin(), a.end(), ld(0)), s1 = 0;
	for (int i = 0; i <= n; i++) {
		ld arr[3]{ d, s1, sum - s1 };
		sort(arr, arr + 3);
		if (arr[2] < arr[1] + arr[0] + eps) {
			cout << "Possible\n";
			auto [x2, y2] = intersect(x0, y0, s1, x1, y1, sum - s1);
			for (int j = 0; j < i; j++) {
				x0 = x0 + a[j] / s1 * (x2 - x0); y0 = y0 + a[j] / s1 * (y2 - y0);
				s1 -= a[j];
				sum -= a[j];
				cout << x0 << ' ' << y0 << '\n';
			}
			for (int j = i; j < n; j++) {
				x2 = x2 + a[j] / sum * (x1 - x2); y2 = y2 + a[j] / sum * (y1 - y2);
				sum -= a[j];
				cout << x2 << ' ' << y2 << '\n';
			}
			return 0;
		}
		if (i != n) s1 += a[i];
	}

	cout << "Impossible";

	return 0;
}