# Задача D. Ленивые разрезы

def min_cuts(n, m, s):
    if s == n * m:
        return 0

    min_cuts = float('inf')

    # Перебираем количество вертикальных разрезов x (от 0 до n - 1)
    for x in range(n):
        # Перебираем количество горизонтальных разрезов y (от 0 до m - 1)
        for y in range(m):

            areas = []
            for i in range(x + 1):
                for j in range(y + 1):
                    width = m // (y + 1) if j < y else m - (m // (y + 1)) * y
                    height = n // (x + 1) if i < x else n - (n // (x + 1)) * x
                    areas.append(width * height)
            
            # Проверяем, можно ли из этих площадей составить s
            if subset_sum_possible(areas, s):
                min_cuts = min(min_cuts, x + y)
    
    return min_cuts


def subset_sum_possible(areas, target):
    dp = [False] * (target + 1)
    dp[0] = True

    for area in areas:
        for t in range(target, area - 1, -1):
            dp[t] = dp[t] or dp[t - area]
    
    return dp[target]

n, m, s = map(int, input().split())
print(min_cuts(n, m, s))