# M task (Три точки)

from itertools import combinations

def solve_three_points(houses):
    (x1, y1, x2, y2, x3, y3) = houses

    points = [(x1, y1), (x2, y2), (x3, y3)]

    min_distance_sum = float('inf')
    best_line_coefficients = None
    
    for (p1, p2) in combinations(points, 2):
        (x1, y1), (x2, y2) = p1, p2
        
        # Уравнение прямой: ax + by + c = 0
        a = y2 - y1
        b = x1 - x2
        c = x2 * y1 - x1 * y2

        distance_sum = 0
        for (px, py) in points:
            distance_sum += abs(a * px + b * py + c) / (a**2 + b**2)**0.5

        if distance_sum < min_distance_sum:
            min_distance_sum = distance_sum
            best_line_coefficients = (a, b, c)
    
    a, b, c = best_line_coefficients
    
    x1_new = 1
    y1_new = -(a * x1_new + c) // b if b != 0 else 0  # Находим y по уравнению прямой
    
    x2_new = 3
    y2_new = -(a * x2_new + c) // b if b != 0 else 0  # Находим y по уравнению прямой
    
    return (x1_new, y1_new, x2_new, y2_new)

input_data = input("Введите координаты точек (x1 y1 x2 y2 x3 y3): ")
x1, y1, x2, y2, x3, y3 = map(int, input_data.split())

result = solve_three_points((x1, y1, x2, y2, x3, y3))
print(f"{result[0]} {result[1]} {result[2]} {result[3]}")