from collections import defaultdict

def process_queries(n, q, queries):
    edges_by_color = defaultdict(set)
    degree_by_color = defaultdict(int)
    total_beauty = 0

    excellent_colors = set()


    results = []

    for query in queries:
        op, v, u, c = query
        if op == '+': 
            edges_by_color[c].add((v, u))
            for vertex in (v, u):
                degree_by_color[(c, vertex)] += 1
                if degree_by_color[(c, vertex)] == 2:
                    if c in excellent_colors:
                        total_beauty -= len(edges_by_color[c])
                        excellent_colors.remove(c)

            if c not in excellent_colors and all(degree_by_color[(c, vertex)] <= 1 for vertex in (v, u)):
                excellent_colors.add(c)
                total_beauty += len(edges_by_color[c])

        elif op == '-':  
            edges_by_color[c].remove((v, u))
            for vertex in (v, u):
                degree_by_color[(c, vertex)] -= 1
                if degree_by_color[(c, vertex)] == 1:
                    if c not in excellent_colors:
                        excellent_colors.add(c)
                        total_beauty += len(edges_by_color[c])

            if not edges_by_color[c]:
                if c in excellent_colors:
                    total_beauty -= len(edges_by_color[c])
                    excellent_colors.remove(c)

        results.append(total_beauty)

    return results


n, q = map(int, input().split())
queries = [input().split() for _ in range(q)]
queries = [(op, int(v), int(u), int(c)) for op, v, u, c in queries]

results = process_queries(n, q, queries)

print('\n'.join(map(str, results)))
