import heapq

def minimum_time_to_moscow(n, m, c, gas_stations):
    gas_stations.append((m, 0))
    gas_stations.sort()
    min_heap = []
    current_fuel = c
    current_position = 0
    total_time = 0.0

    for position, refuel_time in gas_stations:
        distance = position - current_position
        while current_fuel < distance:
            if not min_heap:
                return -1.0
            current_fuel += c
            total_time += heapq.heappop(min_heap)
        current_fuel -= distance
        current_position = position
        heapq.heappush(min_heap, refuel_time)

    return total_time

n, m, c = map(int, input().split())
gas_stations = [tuple(map(int, input().split())) for _ in range(n)]
result = minimum_time_to_moscow(n, m, c, gas_stations)
print(f"{result:.10f}" if result != -1 else -1)