#include <iostream>
#include <cmath>
#include <tuple>

using namespace std;

double calculate_distance(int x1, int y1, int x2, int y2) {
    return sqrt(pow(x2 - x1, 2) + pow(y2 - y1, 2));
}


tuple<int, int, int, int> find_max_distance(int x1, int y1, int x2, int y2, int x3, int y3) {
    double max_dist = 0;
    tuple<int, int, int, int> result;

    double dist_12 = calculate_distance(x1, y1, x2, y2);
    if (dist_12 > max_dist) {
        max_dist = dist_12;
        result = make_tuple(x1, y1, x2, y2);
    }
    double dist_13 = calculate_distance(x1, y1, x3, y3);
    if (dist_13 > max_dist) {
        max_dist = dist_13;
        result = make_tuple(x1, y1, x3, y3);
    }
    double dist_23 = calculate_distance(x2, y2, x3, y3);
    if (dist_23 > max_dist) {
        max_dist = dist_23;
        result = make_tuple(x2, y2, x3, y3);
    }

    return result;
}

int main() {
    int x1, y1, x2, y2, x3, y3;

    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    auto [x_start, y_start, x_end, y_end] = find_max_distance(x1, y1, x2, y2, x3, y3);

    cout << x_start << " " << y_start << " " << x_end << " " << y_end << endl;

    return 0;
}
