#include <bits/stdc++.h>
 
using namespace std;
#define ll long long
#define ull unsigned long long
#define ld long double
struct node {
    long double x, y;
};

const ld eps = 1e-6;
ld dist(ld a1, ld b1, ld a2, ld b2) {
    return sqrt((a1 - a2) * (a1 - a2) + (b1 - b2) * (b1 - b2));
}

struct ver {
    ld x, y;
    ld len() {
        return sqrt(x*x + y*y);
    }
    ver norm() {
        return {x / len(), y / len()};
    }
    ld operator*(ver b) {
        return x * b.x + y * b.y;
    }
    ver operator*(ld f) {
        return {x*f, y*f};
    }
    ver operator+(ver b) {
        return {x+b.x, y+b.y};
    }
    ld operator%(ver b) {
        return x*b.y - y*b.x;
    }
};

bool have(ld a1, ld b1, ld a2, ld b2, ld r1, ld r2) {
    ld d = dist(a1, b1, a2, b2);
    if (r1 + r2 + eps < d) return false;
    if (d + r1 + eps < r2) return false;
    if (d + r2 + eps < r1) return false;
    return true;
}
node tochper(ld a1, ld b1, ld a2, ld b2, ld r1, ld r2) {
    ld d = dist(a1, b1, a2, b2);
    if (abs(r1 + r2 - d) <= eps) {
        ver t = {a2 - a1, b2 - b1};
        ver c = t.norm();
        ver g = c*r1;
        return {a1 + g.x, b1 + g.y};
    }
    if(abs(r1 + d - r2) <= eps) {
        ver t = {a1 - a2, b1 - b2};
        ver c = t.norm();
        ver g = c*r2;
        return {a2 + g.x, b2 + g.y};
    }
    if(abs(r2 + d - r1) <= eps) {
        ver t = {a2 - a1, b2 - b1};
        ver c = t.norm();
        ver g = c*r1;
        return {a1 + g.x, b1 + g.y};
    }

    ver t = {a2 - a1, b2 - b1};
    t = t.norm();
    t = t * r1;
    ld cs = (r2*r2 - r1*r1 - d*d) / (-2.*r1*d);
    ld sn = sqrt(1. - cs*cs);
    ver p = {t.x * cs - t.y * sn, t.y * cs + t.x * sn};
    return {a1 + p.x, b1 + p.y};
}

void solve() {
    //cout << fixed << setprecision(1);
    ld x0, y0, x1, y1;
    cin >> x0 >> y0 >> x1 >> y1;
    ll n;
    cin >> n;
    vector<ld> a(n);
    ld sum = 0;
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        sum += a[i];
    }
    ld ns = 0;
    for(int i = 0; i < n; ++i) {
        ns += a[i];
        if (!have(x0, y0, x1, y1, ns, sum - ns)) {
            continue;
        }
        //cout << i << ":";
        vector<ver> anss;
        node ans = tochper(x0, y0, x1, y1, ns, sum - ns);
        //cout << ans.x << ' ' << ans.y << '\n';
        ver ft = {ans.x - x0, ans.y - y0};
        ver f = ft.norm();
        ver cur = {x0, y0};
        for(int j = 0; j<=i; ++j) {
            cur = cur + (f * a[j]);
            anss.push_back(cur);
        }
        ver st = {x1 - cur.x, y1 - cur.y};
        ver s = st.norm();
        for(int j = i+1; j<n; ++j) {
            cur = cur + (s * a[j]);
            anss.push_back(cur);
        }
        if(abs(cur.x - x1) > eps || abs(cur.y - y1) > eps) while(true);
        cout << "Possible\n";
        for(auto [x, y] : anss) {
            cout << x << ' ' << y << '\n';
        } 
        return;
    }
    cout << "Impossible\n";
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(6);
    solve();
}