import heapq

def minimum_time(n, m, c, stations):
    # Добавим начальную и конечную точку
    stations = [(0, 0)] + stations + [(m, 0)]
    
    # Массив для времени достижения каждой точки
    time_to_reach = [float('inf')] * (n + 2)
    time_to_reach[0] = 0  # Начальная точка (Санкт-Петербург)
    
    # Очередь с приоритетом для минимизации времени
    pq = [(0, 0)]  # (время, индекс станции)
    
    while pq:
        current_time, i = heapq.heappop(pq)
        
        if current_time > time_to_reach[i]:
            continue
        
        # Пробуем добраться от станции i до всех последующих станций
        for j in range(i + 1, n + 2):
            # Расстояние между станциями i и j
            distance = stations[j][0] - stations[i][0]
            if distance > c:
                break  # Если не хватает топлива для прямого пути, пропускаем
            
            # Время для движения между станциями i и j с максимальной скоростью
            travel_time = distance / c
            # Время на заправке
            refuel_time = stations[j][1]
            
            # Общее время до станции j
            new_time = current_time + travel_time + refuel_time
            
            # Если нашли лучшее время для станции j
            if new_time < time_to_reach[j]:
                time_to_reach[j] = new_time
                heapq.heappush(pq, (new_time, j))
    
    return time_to_reach[n + 1]

# Пример использования:
n, m, c = 4, 100, 25
stations = [(10, 50), (15, 30), (50, 100), (80, 60)]
print(f"{minimum_time(n, m, c, stations):.6f}")
