from collections import defaultdict

def solve():
    # Ввод
    n, q = map(int, input().split())  # n - количество вершин, q - количество запросов
    queries = [input().strip().split() for _ in range(q)]
    
    # Словари для учета рёбер и инцидентности
    edge_count = defaultdict(int)  # Счетчик рёбер для каждого цвета
    vertex_color_count = defaultdict(lambda: defaultdict(int))  # Сколько рёбер для каждой вершины и цвета
    total_beauty = 0  # Суммарная красота превосходных цветов
    color_valid = defaultdict(lambda: True)  # Для каждого цвета, является ли он превосходным

    # Функция для пересчета красоты (суммы рёбер для превосходных цветов)
    def recalculate_total_beauty():
        nonlocal total_beauty
        total_beauty = 0
        # Суммируем количество рёбер для каждого превосходного цвета
        for color in edge_count:
            if color_valid[color]:
                total_beauty += edge_count[color]
    
    # Обработка запросов
    for query in queries:
        q_type, v, u, c = query
        v, u, c = int(v), int(u), int(c)
        
        if q_type == '+':
            # Добавление ребра
            edge_count[c] += 1
            vertex_color_count[v][c] += 1
            vertex_color_count[u][c] += 1
            
            # Проверка, нарушается ли превосходство для этого цвета
            if vertex_color_count[v][c] > 1 or vertex_color_count[u][c] > 1:
                if color_valid[c]:
                    color_valid[c] = False

        elif q_type == '-':
            # Удаление ребра
            edge_count[c] -= 1
            vertex_color_count[v][c] -= 1
            vertex_color_count[u][c] -= 1
            
            # Проверка, может ли цвет снова стать превосходным
            if vertex_color_count[v][c] == 0 and vertex_color_count[u][c] == 0:
                if edge_count[c] > 0:
                    # Если цвет снова может стать превосходным
                    color_valid[c] = True
            
        # Пересчитываем суммарную красоту после каждого запроса
        recalculate_total_beauty()
        
        # Выводим результат
        print(total_beauty)

# Вызов функции
solve()

