def is_within_board(file, rank):
    return 'a' <= file <= 'h' and '1' <= rank <= '8'

def move_bishop(position, x, y):
    file, rank = position
    new_file = chr(ord(file) + x)
    new_rank = chr(ord(rank) + y)
    if is_within_board(new_file, new_rank):
        return f"{new_file}{new_rank}", True
    return position, False

if __name__ == "__main__":
    initial_position = "e7"
    current_position = initial_position
    
    while True:
        request = input().strip()
        if request.startswith('?'):
            _, x, y = request.split()
            x, y = int(x), int(y)
            new_position, success = move_bishop(current_position, x, y)
            if success:
                current_position = new_position
                print("+")
            else:
                print("-")
        elif request.startswith('!'):
            _, pos = request.split()
            if pos == initial_position:
                print("Correct! Initial position was:", initial_position)
            else:
                print("Incorrect. Initial position was:", initial_position)
            break
