# Чтение входных данных
n, m, S = map(int, input().split())

# Огромное значение для обозначения невозможного результата
INF = 10**9

# Таблица для хранения минимального количества разрезов
dp = {}

# Основной цикл для нахождения минимального числа разрезов
def min_cuts(n, m, S):
    # Проверяем, можем ли получить нужную площадь
    if n * m < S: 
        return INF  # Невозможно получить S из листа меньшей площади
    if n * m == S: 
        return 0  # Не нужно резать

    # Проверяем, есть ли уже рассчитанный результат
    if (n, m, S) in dp:
        return dp[(n, m, S)]

    # Ищем минимальное количество разрезов
    min_cuts_result = INF

    # Горизонтальные разрезы
    for cut in range(1, n):
        upper = cut * m
        lower = (n - cut) * m

        if upper >= S:
            min_cuts_result = min(min_cuts_result, 1 + min_cuts(cut, m, S))
        if lower >= S:
            min_cuts_result = min(min_cuts_result, 1 + min_cuts(n - cut, m, S))
        if upper < S and lower < S:
            min_cuts_result = min(
                min_cuts_result,
                1 + min_cuts(cut, m, upper) + min_cuts(n - cut, m, S - upper)
            )

    # Вертикальные разрезы
    for cut in range(1, m):
        left = cut * n
        right = (m - cut) * n

        if left >= S:
            min_cuts_result = min(min_cuts_result, 1 + min_cuts(n, cut, S))
        if right >= S:
            min_cuts_result = min(min_cuts_result, 1 + min_cuts(n, m - cut, S))
        if left < S and right < S:
            min_cuts_result = min(
                min_cuts_result,
                1 + min_cuts(n, cut, left) + min_cuts(n, m - cut, S - left)
            )

    # Сохраняем результат в таблицу
    dp[(n, m, S)] = min_cuts_result
    return min_cuts_result


# Запуск алгоритма
result = min_cuts(n, m, S)
print(result if result != INF else -1)