def find_path(graph, start, end, path=[]):
    """
    Рекурсивная функция поиска пути от точки start до end в графе.
    """
    path = path + [start]
    if start == end:
        return path
    for node in graph[start]:
        if node not in path:
            new_path = find_path(graph, node, end, path)
            if new_path:
                return new_path
    return None


def main():
    # Пример входных данных
    adjacency_matrix = [
        [0, 1, 1],
        [1, 0, 1],
        [1, 1, 0]
    ]
    start_point = 0  # Начальная точка (0 соответствует точке 1)
    end_point = 2    # Конечная точка (2 соответствует точке 3)

    # Преобразуем матрицу смежности в список смежности
    graph = {i: [] for i in range(len(adjacency_matrix))}
    for i in range(len(adjacency_matrix)):
        for j in range(len(adjacency_matrix[i])):
            if adjacency_matrix[i][j] == 1:
                graph[i].append(j)

    # Поиск пути
    path = find_path(graph, start_point, end_point)
    n, m, s = map(int, input().split())

    sum = 0
    k1 = 0  # разрез
    k2 = 0

    # 2
    if n * m == s:
        print(0)

    # 3
    else:
        if (n * m) - s >= (n * m) / 2:
            print(1)
        else:
            # Вертикальный
            for i in range(m):
                sum += n
                if sum > s:
                    # print('sumV > s')
                    k1 += 2
                    sum = 0
                    break
                elif sum == s:
                    # print('sumV == S')
                    k1 += 1
                    sum = 0
                    break

            # Горизонтальный
            for i in range(n):
                sum += m
                if sum > s:
                    # print('sumG > s')
                    k2 += 2
                    break
                elif sum == s:
                    # print('sumG == S')
                    k2 += 1
                    break

            if k1 > k2:
                print(k2)
            else:
                print(k1)