def min_cuts(n, m, s):

    min_cuts = float('inf')  # Минимальное количество разрезов

    # Перебираем количество вертикальных разрезов (x)
    for x in range(n):
        # Перебираем количество горизонтальных разрезов (y)
        for y in range(m):
            # Получаем размеры всех прямоугольников
            widths = [m // (x + 1)] * (x + 1)
            heights = [n // (y + 1)] * (y + 1)

            # Учитываем остатки (если разрезы не равномерны)
            for i in range(m % (x + 1)):
                widths[i] += 1
            for i in range(n % (y + 1)):
                heights[i] += 1

            # Все возможные площади прямоугольников
            areas = [w * h for w in widths for h in heights]

            # Проверяем, можно ли из них набрать ровно s
            if can_form_sum(areas, s):
                min_cuts = min(min_cuts, x + y)

    return min_cuts if min_cuts != float('inf') else -1

def can_form_sum(areas, target):
    dp = [False] * (target + 1)
    dp[0] = True  # Сумму 0 можно всегда набрать (пустой набор)

    for area in areas:
        for t in range(target, area - 1, -1):
            dp[t] = dp[t] or dp[t - area]

    return dp[target]


# Главная программа
if __name__ == "__main__":
    n,m,s = map(int,input().split())

    # Вызываем функцию и выводим результат
    result = min_cuts(n, m, s)
    if result != -1:
        print(result)

