import math

# Ввод данных
x0, y0 = map(int, input().split())
x1, y1 = map(int, input().split())
n = int(input())
a = list(map(int, input().split()))

# Функция для проверки возможности прыжка длиной d из точки (x, y) в точку (nx, ny)
def can_jump(x, y, nx, ny, d):
    return abs(math.sqrt((nx - x) * 2 + (ny - y) * 2) - d) <= 1e-4

# Функция для поиска пути
def find_path(x0, y0, x1, y1, a):
    path = [(x0, y0)]
    current_x, current_y = x0, y0

    for length in a:
        found = False
        # Ищем точку (nx, ny), которая находится на расстоянии length от текущей
        for angle in range(0, 360):
            rad = math.radians(angle)
            nx = current_x + length * math.cos(rad)
            ny = current_y + length * math.sin(rad)

            if can_jump(current_x, current_y, nx, ny, length):
                path.append((nx, ny))
                current_x, current_y = nx, ny
                found = True
                break

        if not found:
            return "Impossible"

    # Проверяем достижение конечной точки
    if not can_jump(current_x, current_y, x1, y1, a[-1]):
        return "Impossible"

    path.append((x1, y1))
    return path

# Поиск пути
result = find_path(x0, y0, x1, y1, a)

# Вывод результата
if result == "Impossible":
    print("Impossible")
else:
    print("Possible")
    for x, y in result:
        print(f"{x:.6f} {y:.6f}")