def galactic_timeline(n, a, b):
    cards = [(a[i], b[i]) for i in range(n)]

    cards.sort(key=lambda x: min(x))

    result_a = []
    result_b = []
    prev_a = prev_b = -1

    for ai, bi in cards:
        if ai >= prev_a and bi >= prev_b:
            result_a.append(ai)
            result_b.append(bi)
            prev_a, prev_b = ai, bi
        elif bi >= prev_a and ai >= prev_b:
            result_a.append(bi)
            result_b.append(ai)
            prev_a, prev_b = bi, ai
        else:
            return -1

    return result_a, result_b

n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

result = galactic_timeline(n, a, b)
if result == -1:
    print(result)
else:
    print(" ".join(map(str, result[0])))
    print(" ".join(map(str, result[1])))