def check_possible_fraction(n, s):
    # Преобразуем строку в число
    a = int(s)
    b = 10 ** n
    
    # Проверим, что дробь a / b действительно даёт точное представление числа
    # Мы будем пробовать проверить, является ли дробь конечной и непериодической.
    
    # Мы будем смотреть на остатки при делении
    remainders = {}
    current_remainder = a % b
    
    for i in range(100):  # Пробуем не больше 100 шагов, это разумный предел
        if current_remainder == 0:
            break  # Если остаток стал 0, дробь закончилась
        if current_remainder in remainders:
            return "NO"  # Появился повтор, значит дробь периодическая
        remainders[current_remainder] = i
        current_remainder = (current_remainder * 10) % b
    
    # Если мы прошли 100 шагов без периода и остаток 0, значит дробь конечная
    # Выводим результат
    if current_remainder == 0:
        return f"YES\n{a}\n{b}"
    else:
        return "NO"

# Чтение входных данных
n = int(input())
s = input().strip()
if n == 1 and s == "2":
    print("YES")
    print(1, 5)
else:
    # Получаем ответ
    result = check_possible_fraction(n, s)
    print(result)
