import heapq

def solve(n, m, c, stations):
    
    stations.insert(0, (0, 0)) 
    stations.append((m, 0))  

    
    dp = [float('inf')] * (n + 2)
    dp[0] = 0  
    
    
    pq = [(0, 0)] 
    
    while pq:
        time, idx = heapq.heappop(pq)
        
        
        if time > dp[idx]:
            continue
        
        
        for j in range(idx + 1, n + 2):
            x1, t1 = stations[idx]
            x2, t2 = stations[j]
            
            
            dist = x2 - x1
            
            
            if dist <= c:
                
                travel_time = dist  
                total_time = time + travel_time + t2 
                if total_time < dp[j]:
                    dp[j] = total_time
                    heapq.heappush(pq, (total_time, j))

    return dp[n + 1]

n, m, c = map(int, input().split())
stations = [tuple(map(int, input().split())) for _ in range(n)]

result = solve(n, m, c, stations)
print(f"{result:.6f}")
