#include<bits/stdc++.h>

using type = _Float128;

constexpr type EPS = 0;

std::pair<bool, std::pair<type, type>> line_with_circle(type a, type b, type c, type x, type y, type r) {
	type d = std::abs(a * x + b * y + c) / sqrtl(a * a + b * b);
	if (r * r < d * d - EPS) return {false, {0, 0}};
	type dx = -a, dy = -b;
	if (a * x + b * y + c < 0) dx = -dx, dy = -dy;
	type coef = d / sqrtl(dx * dx + dy * dy);
	dx *= coef, dy *= coef;
	x += dx, y += dy;
	dx = -b, dy = a;
	type l = sqrtl(r * r - d * d);
	coef = l / sqrtl(dx * dx + dy * dy);
	dx *= coef, dy *= coef;
	x += dx, y += dy;
	return {true, {x, y}};
}

std::pair<bool, std::pair<type, type>> circle_with_circle(type x1, type y1, type d1, type x2, type y2, type d2) {
	if (std::abs((d1 + d2) * (d1 + d2) - ((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2))) <= EPS) {
		return {true, {(x1 * d2 + x2 * d1) / (d1 + d2), (y1 * d2 + y2 * d1) / (d1 + d2)}};
	}
	type a = 2 * (x2 - x1), b = 2 * (y2 - y1);
	type c = d2 * d2 - d1 * d1 - (x2 - x1) * (x1 + x2) - (y2 - y1) * (y1 + y2);
	return line_with_circle(a, b, c, x1, y1, d1);
}

std::istream& operator>>(std::istream& in, _Float128& a) {
	double b;
	in >> b;
	a = b;
	return in;
}

std::ostream& operator<<(std::ostream& out, _Float128 a) {
	double b = a;
	out << b;
	return out;
} 

int main() {
	std::cin.tie(nullptr)->sync_with_stdio(false);

	type x0, y0, x1, y1;
	std::cin >> x0 >> y0 >> x1 >> y1;
	type d = sqrt((x0 - x1) * (x0 - x1) + (y0 - y1) * (y0 - y1));
	int n;
	std::cin >> n;
	std::vector<type> a(n);
	for (auto& i : a) {
		int x;
		std::cin >> x;
		i = x;
	}
	std::vector<type> out(n), in(n);
	out[0] = a[0], in[0] = a[0];
	for (int i = 1; i < n; ++i) {
		out[i] = out[i - 1] + a[i];
		in[i] = std::max<type>(0, in[i] - a[i]);
	}
	if (in[n - 1] <= d && d <= out[n - 1]) {
		std::cout << "Possible\n";
		std::vector<std::pair<type, type>> ret = {{x1, y1}};
		for (int i = n - 1; i > 0; --i) {
			auto [f2, xy2] = circle_with_circle(x0, y0, in[i - 1], x1, y1, a[i]);
			auto [f3, xy3] = circle_with_circle(x0, y0, out[i - 1], x1, y1, a[i]);
			auto [x2, y2] = xy2;
			auto [x3, y3] = xy3;
			if (!f2 && !f3) {
				x1 += a[i];
			} else if (f2) {
				x1 = x2, y1 = y2;
			} else {
				x1 = x3, y1 = y3;
			}
			ret.emplace_back(x1, y1);
		}
		std::reverse(ret.begin(), ret.end());
		std::cout << std::fixed << std::setprecision(15);
		for (auto [x, y] : ret) std::cout << x << ' ' << y << '\n';
	} else {
		std::cout << "Impossible\n";
	}
}