#include<bits/stdc++.h>

using ll = int64_t;

ll mod = (1ll << 61) - 1;

ll add(ll a, ll b) {
	return a + b >= mod ? a + b - mod : a + b;
}
ll sub(ll a, ll b) {
	return a >= b ? a - b : a + mod - b;
}
ll mul(ll a, ll b) {
	return 1ll * a * b % mod;
}

ll base = 10;

struct hashing {
	std::vector<ll> pref, pw;

	hashing() = default;
	hashing(std::vector<int> a) {
		int n = a.size();
		pref.assign(n + 1, 0);
		pw.assign(n + 1, 1);
		for (int i = 0; i < n; ++i) {
			pref[i + 1] = add(mul(pref[i], base), a[i] + 1);
			pw[i + 1] = mul(pw[i], base);
		}
	}

	ll get(int l, int r) {
		return sub(pref[r + 1], mul(pref[l], pw[r - l + 1]));
	}
};

bool ckmin(int& a, int b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

signed main() {
	std::cin.tie(nullptr)->sync_with_stdio(false);

	int tests;
	std::cin >> tests;
	while (tests--) {
		int n, m, k;
		std::cin >> n >> m >> k;
		std::vector<int> p(n);
		std::vector<int> pos(n);
		for (int i = 0; i < n; ++i) {
			std::cin >> p[i];
			pos[--p[i]] = i;
		}
		std::vector<int> a(m);
		for (auto& i : a) std::cin >> i, --i;
		std::vector<std::vector<int>> start(n), end(n);
		std::vector<int> l(k), r(k);
		for (int i = 0; i < k; ++i) {
			std::cin >> l[i] >> r[i];
			--l[i], --r[i];
			start[pos[a[l[i]]]].push_back(i);
			end[pos[a[r[i]]]].push_back(i);
		}
		hashing ha(a), hp(p);
		std::vector<int> pref(n + 1, n + 1), par_pref(n + 1, -1), suf(n + 1, n + 1), par_suf(n + 1, -1);
		pref[0] = 0;
		for (int i = 0; i < n; ++i) {
			for (auto id : start[i]) {
				int j = i + r[id] - l[id];
				if (j < p.size() && hp.get(i, j) == ha.get(l[id], r[id])) {
					if (ckmin(pref[j + 1], pref[i] + 1)) par_pref[j + 1] = id;
				}
			}
		}
		suf[n] = 0;
		for (int i = n - 1; i >= 0; --i) {
			for (auto id : end[i]) {
				int j = i - (r[id] - l[id]);
				if (j >= 0 && hp.get(j, i) == ha.get(l[id], r[id])) {
					if (ckmin(suf[j], suf[i + 1] + 1)) par_suf[j] = id;
				}
			}
		}
		std::vector<int> sufmn(n + 1), prefmn(n + 1);
		std::vector<std::pair<int, int>> par_sufmn(n + 1, {-1, -1}), par_prefmn(n + 1, {-1, -1});
		prefmn = pref;
		sufmn = suf;
		for (int i = 0; i < n; ++i) {
			for (auto id : start[i]) {
				int L = -1, R = n;
				while (L != R) {
					int M = (L + R + 2) / 2;
					if (i + M < n && l[id] + M <= r[id] && hp.get(i, i + M) == ha.get(l[id], l[id] + M)) L = M;
					else R = M - 1;
				}
				int d = L + 1;
				if (ckmin(prefmn[i + d], pref[i] + 1)) par_prefmn[i + d] = {id, i};
			}
		}
		for (int i = 0; i < n; ++i) {
			for (auto id : end[i]) {
				int L = -1, R = n;
				while (L != R) {
					int M = (L + R + 2) / 2;
					if (i - M >= 0 && r[id] - M >= l[id] && hp.get(i - M, i) == ha.get(r[id] - M, r[id])) L = M;
					else R = M - 1;
				}
				int d = L + 1;
				if (ckmin(sufmn[i + 1 - d], suf[i + 1] + 1)) par_sufmn[i + 1 - d] = {id, i + 1};
			}
		}
		for (int i = n; i; --i) {
			if (ckmin(prefmn[i - 1], prefmn[i])) par_prefmn[i - 1] = par_prefmn[i];
		}
		for (int i = 1; i <= n; ++i) {
			if (ckmin(sufmn[i], sufmn[i - 1])) par_sufmn[i] = par_sufmn[i - 1];
		}
		int ans = n + 1;
		int opt = -1;
		for (int i = 0; i <= n; ++i) {
			if (ckmin(ans, prefmn[i] + sufmn[i])) opt = i;
		}
		if (ans > n) {
			std::cout << "-1\n";
		} else {
			std::cout << ans << '\n';
			std::vector<int> ret;
			int i = opt;
			if (par_prefmn[i].first != -1) {
				ret.push_back(par_prefmn[i].first);
				i = par_prefmn[i].second;
			}
			for (; i > 0; ) {
				ret.push_back(par_pref[i]);
				i -= r[ret.back()] - l[ret.back()] + 1;
			}
			std::reverse(ret.begin(), ret.end());
			i = opt;
			if (par_sufmn[i].first != -1) {
				ret.push_back(par_sufmn[i].first);
				i = par_sufmn[i].second;
			}
			for (; i < n; ) {
				ret.push_back(par_suf[i]);
				i += r[ret.back()] - l[ret.back()] + 1;
			}
			for (auto x : ret) std::cout << x + 1 << ' ';
			std::cout << '\n';
		}
	}
}